#!/usr/bin/python
#######################################################################################
# Keep the best aligned read for multiple aligned reads and remove others.
#######################################################################################
import string
import sys
import operator

genome = ""
read_len = 0
n_snp = 0
n_match = 0
left_match = 0
right_match = 0
abnormal_isize_0 = 0
abnormal_isize_1 = 0	
bound_len_thresh = 0

SOFT_CLIPPING = 3
UNMAPPED = 5
class split_read:
	def __init__(self):
		self.read_start=""
		self.gap_start=0
		self.gap_size=0
		self.left_len=0
		self.right_len=0
		self.type=""
		self.chr=""
		self.left_seq=""
		self.right_seq=""
		self.mpos=0
		self.strand=0
		self.gap_end =0
		self.isize=0
		self.mismatch=0
		self.score=0
		self.difficulty=0
		self.sv_seq=""
def usage():
	print "%s [cigar_analysis_file] [ref_file]" % sys.argv[0]
def get_as(line):
	pos1=line.find('AS')
	if pos1>0:
		pos2=line[pos1:].find('\t')
		as1=string.atoi(line[pos1+5:pos1+pos2]);
		return as1
	else:
		print "No AS field in sam file." 
		print line
		sys.exit(1)	
def load_genome (contig_file):	
	global genome
	fd = open(contig_file, "r")
	lines=fd.readlines()
	#assert(lines[0][0]=='>')
	genome = "".join(lines[1:]).replace('\n','').upper()
	fd.close()
def call_ins_seq(read_list):
	ins_seq=""
	start = 0
	end = len(read_list[0].sv_seq)
	max = 0 
	n_a=0
	n_c=0
	n_g=0
	n_t=0
	c=""
	for i in range (start,end):
                for j in range (0,len(read_list)):
			c = read_list[j].sv_seq[i]
                	if  c == "A" or c == "a":
		                n_a=n_a+1
	                if  c == "C" or c == "c":
                		n_c=n_c+1
                	if  c == "G" or c == "g":
        		        n_g=n_g+1
	                if  c == "T" or c == "t":
	  	        	n_t=n_t+1
                if max < n_a:
                        max = n_a
                        c="A"
                if max < n_c:
                        max = n_c
                        c="C"
                if max < n_g:
                        max = n_g
                        c="G"
                if max < n_t:
                        max = n_t
                        c="T"
		ins_seq = ins_seq + c.upper()
		n_a=0
	        n_c=0
        	n_g=0
	        n_t=0

	#print ins_seq
	return ins_seq
	
def build_contig (read_list):
	global genome
	global n_match
	global left_match
	global right_match
	global n_snp
	if read_list[0].type == "INV" or read_list[0].type == "DUP":
		n_snp=-999
		n_match=-999
		left_match=-999
		right_match=-999
		return
	#read_list.sort(key=operator.attrgetter("read_start"))
	n_a=0
	n_c=0
	n_g=0
	n_t=0
	n=0
	c=""
	k=0
	max=0
	n_snp=0
	n_match=0
	left_match=0
	right_match=0
	call_match_thresh = 9999
	if len(read_list) < 5 :
		call_match_thresh = 1
	else:
		call_match_thresh = 2
	#start = read_list[0].read_start
	#end = read_list[0].gap_start 
	if read_list[0].type == "INS" or read_list[0].type == "DEL":
		start =  read_list[0].gap_start - 1
	elif read_list[0].type == "DUP":
		start = read_list[0].gap_start + read_list[0].gap_size -1
		
	if start - 10000 >0:
		end = start - 10000
	else:
		end = 0
	contig_exceed=True
	#print "start:",start
	for i in range (start,end,-1):
		#print i
		k=k+1
		contig_exceed=True
		for j in range (0,len(read_list)):
			
			if len(read_list[j].left_seq) >=k :
				contig_exceed=False
				c =  read_list[j].left_seq[-k]
				#print "c:",c
				n = n+1
				if  c == "A" or c == "a":
					n_a=n_a+1
				if  c == "C" or c == "c":
					n_c=n_c+1
				if  c == "G" or c == "g":
					n_g=n_g+1
				if  c == "T" or c == "t":
					n_t=n_t+1
		if max < n_a:
			max = n_a
			c="A"
		if max < n_c:
                	max = n_c
	                c="C"
		if max < n_g:
                	max = n_g
	                c="G"
		if max < n_t:
                	max = n_t
	                c="T"
		if max > call_match_thresh and float(max)/float(n)>0.5:
			if genome[i-1]==c:
				n_match=n_match+1
				left_match = left_match + 1
			else:
				n_snp=n_snp+1
	
			
		n_a=0
	        n_c=0
		n_g=0
		n_t=0
        	n=0
		max=0
		if contig_exceed:
			break
	#print n_match,left_match
	if read_list[0].type == "INS":
		start =  read_list[0].gap_start 
	elif  read_list[0].type == "DEL":
		start =  read_list[0].gap_start + read_list[0].gap_size
	elif read_list[0].type == "DUP":
		start = read_list[0].gap_start

	#print "start:",start
        end = start + 10000
        contig_exceed=True
	k=0
        for i in range (start,end,1):
                contig_exceed=True
                for j in range (0,len(read_list)):
                        if len(read_list[j].right_seq) > k :
                                contig_exceed=False
                                c =  read_list[j].right_seq[k]
                                n = n+1
                                if  c == "A" or c == "a":
                                        n_a=n_a+1
                                if  c == "C" or c == "c":
                                        n_c=n_c+1
                                if  c == "G" or c == "g":
                                        n_g=n_g+1
                                if  c == "T" or c == "t":
                                        n_t=n_t+1
                if max < n_a:
                        max = n_a
                        c="A"
                if max < n_c:
                        max = n_c
                        c="C"
                if max < n_g:
                        max = n_g
                        c="G"
                if max < n_t:
                        max = n_t
                        c="T"
                if max > call_match_thresh and float(max)/float(n)>0.5:
                        if genome[i-1]==c:
                                n_match=n_match+1
                                right_match = right_match + 1
                        else:
                                n_snp=n_snp+1


                n_a=0
                n_c=0
                n_g=0
                n_t=0
                n=0
                max=0
		k=k+1
                if contig_exceed:
                        break
	#print n_match,right_match
	#exit(0)
		
def detect_sv(filename,contig_file):
	global abnormal_isize_0
	global abnormal_isize_1
	global bound_len_thresh
	global n_match
        global left_match
        global right_match

	avg_iszie=0.0
	tol_isize=0
	mismatch_1=999
	mismatch_2=999
	mismatch_3=999
	score1=0
	score2=0
	score3=0
	soft_clipped = 0
	unmapped = 0
	load_genome(contig_file)
	f1=open(filename,'r')
	fout=open(filename+"_sv","w")
    	
	read_list=[]
	last_read=split_read()
	read_list.append(last_read)
	str = "@chr\tgap_start\tgap_end\tgap_size\ttype\tsupport_read_num\tcontig_match\tcontig_snp\tab_isize_0\tab_isize_1\tavg_isize\tmismatch_1\tmismatch_2\tmismatch_3\tleft_match\tright_match\tscore1\tscore2\tscore3\tmate_soft_clipped\tmate_unmapped\tsv_seq\n"

	fout.write(str)
	
	while True:
		line = f1.readline()
		if line[0:1]=='@':
			continue
    		if len(line) == 0: # Zero length indicates EOF
        		break
		tmp=line.split()
		a=split_read()
		
		a.read_start=string.atoi(tmp[0])
		a.gap_start=string.atoi(tmp[1])
		if abs(a.gap_start - a.read_start) > 99:
			continue
		a.gap_size=string.atoi(tmp[2])
		a.left_len=string.atoi(tmp[3])
		a.right_len=string.atoi(tmp[4])
		a.type=tmp[5]
		a.left_seq=tmp[6]
		a.right_seq=tmp[11]
		a.mpos=string.atoi(tmp[12])
		a.chr=tmp[9]
		a.strand=string.atoi(tmp[8])
		a.mismatch = string.atoi(tmp[10])
		a.score = string.atoi(tmp[7])
		a.difficulty= string.atoi(tmp[13])
		a.sv_seq= tmp[14]
		#if a.strand == 1:
			#a.isize = abs(a.mpos - a.read_start) + len(a.seq) + 1
		
		#else :
			#if a.type == "DEL":
			#	a.isize = a.mpos - a.read_start + len(a.seq) - a.gap_size + 1
			#elif a.type == "INS":
			#	a.isize = a.mpos - a.read_start + len(a.seq) + a.gap_size + 1
			#else:
			#	continue
		#if a.isize < mean - 3*std or a.isize > mean + 3*std:
		#	if a.strand == 1:
		#		abnormal_isize_1 = abnormal_isize_1 + 1
		#	else:
		#		abnormal_isize_0 = abnormal_isize_0 + 1
		if a.type == read_list[0].type and a.gap_start == read_list[0].gap_start and a.gap_size == read_list[0].gap_size:
			is_dup_line=False
			for i in range (0,len(read_list)):
				if a.read_start == read_list[i].read_start and a.left_len ==  read_list[i].left_len:
					is_dup_line=True
					break
			if is_dup_line:
				continue
			if (a.left_len < bound_len_thresh or a.right_len < bound_len_thresh):
				continue
			#tol_isize = tol_isize + a.isize
			read_list.append(a)
			
			
		else :
			if len(read_list)>=2:
				build_contig(read_list)		
				if (read_list[0].type == "INS"):
					sv_seq = call_ins_seq(read_list)	
					gap_end = read_list[0].gap_start
				else:
					sv_seq = "*"
					gap_end = read_list[0].gap_start+read_list[0].gap_size-1
				tol_isize = 0
				for i in range(0,len(read_list)):
					b = read_list[i]
					if b.difficulty == SOFT_CLIPPING:
		                                soft_clipped = soft_clipped + 1
					elif b.difficulty == UNMAPPED:
		                                unmapped = unmapped + 1

					#if b.isize < mean - 3*std or b.isize > mean + 3*std:
					#	if a.strand == 1:
					#		abnormal_isize_1 = abnormal_isize_1 + 1
					#	else:
					#		abnormal_isize_0 = abnormal_isize_0 + 1
					#tol_isize = tol_isize + b.isize
					if b.left_len >= 10 and b.right_len >= 10:
						if b.mismatch < mismatch_1:
							mismatch_3 = mismatch_2
							mismatch_2 = mismatch_1
							mismatch_1 = b.mismatch
						elif b.mismatch < mismatch_2:
							mismatch_3 = mismatch_2
							mismatch_2 = b.mismatch
						elif b.mismatch < mismatch_3:
							mismatch_3 = b.mismatch
						
						if b.score > score1:
							score3 = score2
							score2 = score1
							score1 = b.score
						elif b.score > score2:
							score3 = score2
							score2 = b.score
						elif b.score > score3:
							score3 = b.score

				#avg_isize = tol_isize / len(read_list)
				str = "%s\t%i\t%i\t%i\t%s\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%s\n" % (read_list[0].chr,read_list[0].gap_start,gap_end,read_list[0].gap_size,read_list[0].type,len(read_list),n_match,n_snp,abnormal_isize_0,abnormal_isize_1,avg_isize,mismatch_1,mismatch_2,mismatch_3,left_match,right_match,score1,score2,score3,soft_clipped,unmapped,sv_seq)
				#print str
				fout.write(str)
			read_list=[]
			abnormal_isize_0 = 0
			abnormal_isize_1 = 0
			mismatch_1=999
			mismatch_2=999
			mismatch_3=999
		 	score1=0
		        score2=0
		        score3=0
			soft_clipped = 0;
			unmapped = 0;
			avg_isize = 0
			if (a.left_len < bound_len_thresh or a.right_len < bound_len_thresh):
				read_list.append(split_read())
				#tol_isize = 0
			else:
				read_list.append(a)
				#tol_isize = a.isize
	if len(read_list)>=2:
        	build_contig(read_list)
        	if (read_list[0].type == "INS"):
			sv_seq = call_ins_seq(read_list)	
			gap_end = read_list[0].gap_start
                else:   
			sv_seq = "*"
                	gap_end = read_list[0].gap_start+read_list[0].gap_size-1
		tol_isize = 0
		for i in range(0,len(read_list)):
			b = read_list[i]

			if b.difficulty == SOFT_CLIPPING:
				soft_clipped = soft_clipped + 1
			elif b.difficulty == UNMAPPED:
				unmapped = unmapped + 1
			#if b.isize < mean - 3*std or b.isize > mean + 3*std:
			#	if a.strand == 1:
			#		abnormal_isize_1 = abnormal_isize_1 + 1
			#	else:
			#		abnormal_isize_0 = abnormal_isize_0 + 1
			abnormal_isize_0 = -999
			abnormal_isize_1 = -999
			tol_isize = tol_isize + b.isize
			if b.left_len >=10 and a.right_len >= 10:
				if b.mismatch < mismatch_1:
					mismatch_3 = mismatch_2
					mismatch_2 = mismatch_1
					mismatch_1 = b.mismatch
				elif b.mismatch < mismatch_2:
					mismatch_3 = mismatch_2
					mismatch_2 = b.mismatch
				elif b.mismatch < mismatch_3:
					mismatch_3 = b.mismatch
				if b.score > score1:
					score3 = score2
					score2 = score1
					score1 = b.score
				elif b.score > score2:
					score3 = score2
					score2 = b.score
				elif b.score > score3:
					score3 = b.score

		#avg_isize = tol_isize / len(read_list)
		avg_isize = -999
		
		#str = "%s\t%i\t%i\t%i\t%s\t%i\t%i\t%i\t%i\t%i\n" % (read_list[0].chr,read_list[0].gap_start,read_list[0].gap_start+read_list[0].gap_size-1,read_list[0].gap_size,read_list[0].type,len(read_list),n_match,n_snp,abnormal_isize_0,abnormal_isize_1)
		#str = "%s\t%i\t%i\t%i\t%s\t%i\t%i\t%i\t%i\t%i\t%i\n" % (read_list[0].chr,read_list[0].gap_start,gap_end,read_list[0].gap_size,read_list[0].type,len(read_list),n_match,n_snp,abnormal_isize_0,abnormal_isize_1,avg_isize)
		#str = "%s\t%i\t%i\t%i\t%s\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\n" % (read_list[0].chr,read_list[0].gap_start,gap_end,read_list[0].gap_size,read_list[0].type,len(read_list),n_match,n_snp,abnormal_isize_0,abnormal_isize_1,avg_isize,mismatch_1,mismatch_2,mismatch_3,left_match,right_match,score1,score2,score3,soft_clipped,unmapped)
		str = "%s\t%i\t%i\t%i\t%s\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%s\n" % (read_list[0].chr,read_list[0].gap_start,gap_end,read_list[0].gap_size,read_list[0].type,len(read_list),n_match,n_snp,abnormal_isize_0,abnormal_isize_1,avg_isize,mismatch_1,mismatch_2,mismatch_3,left_match,right_match,score1,score2,score3,soft_clipped,unmapped,sv_seq)
                #print str		
		fout.write(str)
	f1.close()
	fout.close()
		


if __name__=='__main__':
	if len(sys.argv)!=3:
		usage()
		sys.exit(1)
	file1=sys.argv[1]
	file2=sys.argv[2]
	#mean=string.atoi(sys.argv[3])
	#std=string.atoi(sys.argv[4])
	detect_sv(file1,file2)
