supp_num=5
mismatch_highcov=3
mismatch_lowcov=1
flanking_match_highcov=15
flanking_match_lowcov=30
flanking_match_highcov_ins=12
flanking_match_lowcov_ins=20
max_snp=3
prism_sam="_none"
output_path="."
usage()
{
        echo "usage:"
        echo "  -i sv loci file."
        echo "  -s support read num [default:5]"
        echo "  -m Max mismatch for sv supported by >= supp_num reads [default:3]"
        echo "  -n Max mismatch for sv supported by < supp_num reads [default:1]"
        echo "  -l Flanking region length for  sv supported by >= supp_num reads [default:15]"
        echo "  -r Flanking region length for  sv supported by < supp_num reads [default:30]"
        echo "  -p Max snp num in flaning region [default:3]"
        echo "  -o output folder [default:"."]"
	
        exit 0
}

while getopts "s:l:r:m:n:i:p:o:" options;do
        case $options in
                s)      supp_num=$OPTARG;echo -e "Support read num:\t${supp_num}";;
                m)      mismatch_highcov=$OPTARG;echo -e "Max mismatch for sv supported by >= supp_num reads:\t${mismatch_highcov}";;
                n)      mismatch_lowcov=$OPTARG;echo -e "Max mismatch for sv supported by < supp_num reads:\t${mismatch_lowcov}";;
                l)      flanking_match_highcov=$OPTARG;echo -e "Flanking region length for  sv supported by >= supp_num reads:\t${flanking_match_highcov}";;
                r)      flanking_match_lowcov=$OPTARG;echo -e "Flanking region length for  sv supported by < supp_num reads:\t${flanking_match_lowcov}";;
                p)      max_snp=$OPTARG;echo -e "Max snp num in flaning region:\t${max_snp}";;
		i)      prism_sam=$OPTARG;echo -e "PRiSM sam:\t${prism_sam}";;
		o)	output_path=$OPTARG;echo -e "Output folder:\t${output_path}";;
                \?)     usage;;
        esac
done
if test ! -e ${prism_sam};then
        echo "input file is invalid:$prism_sam."
        usage
        exit 0
fi


awk '$4>=1 && $4<10 && $5=="DEL"' ${prism_sam} |awk -v ms=$max_snp -v sn=$supp_num -v mh=$mismatch_highcov -v ml=$mismatch_lowcov -v fmh=$flanking_match_highcov -v fml=$flanking_match_lowcov '$8<=ms && (($6>=sn && $12<=mh  && $15>fmh &&$16>fmh)||($6<sn && $12 <=ml && $15>fml &&$16>fml))' > ${output_path}/del_1_10
awk '$4>=10 && $4<50 && $5=="DEL"' ${prism_sam} |awk -v ms=$max_snp -v sn=$supp_num -v mh=$mismatch_highcov -v ml=$mismatch_lowcov -v fmh=$flanking_match_highcov -v fml=$flanking_match_lowcov '$8<=ms && (($6>=sn && $12<=mh  && $15>fmh &&$16>fmh)||($6<sn && $12 <=ml && $15>fml &&$16>fml))' > ${output_path}/del_10_50
awk '$4>=50 && $4<100 && $5=="DEL"' ${prism_sam} |awk -v ms=$max_snp -v sn=$supp_num -v mh=$mismatch_highcov -v ml=$mismatch_lowcov -v fmh=$flanking_match_highcov -v fml=$flanking_match_lowcov '$8<=ms && (($6>=sn && $12<=mh  && $15>fmh &&$16>fmh)||($6<sn && $12 <=ml && $15>fml &&$16>fml))' > ${output_path}/del_50_100
awk '$4>=100 && $4<1000 && $5=="DEL"' ${prism_sam} | awk -v ms=$max_snp -v sn=$supp_num -v mh=$mismatch_highcov -v ml=$mismatch_lowcov -v fmh=$flanking_match_highcov -v fml=$flanking_match_lowcov '$8<=ms && (($6>=sn && $12<=mh  && $15>fmh &&$16>fmh)||($6<sn && $12 <=ml && $15>fml &&$16>fml))'> ${output_path}/del_100_1000
awk '$4>=1000 && $5=="DEL"' ${prism_sam} | awk -v ms=$max_snp  -v sn=$supp_num -v mh=$mismatch_highcov -v ml=$mismatch_lowcov -v fmh=$flanking_match_highcov -v fml=$flanking_match_lowcov '$8<=ms && (($6>=sn && $12<=mh  && $15>fmh &&$16>fmh)||($6<sn && $12 <=ml && $15>fml &&$16>fml))'> ${output_path}/del_1000_plus
awk '$4>=1 && $4<10 && $5=="INS"' ${prism_sam} | awk -v ms=$max_snp -v sn=$supp_num -v mh=$mismatch_highcov -v ml=$mismatch_lowcov -v fmh=$flanking_match_highcov_ins -v fml=$flanking_match_lowcov_ins '$8<=ms && (($6>=sn && $12<=mh  && $15>fmh &&$16>fmh)||($6<sn && $12 <=ml && $15>fml &&$16>fml))'> ${output_path}/ins_1_10
awk '$4>=10 && $4<50 && $5=="INS"' ${prism_sam} | awk -v ms=$max_snp -v sn=$supp_num -v mh=$mismatch_highcov -v ml=$mismatch_lowcov -v fmh=$flanking_match_highcov_ins -v fml=$flanking_match_lowcov_ins '$8<=ms && (($6>=sn && $12<=mh  && $15>fmh &&$16>fmh)||($6<sn && $12 <=ml && $15>fml &&$16>fml))'> ${output_path}/ins_10_50
awk '$4>=50 && $4<100 && $5=="INS"' ${prism_sam} | awk -v ms=$max_snp -v sn=$supp_num -v mh=$mismatch_highcov -v ml=$mismatch_lowcov -v fmh=$flanking_match_highcov_ins -v fml=$flanking_match_lowcov_ins '$8<=ms && (($6>=sn && $12<=mh  && $15>fmh &&$16>fmh)||($6<sn && $12 <=ml && $15>fml &&$16>fml))'> ${output_path}/ins_50_100

awk '$5=="INV"' ${prism_sam} |awk -v ms=$max_snp -v sn=$supp_num -v mh=$mismatch_highcov -v ml=$mismatch_lowcov -v fmh=$flanking_match_highcov -v fml=$flanking_match_lowcov '($6>=sn && $12<=mh )||($6<sn && $12 <=ml )' > ${output_path}/inv
awk '$5=="DUP"' ${prism_sam} |awk -v ms=$max_snp -v sn=$supp_num -v mh=$mismatch_highcov -v ml=$mismatch_lowcov -v fmh=$flanking_match_highcov -v fml=$flanking_match_lowcov '($6>=sn && $12<=mh  && $15>fmh &&$16>fmh)||($6<sn && $12 <=ml && $15>fml &&$16>fml)' > ${output_path}/dup
${PRISM_PATH}/toolkit/rm_overlap_sv.py ${output_path}/del_100_1000
${PRISM_PATH}/toolkit/rm_overlap_sv.py ${output_path}/del_50_100
${PRISM_PATH}/toolkit/rm_overlap_sv.py ${output_path}/del_1000_plus
${PRISM_PATH}/toolkit/rm_overlap_sv.py ${output_path}/dup
${PRISM_PATH}/toolkit/rm_overlap_sv.py ${output_path}/inv

