#!/usr/bin/python
#######################################################################################
# Keep the best aligned read for multiple aligned reads and remove others.
#######################################################################################
import string
import sys
import operator

genome = ""
n_snp = 0
n_match = 0
class sam:
	def __init__(self):
		self.name=""
		self.strand=0
		self.chr=""
		self.pos=0
		self.mpos=0
		self.cigar=""
		self.seq=""
		self.sv_type=0
		self.x0=0
		self.mismatch=0
		self.match=0
		self.score=0
		self.difficulty=0
		self.read_len=0
def usage():
	print "%s sam file" % sys.argv[0]
def get_custom_field(line,field):
	pos1=line.find(field)
	if pos1>0:
		pos2=line[pos1:].find('\t')
		if pos2>0:
			cs=line[pos1+5:pos1+pos2]
		else:
			cs=line[pos1+5:]
		return cs
	else:
		return "-999"
		print "No custom field in sam file." 
		print line
		sys.exit(1)	

def format_sv(filename):
	#load_genome(contig_file)
	f1=open(filename,'r')
	fout=open(filename+"_cigar","w")
    	
	#read_list=[]
	#last_read=split_read()
	#read_list.append(last_read)
	str = "@read_start\tsv_start\tsv_size\tleft_len\tright_len\tsv_type\tleft_seq\tscore\tstrand\tchr\tmismatch\tright_seq\tmate_start\tdifficulty\tsv_seq\n" 
	#print str
	fout.write(str)
	while True:
		line = f1.readline()
		if line[0:1]=='@':
			continue
    		if len(line) == 0: # Zero length indicates EOF
        		break
		tmp=line.split()
		a=sam()
		
		a.strand=string.atoi(tmp[1])/16
		a.chr=tmp[2]
		a.pos=string.atoi(tmp[3])
		#a.mpos=string.atoi(tmp[7])
		a.cigar=tmp[5]
		a.seq=tmp[9]
		a.read_len=len(a.seq)
		a.sv_type=string.atoi(get_custom_field(line,"ST:i:"))
		a.match=string.atoi(get_custom_field(line,"MA:i:"))
		a.mismatch=string.atoi(get_custom_field(line,"MM:i:"))
		a.score=string.atoi(get_custom_field(line,"AS:i:"))
		a.difficulty=string.atoi(get_custom_field(line,"DF:i:"))
		
		
		if a.cigar == "*":
			continue	
		if not (a.cigar.find("D") or a.cigar.find("I") or a.cigar.find("N")):
			continue

		left_len=0
		right_len=0
		is_left=True
		sv_size=0
		sv_type=""
		sv_start=0
		sv_seq="*"
		left_len_N=0
		right_len_N=0
		cigar=a.cigar
		tmpstr=""
		gap_size = 0
		n_m=0
		n_i=0
		n_d=0
		n_s=0
		head_m=0
		head_i=0
		head_d=0
		sv_size_N=0
		left_seq=""
		right_seq=""
		first_m=0
		last_m=0
		left_m=0
		right_m=0
		left_i=0
		right_i=0
		left_d=0
		right_d=0
		ins_seq=""
	 	for i in range(0,len(cigar)):
                        if cigar[i].isdigit():
                                tmpstr = tmpstr + cigar[i]
                	else:
				if cigar[i] == "S":
					n_s += string.atoi(tmpstr)	
				if cigar[i] == "M":
					if first_m==0:
						first_m=string.atoi(tmpstr)
					n_m+=string.atoi(tmpstr)
					if is_left:
						left_len=string.atoi(tmpstr)
					else:
						right_len=string.atoi(tmpstr)
						if sv_type == "DEL":
							left_seq = a.seq[n_s+left_m+left_i-left_len:n_s+left_m+left_i]
                                                        right_seq = a.seq[n_s+left_m+left_i:n_s+left_m+left_i+right_len]
							if len(left_seq) == 0:
					                        left_seq="N"
					                if len(right_seq) == 0:
					                        right_seq="N"

                                                        str = "%i\t%i\t%i\t%i\t%i\t%s\t%s\t%i\t%i\t%s\t%i\t%s\t%i\t%i\t%s\n" % (a.pos,sv_start,sv_size,left_len,right_len,sv_type,left_seq,a.score,a.strand,a.chr,a.mismatch,right_seq,a.mpos,a.difficulty,"*")
                                                        fout.write(str)
						if sv_type == "INS":
							ins_seq = a.seq[n_s+left_m+left_i:n_s+left_m+left_i+sv_size]
							left_seq = a.seq[n_s+left_m+left_i-left_len:n_s+left_m+left_i]
							right_seq = a.seq[n_s+left_m+left_i+sv_size:n_s+left_m+left_i+sv_size+right_len]
							if len(left_seq) == 0:
					                        left_seq="N"
					                if len(right_seq) == 0:
					                        right_seq="N"
							str = "%i\t%i\t%i\t%i\t%i\t%s\t%s\t%i\t%i\t%s\t%i\t%s\t%i\t%i\t%s\n" % (a.pos,sv_start,sv_size,left_len,right_len,sv_type,left_seq,a.score,a.strand,a.chr,a.mismatch,right_seq,a.mpos,a.difficulty,ins_seq)
							fout.write(str)
						elif sv_type == "DUP":
							left_len_N = left_len	
							right_len_N = right_len
                                                elif a.sv_type == 31 or a.sv_type ==32 or a.sv_type == 36:
							left_len_N = left_len	
							right_len_N = right_len
	
                                                elif a.sv_type == 33 or a.sv_type ==34 or a.sv_type == 35:
							left_len_N = left_len	
							right_len_N = right_len

						#print str
						#fout.write(str)
						left_len = right_len
						is_left = True
						
				elif cigar[i] == "D":
					left_m = n_m
					left_i = n_i
					sv_size=string.atoi(tmpstr)
					sv_start=a.pos+n_m + n_d 
					is_left=not is_left
					sv_type="DEL"
					n_d+=sv_size
				elif cigar[i] == "I":
					left_m = n_m
					left_i = n_i
					sv_size=string.atoi(tmpstr)
					sv_start=a.pos+n_m+n_d
					is_left=not is_left
					sv_type="INS"
					n_i+=sv_size
				elif cigar[i] == "N":
					head_m=n_m
					head_i=n_i
					head_d=n_d
					is_left=not is_left
					gap_size = string.atoi(tmpstr)
					sv_size_N=gap_size
					n_d += gap_size
					if a.sv_type ==1 or a.sv_type == 2: #small del or cluster del
						left_m = n_m
						left_i = n_i
						sv_start = a.pos+head_m+head_d
						sv_size = sv_size_N
						sv_type="DEL"
					elif a.sv_type ==4: #dup
                                        	#sv_size=gap_size+ a.read_len
						sv_start=a.pos
	                                        #is_left=not is_left
        	                                sv_type="DUP"
					elif a.sv_type == 31 or a.sv_type ==32 or a.sv_type == 36: # inver_fw_out inver_fw_in small_inver_bw
						#sv_size = gap_size + a.read_len - n_m -n_i
						sv_start = a.pos + n_m
						sv_type = "INV"
					elif a.sv_type == 33 or a.sv_type ==34 or a.sv_type == 35: # inver_bw_out inver_bw_in small_inver_fw
						#sv_size = gap_size + n_m 
						sv_start = a.pos
						sv_type = "INV"
					
						 

				tmpstr=""
		last_m=right_len
		#n_m += right_len
		#print first_m,last_m
		if a.sv_type == 4:
			sv_type = "DUP"
			sv_size = n_m + n_d
			sv_start = a.pos
			#left_len_N=first_m
			#right_len_N=last_m
			#left_seq = a.seq[0:first_m]
			#right_seq = a.seq[a.read_len-last_m:a.read_len]
			right_len_N=first_m
			left_len_N=last_m
			right_seq = a.seq[0:first_m]
			left_seq = a.seq[a.read_len-last_m:a.read_len]
			if len(left_seq) == 0:
				left_seq="N"
			if len(right_seq) == 0:
				right_seq="N"
			str = "%i\t%i\t%i\t%i\t%i\t%s\t%s\t%i\t%i\t%s\t%i\t%s\t%i\t%i\t%s\n" % (a.pos,sv_start,sv_size,left_len_N,right_len_N,sv_type,left_seq,a.score,a.strand,a.chr,a.mismatch,right_seq,a.mpos,a.difficulty,"*")
			fout.write(str)
                	#str = "%i\t%i\t%i\t%i\t%i\t%s\t%s\t%i\t%i\t%s\t%i\t%s\t%i\t%i\n" % (a.pos,sv_start,sv_size,left_len_N,right_len_N,sv_type,sv_seq,a.score,a.strand,a.chr,a.mismatch,a.seq,a.mpos,a.difficulty)
                elif a.sv_type == 31 or a.sv_type ==32 or a.sv_type == 36:
			sv_type = "INV"
			sv_size = (n_m - head_m) + (n_d - head_d)
			sv_start = a.pos + head_m + head_d 
			right_len_N=last_m
			left_seq = a.seq[head_m+head_i-left_len_N:head_m+head_i]
                        right_seq = a.seq[a.read_len-last_m:a.read_len]
			if len(left_seq) == 0:
				left_seq="N"
			if len(right_seq) == 0:
				right_seq="N"
			str = "%i\t%i\t%i\t%i\t%i\t%s\t%s\t%i\t%i\t%s\t%i\t%s\t%i\t%i\t%s\n" % (a.pos,sv_start,sv_size,left_len_N,right_len_N,sv_type,left_seq,a.score,a.strand,a.chr,a.mismatch,right_seq,a.mpos,a.difficulty,"*")
			fout.write(str)
                        #str = "%i\t%i\t%i\t%i\t%i\t%s\t%s\t%i\t%i\t%s\t%i\t%s\t%i\t%i\n" % (a.pos,sv_start,sv_size,left_len_N,right_len_N,sv_type,sv_seq,a.score,a.strand,a.chr,a.mismatch,a.seq,a.mpos,a.difficulty)
                elif a.sv_type == 33 or a.sv_type ==34 or a.sv_type == 35:
			sv_type = "INV"
			sv_size = sv_size_N + head_m + head_d
			sv_start = a.pos
			left_len_N=first_m
			left_seq = a.seq[0:first_m]
                        right_seq = a.seq[head_m+head_i:head_m+head_i+right_len_N]
			if len(left_seq) == 0:
				left_seq="N"
			if len(right_seq) == 0:
				right_seq="N"
			str = "%i\t%i\t%i\t%i\t%i\t%s\t%s\t%i\t%i\t%s\t%i\t%s\t%i\t%i\t%s\n" % (a.pos,sv_start,sv_size,left_len_N,right_len_N,sv_type,left_seq,a.score,a.strand,a.chr,a.mismatch,right_seq,a.mpos,a.difficulty,"*")
			fout.write(str)
                	#str = "%i\t%i\t%i\t%i\t%i\t%s\t%s\t%i\t%i\t%s\t%i\t%s\t%i\t%i\n" % (a.pos,sv_start,sv_size,left_len_N,right_len_N,sv_type,sv_seq,a.score,a.strand,a.chr,a.mismatch,a.seq,a.mpos,a.difficulty)
	

	f1.close()
	fout.close()
		


if __name__=='__main__':
	if len(sys.argv)!=2:
		usage()
		sys.exit(1)
	file1=sys.argv[1]
	format_sv(file1)
