#!/usr/bin/python
#######################################################################################
# Keep the best aligned read for multiple aligned reads and remove others.
#######################################################################################
import string
import sys

class read:
	def __init__(self):
		self.sam_line=""
		self.name=""
		self.pos=0
		self.cigar=""
		self.score=0
		self.sv_size=0
		self.sv_num=0
def usage():
	print "%s sam file" % sys.argv[0]
def get_as(line):
	pos1=line.find('AS')
	if pos1>0:
		pos2=line[pos1:].find('\t')
		as1=string.atoi(line[pos1+5:pos1+pos2]);
		return as1
	else:
		print "No AS field in sam file." 
		print line
		sys.exit(1)	
def is_multi_indel(cigar):
        n_indel = cigar.count("I") + cigar.count("D") + cigar.count("N")
	if n_indel > 1 :
		return True
	else :
		return False	
def fight(a,b):
	if a.score > b.score:
		return 1
	elif a.score < b.score:
		return 2
	else:
		if a.sv_num < b.sv_num:
			return 1
		elif a.sv_num > b.sv_num:
			return 2
		else:
			if a.sv_size < b.sv_size:
				return 1 
			elif a.sv_size > b.sv_size:
				return 2
			else:
				return 0	
def rm_multi_read(filename):
	f1=open(filename,'r')
	fout=open(filename+"_rmmul","w")
	fout_non_un=open(filename+"_non_un_pair","w")
	fout_multi_indel=open(filename+"_multi_indel","w")
    	
	read_list=[]
	last_read=read()
	#max = read()
	read_list.append(last_read)
	max = last_read
	
	is_non_un=False
	
	while True:
		line = f1.readline()
		if line[0:1]=='@':
			continue
    		if len(line) == 0: # Zero length indicates EOF
        		break
		tmp=line.split()
		a=read()
		
		a.sam_line=line
		a.name=tmp[0]
		a.pos=string.atoi(tmp[3])
		a.cigar=tmp[5]
		a.score=get_as(line)
		tmpstr = ""
		for i in range(0,len(a.cigar)):
                	if a.cigar[i].isdigit():
                        	tmpstr = tmpstr + a.cigar[i]
                        else:
                        	if a.cigar[i] != "M" and a.cigar[i] != "S":
					a.sv_num = a.sv_num + 1
					a.sv_size = a.sv_size + string.atoi(tmpstr)		
				tmpstr=""

		if a.name == read_list[0].name:
			is_dup_line=False
			for i in range (0,len(read_list)):
				if a.pos ==  read_list[i].pos and a.cigar == read_list[i].cigar:
					is_dup_line=True
					break
			if is_dup_line:
				continue
			read_list.append(a)
			ret = fight (a,max)
			if ret == 1:
				is_non_un = False
				max = a
			elif ret == 0:
				is_non_un - True
			#if a.score > max_score:
				#max_score=a.score
				#max_score_sv_num=a.sv_num
				#max_score_sv_size=a.sv_size
				#is_non_un = False
				#max_line=a.sam_line
		
			#elif a.score == max_score:	
				#if a.sv_num < max_score_sv_num
				#is_non_un = True
				#max_line=""
			
		else :
			if is_non_un:
				for i in range(0,len(read_list)):
					if read_list[i].score == max.score:
						fout_non_un.write(read_list[i].sam_line)
						fout.write(read_list[i].sam_line)
		
			else :	
				if is_multi_indel(max.cigar):
                                	fout_multi_indel.write(max.sam_line)
                                	fout.write(max.sam_line)
                                else:
                                	fout.write(max.sam_line)

				#for i in range(0,len(read_list)):
                                #        if read_list[i].score == max_score:
                                        #        fout.write(read_list[i].sam_line)
				#		if is_multi_indel(read_list[i].cigar):
				#			fout_multi_indel.write(read_list[i].sam_line)
				#		else:
				#			fout.write(read_list[i].sam_line)
			read_list=[]
			read_list.append(a)
			max = a
			#max_score=a.score
			#max_line=a.sam_line
			is_non_un=False
	if is_non_un:
        	for i in range(0,len(read_list)):
                	if read_list[i].score == max.score:
                        	fout_non_un.write(read_list[i].sam_line)
				fout.write(read_list[i].sam_line)
        else :
		if is_multi_indel(max.cigar):
                	fout_multi_indel.write(max.sam_line)
                        fout.write(max.sam_line)
                else:
                	fout.write(max.sam_line)

        #        for i in range(0,len(read_list)):
        #                if read_list[i].score == max_score:
	#			if is_multi_indel(read_list[i].cigar):
	#				fout_multi_indel.write(read_list[i].sam_line)
	#			else:
        #                    		fout.write(read_list[i].sam_line)
	
	f1.close()
	fout.close()
	fout_non_un.close()
		


if __name__=='__main__':
	if len(sys.argv)!=2:
		usage()
		sys.exit(1)
	file1=sys.argv[1]
	rm_multi_read(file1)
