#!/usr/bin/python
#######################################################################################
# Keep the best aligned read for multiple aligned reads and remove others.
#######################################################################################
import string
import sys

class structure_variant:
	def __init__(self):
		self.line=""
		self.chr=""
		self.start=0
		self.end=0
		self.size=0
		self.type=0
		self.supp=0
		self.contigmatch=0
		self.contigsnp=0
		self.mismatch1=0
		self.mismatch2=0
		self.mismatch3=0
		self.score1=0
		self.score2=0
		self.score3=0
		self.leftmatch=0
		self.rightmatch=0
def usage():
	print "%s sam file" % sys.argv[0]
def get_as(line):
	pos1=line.find('AS')
	if pos1>0:
		pos2=line[pos1:].find('\t')
		as1=string.atoi(line[pos1+5:pos1+pos2]);
		return as1
	else:
		print "No AS field in sam file." 
		print line
		sys.exit(1)	
def is_multi_indel(cigar):
        n_indel = cigar.count("I") + cigar.count("D") + cigar.count("N")
	if n_indel > 1 :
		return True
	else :
		return False	

def read_sv(line):
	tmp=line.split()
	a=structure_variant()
	a.line=line
	a.chr=tmp[0]
	a.start=string.atoi(tmp[1])
	a.end=string.atoi(tmp[2])
	a.size=string.atoi(tmp[3])
	a.type=tmp[4]
	if tmp[5] == "-":
		a.supp = 0
	else:
		a.supp=string.atoi(tmp[5])
	a.contigmatch=string.atoi(tmp[6])
	a.contigsnp=string.atoi(tmp[7])
	a.mismatch1=string.atoi(tmp[11])
	a.mismatch2=string.atoi(tmp[12])
	a.mismatch3=string.atoi(tmp[13])
	a.score1=string.atoi(tmp[16])
	a.score2=string.atoi(tmp[17])
	a.score3=string.atoi(tmp[18])
	a.leftmatch=string.atoi(tmp[14])
	a.rightmatch=string.atoi(tmp[15])
	return a
def is_overlap(a,b):
	delta = 0
	if not (a.end < b.start -delta or a.start > b.end + delta):
		return 1
	else:
		return 0
def fight (a,b):
	if a.supp > b.supp:
		return 0
	elif a.supp < b.supp:
		return 2
	else:
		if a.size < b.size:
			return 0
		elif a.size > b.size:
			return 2
		else:	
			return 1
def rm_overlap_sv(filename):
	f1=open(filename,'r')
	fout=open(filename+"_RO","w")
	#f_rm=open(filename+"_RM","w")
    	cur_sv=structure_variant()

	while True:
                line = f1.readline()
                if line[0:1]=='@':
                        continue
                if len(line) == 0: # Zero length indicates EOF
                        break
		cur_sv=read_sv(line)
		break

	while True:
		line = f1.readline()
		if line[0:1]=='@':
			continue
    		if len(line) == 0: # Zero length indicates EOF
        		break
		a=read_sv(line)
		
		
		if is_overlap(a,cur_sv):
			f = fight (a,cur_sv)		
			if f == 0 :
				#f_rm.write(cur_sv.line)
				cur_sv = a
			#else:
			#	f_rm.write(a.line)	
		else :
			fout.write(cur_sv.line)
			cur_sv = a
	fout.write(cur_sv.line)
	f1.close()
	fout.close()
	#f_rm.close()
		


if __name__=='__main__':
	if len(sys.argv)!=2:
		usage()
		sys.exit(1)
	file1=sys.argv[1]
	rm_overlap_sv(file1)
