/*	$Id: sw-full-cs.c,v 1.15 2009/06/16 23:26:21 rumble Exp $	*/

#include <assert.h>
#include <ctype.h>
#include <errno.h>
#include <math.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <unistd.h>
#include <zlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>

#include "../common/fasta.h"
#include "../common/util.h"
#include "../common/sw_split_common.h"
#include "../common/sw_split_cs.h"
struct swcell {
  struct {
    int	score_n;
    int	score_w;
    int	score_nw;
    int	score_nw_max;

    int8_t	back_n;
    int8_t	back_w;
    int8_t	back_nw;
    int8_t	back_nw_max;

    int pos;
  } from[4];
};
struct max_l{
	struct{
		int score;
		int score_from;
		int pos;
		//int k;//A B C D
	}max[4];
};
struct max_t{
	int score;
	//int score_from;
	int pos;
	int multi;
};

#define FROM_A	0x00
#define FROM_B	0x01
#define FROM_C	0x02
#define FROM_D	0x03

#define FROM_NORTH_NORTH		0x01
#define FROM_NORTH_NORTHWEST		0x02
#define FROM_WEST_NORTHWEST		0x03
#define FROM_WEST_WEST			0x04
#define FROM_NORTHWEST_NORTH		0x05
#define FROM_NORTHWEST_NORTHWEST	0x06
#define FROM_NORTHWEST_WEST		0x07

#define FROM_NORTHWEST_MAX_NORTH		0x08
#define FROM_NORTHWEST_MAX_NORTHWEST	0x09
#define FROM_NORTHWEST_MAX_WEST		0xA

#define FROM_NORTH_NORTHWEST_MAX	0xB
#define FROM_NORTHWEST_NORTHWEST_MAX	0xC
#define FROM_WEST_NORTHWEST_MAX	0xD

#define FROM_x(_mat, _dir)		(int8_t)(((_dir) << 2) | (_mat))

#define FROM_A_NORTH_NORTH		FROM_x(FROM_A, FROM_NORTH_NORTH)
#define FROM_A_NORTH_NORTHWEST		FROM_x(FROM_A, FROM_NORTH_NORTHWEST)
#define	FROM_A_WEST_NORTHWEST		FROM_x(FROM_A, FROM_WEST_NORTHWEST)
#define FROM_A_WEST_WEST		FROM_x(FROM_A, FROM_WEST_WEST)
#define FROM_A_NORTHWEST_NORTH		FROM_x(FROM_A, FROM_NORTHWEST_NORTH)
#define FROM_A_NORTHWEST_NORTHWEST	FROM_x(FROM_A, FROM_NORTHWEST_NORTHWEST)
#define FROM_A_NORTHWEST_WEST		FROM_x(FROM_A, FROM_NORTHWEST_WEST)
#define FROM_A_NORTH_NORTHWEST_MAX		FROM_x(FROM_A, FROM_NORTH_NORTHWEST_MAX)
#define FROM_A_NORTHWEST_NORTHWEST_MAX	FROM_x(FROM_A, FROM_NORTHWEST_NORTHWEST_MAX)
#define FROM_A_WEST_NORTHWEST_MAX		FROM_x(FROM_A, FROM_WEST_NORTHWEST_MAX)
#define FROM_A_NORTHWEST_MAX_NORTH		FROM_x(FROM_A, FROM_NORTHWEST_MAX_NORTH)
#define FROM_A_NORTHWEST_MAX_NORTHWEST	FROM_x(FROM_A, FROM_NORTHWEST_MAX_NORTHWEST)
#define FROM_A_NORTHWEST_MAX_WEST		FROM_x(FROM_A, FROM_NORTHWEST_MAX_WEST)

#define FROM_B_NORTH_NORTH		FROM_x(FROM_B, FROM_NORTH_NORTH)
#define FROM_B_NORTH_NORTHWEST		FROM_x(FROM_B, FROM_NORTH_NORTHWEST)
#define	FROM_B_WEST_NORTHWEST		FROM_x(FROM_B, FROM_WEST_NORTHWEST)
#define FROM_B_WEST_WEST		FROM_x(FROM_B, FROM_WEST_WEST)
#define FROM_B_NORTHWEST_NORTH		FROM_x(FROM_B, FROM_NORTHWEST_NORTH)
#define FROM_B_NORTHWEST_NORTHWEST	FROM_x(FROM_B, FROM_NORTHWEST_NORTHWEST)
#define FROM_B_NORTHWEST_WEST		FROM_x(FROM_B, FROM_NORTHWEST_WEST)
#define FROM_B_NORTHWEST_MAX_NORTH		FROM_x(FROM_B, FROM_NORTHWEST_MAX_NORTH)
#define FROM_B_NORTHWEST_MAX_NORTHWEST	FROM_x(FROM_B, FROM_NORTHWEST_MAX_NORTHWEST)
#define FROM_B_NORTHWEST_MAX_WEST		FROM_x(FROM_B, FROM_NORTHWEST_MAX_WEST)
#define FROM_B_NORTH_NORTHWEST_MAX		FROM_x(FROM_B, FROM_NORTH_NORTHWEST_MAX)
#define FROM_B_NORTHWEST_NORTHWEST_MAX	FROM_x(FROM_B, FROM_NORTHWEST_NORTHWEST_MAX)
#define FROM_B_WEST_NORTHWEST_MAX		FROM_x(FROM_B, FROM_WEST_NORTHWEST_MAX)
#define FROM_B_NORTHWEST_MAX_NORTH		FROM_x(FROM_B, FROM_NORTHWEST_MAX_NORTH)
#define FROM_B_NORTHWEST_MAX_NORTHWEST	FROM_x(FROM_B, FROM_NORTHWEST_MAX_NORTHWEST)
#define FROM_B_NORTHWEST_MAX_WEST		FROM_x(FROM_B, FROM_NORTHWEST_MAX_WEST)


#define FROM_C_NORTH_NORTH		FROM_x(FROM_C, FROM_NORTH_NORTH)
#define FROM_C_NORTH_NORTHWEST		FROM_x(FROM_C, FROM_NORTH_NORTHWEST)
#define	FROM_C_WEST_NORTHWEST		FROM_x(FROM_C, FROM_WEST_NORTHWEST)
#define FROM_C_WEST_WEST		FROM_x(FROM_C, FROM_WEST_WEST)
#define FROM_C_NORTHWEST_NORTH		FROM_x(FROM_C, FROM_NORTHWEST_NORTH)
#define FROM_C_NORTHWEST_NORTHWEST	FROM_x(FROM_C, FROM_NORTHWEST_NORTHWEST)
#define FROM_C_NORTHWEST_WEST		FROM_x(FROM_C, FROM_NORTHWEST_WEST)
#define FROM_C_NORTHWEST_MAX_NORTH		FROM_x(FROM_C, FROM_NORTHWEST_MAX_NORTH)
#define FROM_C_NORTHWEST_MAX_NORTHWEST	FROM_x(FROM_C, FROM_NORTHWEST_MAX_NORTHWEST)
#define FROM_C_NORTHWEST_MAX_WEST		FROM_x(FROM_C, FROM_NORTHWEST_MAX_WEST)
#define FROM_C_NORTH_NORTHWEST_MAX		FROM_x(FROM_C, FROM_NORTH_NORTHWEST_MAX)
#define FROM_C_NORTHWEST_NORTHWEST_MAX	FROM_x(FROM_C, FROM_NORTHWEST_NORTHWEST_MAX)
#define FROM_C_WEST_NORTHWEST_MAX		FROM_x(FROM_C, FROM_WEST_NORTHWEST_MAX)
#define FROM_C_NORTHWEST_MAX_NORTH		FROM_x(FROM_C, FROM_NORTHWEST_MAX_NORTH)
#define FROM_C_NORTHWEST_MAX_NORTHWEST	FROM_x(FROM_C, FROM_NORTHWEST_MAX_NORTHWEST)
#define FROM_C_NORTHWEST_MAX_WEST		FROM_x(FROM_C, FROM_NORTHWEST_MAX_WEST)

#define FROM_D_NORTH_NORTH		FROM_x(FROM_D, FROM_NORTH_NORTH)
#define FROM_D_NORTH_NORTHWEST		FROM_x(FROM_D, FROM_NORTH_NORTHWEST)
#define	FROM_D_WEST_NORTHWEST		FROM_x(FROM_D, FROM_WEST_NORTHWEST)
#define FROM_D_WEST_WEST		FROM_x(FROM_D, FROM_WEST_WEST)
#define FROM_D_NORTHWEST_NORTH		FROM_x(FROM_D, FROM_NORTHWEST_NORTH)
#define FROM_D_NORTHWEST_NORTHWEST	FROM_x(FROM_D, FROM_NORTHWEST_NORTHWEST)
#define FROM_D_NORTHWEST_WEST		FROM_x(FROM_D, FROM_NORTHWEST_WEST)
#define FROM_D_NORTHWEST_MAX_NORTH		FROM_x(FROM_D, FROM_NORTHWEST_MAX_NORTH)
#define FROM_D_NORTHWEST_MAX_NORTHWEST	FROM_x(FROM_D, FROM_NORTHWEST_MAX_NORTHWEST)
#define FROM_D_NORTHWEST_MAX_WEST		FROM_x(FROM_D, FROM_NORTHWEST_MAX_WEST)
#define FROM_D_NORTH_NORTHWEST_MAX		FROM_x(FROM_D, FROM_NORTH_NORTHWEST_MAX)
#define FROM_D_NORTHWEST_NORTHWEST_MAX	FROM_x(FROM_D, FROM_NORTHWEST_NORTHWEST_MAX)
#define FROM_D_WEST_NORTHWEST_MAX		FROM_x(FROM_D, FROM_WEST_NORTHWEST_MAX)
#define FROM_D_NORTHWEST_MAX_NORTH		FROM_x(FROM_D, FROM_NORTHWEST_MAX_NORTH)
#define FROM_D_NORTHWEST_MAX_NORTHWEST	FROM_x(FROM_D, FROM_NORTHWEST_MAX_NORTHWEST)
#define FROM_D_NORTHWEST_MAX_WEST		FROM_x(FROM_D, FROM_NORTHWEST_MAX_WEST)

enum {
  BACK_INSERTION = 1,
  BACK_A_DELETION,
  BACK_B_DELETION,
  BACK_C_DELETION,
  BACK_D_DELETION,
  BACK_A_MATCH_MISMATCH,
  BACK_B_MATCH_MISMATCH,
  BACK_C_MATCH_MISMATCH,
  BACK_D_MATCH_MISMATCH,
  //BACK_N,
  //BACK_DELETION,
  //BACK_MATCH_MISMATCH
};

#define BACK_I			0xA
#define BACK_D			0xB
#define BACK_MM			0xC
#define BACK_N			0xD //for splice cigar N
#define BACK_I_N		0xE

static int		initialised;
static int8_t	       *db, *qr[4];
static int		dblen, qrlen;
static int		gap_open, gap_ext;
static int		split_penalty_ins, split_penalty_del_double,split_penalty_del_large;
static int		match, mismatch;
static int		xover_penalty;
static struct swcell   *swmatrix;
static uint8_t	       *backtrace;
static char	       *dbalign, *qralign, *qr_seq, *sv_seq;
static int anchor_width;
static int gap_size;
static int ins_len_thresh;
/* statistics */
static uint64_t		swticks, swcells, swinvocs;

#define BT_CROSSOVER		0x80
#define BT_ISCROSSOVER(_x)	((_x) & BT_CROSSOVER)
#define BT_TYPE(_x)		((_x) & 0x0f)

inline static void
init_cell(int idx) {
  swmatrix[idx].from[0].score_nw = 0;
  swmatrix[idx].from[0].score_n  = 0;//-gap_open;
  swmatrix[idx].from[0].score_w  = 0;//-gap_open;
  swmatrix[idx].from[1].score_nw = xover_penalty;//xover_penalty;
  swmatrix[idx].from[1].score_n  = xover_penalty;//-gap_open + xover_penalty;
  swmatrix[idx].from[1].score_w  = xover_penalty;//-gap_open + xover_penalty;
  swmatrix[idx].from[2].score_nw = xover_penalty;//xover_penalty;
  swmatrix[idx].from[2].score_n  = xover_penalty;//-gap_open + xover_penalty;
  swmatrix[idx].from[2].score_w  = xover_penalty;//-gap_open + xover_penalty;
  swmatrix[idx].from[3].score_nw = xover_penalty;//xover_penalty;
  swmatrix[idx].from[3].score_n  = xover_penalty;//-gap_open + xover_penalty;
  swmatrix[idx].from[3].score_w  = xover_penalty;//-gap_open + xover_penalty;

  swmatrix[idx].from[0].back_nw = 0;
  swmatrix[idx].from[0].back_n  = 0;
  swmatrix[idx].from[0].back_w  = 0;
  swmatrix[idx].from[1].back_nw = 0;
  swmatrix[idx].from[1].back_n  = 0;
  swmatrix[idx].from[1].back_w  = 0;
  swmatrix[idx].from[2].back_nw = 0;
  swmatrix[idx].from[2].back_n  = 0;
  swmatrix[idx].from[2].back_w  = 0;
  swmatrix[idx].from[3].back_nw = 0;
  swmatrix[idx].from[3].back_n  = 0;
  swmatrix[idx].from[3].back_w  = 0;
}
/*
 * Perform a full split Smith-Waterman alignment. For the colour case, this means
 * computing each possible letter space read string and doing a four layer
 * scan.
 */
static int
split_sw_del(int lena, int lenb,  int *iret, int *jret,	int *kret, bool revcmpl,int x,int overlap_start)
{
  int i, j, k, l, max_i, max_j, max_k,idx;
  int score, ms, go, ge, tmp, tmp_pos, resetval;
  //int sw_band, ne_band;
  int8_t tmp2;
  int split_penalty;
  revcmpl=0;

  /* shut up gcc */
  max_i = max_j = max_k = j = 0;
  split_penalty=split_penalty_del_large;
  score = WORST_SCORE;
  go = gap_open;
  ge = gap_ext;

  /*initialize the matrix -infinity*/
  for(i=0;i<(lena+1)*(lenb+1);i++){
  	  swmatrix[i].from[0].score_n = WORST_SCORE;
  	  swmatrix[i].from[0].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[0].score_w  = WORST_SCORE;
  	  swmatrix[i].from[0].score_nw_max  = WORST_SCORE;
  	  swmatrix[i].from[1].score_n = WORST_SCORE;
  	  swmatrix[i].from[1].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[1].score_w  = WORST_SCORE;
  	  swmatrix[i].from[1].score_nw_max  = WORST_SCORE;
  	  swmatrix[i].from[2].score_n = WORST_SCORE;
  	  swmatrix[i].from[2].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[2].score_w  = WORST_SCORE;
  	  swmatrix[i].from[2].score_nw_max  = WORST_SCORE;
  	  swmatrix[i].from[3].score_n = WORST_SCORE;
  	  swmatrix[i].from[3].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[3].score_w  = WORST_SCORE;
  	  swmatrix[i].from[3].score_nw_max  = WORST_SCORE;
  }

  init_cell(0);
  for (i = 1; i < lena + 1; i++) {
	  //init_cell(j);
	  	  idx=i;

		swmatrix[idx].from[0].score_w  = 0;
		swmatrix[idx].from[1].score_w  = 0;
		swmatrix[idx].from[2].score_w  = 0;
		swmatrix[idx].from[3].score_w  = 0;

		swmatrix[idx].from[0].back_nw = 0;
		swmatrix[idx].from[0].back_n  = 0;
		swmatrix[idx].from[0].back_w  = FROM_A_WEST_WEST;
		swmatrix[idx].from[0].back_nw_max = 0;
		swmatrix[idx].from[1].back_nw = 0;
		swmatrix[idx].from[1].back_n  = 0;
		swmatrix[idx].from[1].back_w  = FROM_B_WEST_WEST;
		swmatrix[idx].from[1].back_nw_max = 0;
		swmatrix[idx].from[2].back_nw = 0;
		swmatrix[idx].from[2].back_n  = 0;
		swmatrix[idx].from[2].back_w  = FROM_C_WEST_WEST;
		swmatrix[idx].from[2].back_nw_max = 0;
		swmatrix[idx].from[3].back_nw = 0;
		swmatrix[idx].from[3].back_n  = 0;
		swmatrix[idx].from[3].back_w  = FROM_D_WEST_WEST;
		swmatrix[idx].from[3].back_nw_max = 0;
  }

  for (j = 1; j < lenb + 1; j++) {
	  //init_cell(j * (lena + 1));
	  int idx=j * (lena + 1);
	  	swmatrix[idx].from[0].score_n = -gap_open-j*gap_ext;
		swmatrix[idx].from[0].score_nw  = WORST_SCORE;
		swmatrix[idx].from[0].score_w  = WORST_SCORE;
		swmatrix[idx].from[1].score_n = -gap_open-j*gap_ext+xover_penalty;
		swmatrix[idx].from[1].score_nw  = WORST_SCORE ;
		swmatrix[idx].from[1].score_w  = WORST_SCORE ;
		swmatrix[idx].from[2].score_n = -gap_open-j*gap_ext+xover_penalty;
		swmatrix[idx].from[2].score_nw  = WORST_SCORE ;
		swmatrix[idx].from[2].score_w  = WORST_SCORE ;
		swmatrix[idx].from[3].score_n = -gap_open-j*gap_ext+xover_penalty;
		swmatrix[idx].from[3].score_nw  = WORST_SCORE;
		swmatrix[idx].from[3].score_w  = WORST_SCORE ;

		swmatrix[idx].from[0].back_nw = 0;
		swmatrix[idx].from[0].back_n  = FROM_A_NORTH_NORTH;
		swmatrix[idx].from[0].back_w  = 0;
		swmatrix[idx].from[0].back_nw_max = 0;
		swmatrix[idx].from[1].back_nw = 0;
		swmatrix[idx].from[1].back_n  = FROM_B_NORTH_NORTH;
		swmatrix[idx].from[1].back_w  = 0;
		swmatrix[idx].from[1].back_nw_max = 0;
		swmatrix[idx].from[2].back_nw = 0;
		swmatrix[idx].from[2].back_n  = FROM_C_NORTH_NORTH;
		swmatrix[idx].from[2].back_w  = 0;
		swmatrix[idx].from[2].back_nw_max = 0;
		swmatrix[idx].from[3].back_nw = 0;
		swmatrix[idx].from[3].back_n  = FROM_D_NORTH_NORTH;
		swmatrix[idx].from[3].back_w  = 0;
		swmatrix[idx].from[3].back_nw_max = 0;
  }



  /*
   * Figure out our band.
   *   We can actually skip computation of a significant number of
   *   cells, which could never be part of an alignment corresponding
   *   to our threshhold score.
   */
  //sw_band = ((lenb * match - threshscore + match - 1) / match) + 1;
  //ne_band = lena - (lenb - sw_band);



  for (i = 0; i < lenb; i++) {
    /*
     * computing row i of virtual matrix, stored in row i+1
     */


    for (j = 0; j < x; j++) {
      /*
       * computing column j of virtual matrix, stored in column j+1
       */
      struct swcell *cell_nw, *cell_n, *cell_w, *cell_cur;

      cell_nw  = &swmatrix[i * (lena + 1) + j];
      cell_n   = cell_nw + 1;
      cell_w   = cell_nw + (lena + 1);
      cell_cur = cell_w + 1;

      /* banding */
      //if (i >= sw_band + j) {
      //memset(cell_cur, 0, sizeof(*cell_cur));
      //continue;
      //}
      //if (j >= ne_band + i) {
      //memset(cell_cur, 0, sizeof(*cell_cur));
      //break;
      //}

    for (k = 0; k < 4; k++) {


	/*
	 * northwest
	 */
	ms = (db[j] == qr[k][i]) ? match : mismatch;

	if (!revcmpl) {
	  tmp  = cell_nw->from[k].score_nw + ms;
	  tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);

	  if (cell_nw->from[k].score_n + ms > tmp) {
	    tmp  = cell_nw->from[k].score_n + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
	  }

	  if (cell_nw->from[k].score_w + ms > tmp) {
	    tmp  = cell_nw->from[k].score_w + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);
	  }
	} else {
	  tmp  = cell_nw->from[k].score_w + ms;
	  tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);

	  if (cell_nw->from[k].score_n + ms > tmp) {
	    tmp  = cell_nw->from[k].score_n + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
	  }

	  if (cell_nw->from[k].score_nw + ms > tmp) {
	    tmp  = cell_nw->from[k].score_nw + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);
	  }
	}

	/* check neighbours */
	for (l = 0; l < 4; l++) {
	  if (l == k)
	    continue;

	  if (!revcmpl) {
	    /* northwest */
	    if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
	    }

	    /* north */
	    if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
	    }

	    /* west */
	    if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
	    }
	  } else {
	    /* west */
	    if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
	    }

	    /* north */
	    if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
	    }

	    /* northwest */
	    if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
	    }
	  }
	}

	if (tmp <= resetval) {
	  //tmp = resetval;
	  //tmp2 = 0;
	}

	cell_cur->from[k].score_nw = tmp;
	cell_cur->from[k].back_nw  = tmp2;
	cell_cur->from[k].pos = -1;

	/*
	 * north
	 */
	if (!revcmpl) {
	  tmp  = cell_n->from[k].score_nw - go - ge;
	  tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST);

	  if (cell_n->from[k].score_n - ge > tmp) {
	    tmp  = cell_n->from[k].score_n - ge;
	    tmp2 = FROM_x(k, FROM_NORTH_NORTH);
	  }
	} else {
	  tmp  = cell_n->from[k].score_n - ge;
	  tmp2 = FROM_x(k, FROM_NORTH_NORTH);

	  if (cell_n->from[k].score_nw - go - ge > tmp) {
	    tmp  = cell_n->from[k].score_nw - go - ge;
	    tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST);
	  }
	}

	/* check neighbours */
	for (l = 0; l < 4; l++) {
	  if (l == k)
	    continue;

	  if (!revcmpl) {
	    /* northwest */
	    if (cell_n->from[l].score_nw - go - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_nw - go - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST);
	    }

	    /* north */
	    if (cell_n->from[l].score_n - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_n - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTH);
	    }
	  } else {
	    /* north */
	    if (cell_n->from[l].score_n - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_n - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTH);
	    }

	    /* northwest */
	    if (cell_n->from[l].score_nw - go - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_nw - go - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST);
	    }
	  }
	}

	if (tmp <= resetval) {
	  //tmp = resetval;
	  //tmp2 = 0;
	}

	cell_cur->from[k].score_n = tmp;
	cell_cur->from[k].back_n  = tmp2;
	cell_cur->from[k].pos = -1;

	/*
	 * west
	 */
	if (!revcmpl) {
	  tmp  = cell_w->from[k].score_nw - go - ge;
	  tmp2 = FROM_x(k, FROM_WEST_NORTHWEST);

	  if (cell_w->from[k].score_w - ge > tmp) {
	    tmp  = cell_w->from[k].score_w - ge;
	    tmp2 = FROM_x(k, FROM_WEST_WEST);
	  }
	} else {
	  tmp  = cell_w->from[k].score_w - ge;
	  tmp2 = FROM_x(k, FROM_WEST_WEST);

	  if (cell_w->from[k].score_nw - go - ge > tmp) {
	    tmp  = cell_w->from[k].score_nw - go - ge;
	    tmp2 = FROM_x(k, FROM_WEST_NORTHWEST);
	  }
	}

	/*
	 * NB: It doesn't make sense to cross over on a
	 *     genomic gap, so we won't.
	 */

	if (tmp <= resetval) {
	  //tmp = resetval;
	  //tmp2 = 0;
	}

	cell_cur->from[k].score_w = tmp;
	cell_cur->from[k].back_w  = tmp2;
	cell_cur->from[k].pos = -1;



#ifdef DEBUG_SW
	fprintf(stderr, "i:%d j:%d k:%d score_nw:%d [%u,%s] score_n:%d [%u,%s] score_w:%d [%u,%s] \n", i+1, j+1, k,
		cell_cur->from[k].score_nw, cell_cur->from[k].back_nw & 0x3,
		(cell_cur->from[k].back_nw >> 2 == 0 ? "!" :
		 (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTH ? "n" :
		  (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTHWEST ? "nw" : "w"))),

		cell_cur->from[k].score_n, cell_cur->from[k].back_n & 0x3,
		(cell_cur->from[k].back_n >> 2 == 0 ? "!" :
		 (cell_cur->from[k].back_n >> 2 == FROM_NORTH_NORTH ? "n" : "nw")),

		cell_cur->from[k].score_w, cell_cur->from[k].back_w & 0x3,
		(cell_cur->from[k].back_w >> 2 == 0 ? "!" :
		 (cell_cur->from[k].back_w >> 2 == FROM_WEST_NORTHWEST ? "nw" : "w")));
#endif

      }// l

    }//j


  }//i
  /*
  for(i=0;i<(lena+1)*(lenb+1);i++){
	  for(j=0;j<1;j++){
		  printf("%i:%i,",i,swmatrix[i].from[j].score_nw);
		  printf("%i,",swmatrix[i].from[j].score_n);
		  printf("%i,",swmatrix[i].from[j].score_w);
		  //printf("%i,",swmatrix[i].score_northwest_max);

		  printf("\t");
	  }
 	  if((i+1)%(lena+1)==0&&i>0){
 		  printf("\n");
 	  }
  }*/

  /**
   * 	cal the max_l
   */
  /*
	struct max_t max_w[4];
	for(k=0;k<4;k++){
		max_w[k].pos=-1;
		max_w[k].score=WORST_SCORE;
	}
	*/
	for (j = 1; j < lenb + 1; j++) {
		  //init_cell(j * (lena + 1));
			int idx=j * (lena + 1)+x;
			swmatrix[idx].from[0].score_n = -gap_open-j*gap_ext;
			swmatrix[idx].from[0].score_nw  = WORST_SCORE;
			swmatrix[idx].from[0].score_w  = WORST_SCORE;
			swmatrix[idx].from[1].score_n = -gap_open-j*gap_ext+xover_penalty;
			swmatrix[idx].from[1].score_nw  = WORST_SCORE ;
			swmatrix[idx].from[1].score_w  = WORST_SCORE ;
			swmatrix[idx].from[2].score_n = -gap_open-j*gap_ext+xover_penalty;
			swmatrix[idx].from[2].score_nw  = WORST_SCORE ;
			swmatrix[idx].from[2].score_w  = WORST_SCORE ;
			swmatrix[idx].from[3].score_n = -gap_open-j*gap_ext+xover_penalty;
			swmatrix[idx].from[3].score_nw  = WORST_SCORE;
			swmatrix[idx].from[3].score_w  = WORST_SCORE ;

			swmatrix[idx].from[0].back_nw = 0;
			swmatrix[idx].from[0].back_n  = FROM_A_NORTH_NORTH;
			swmatrix[idx].from[0].back_w  = 0;
			swmatrix[idx].from[0].back_nw_max = 0;
			swmatrix[idx].from[1].back_nw = 0;
			swmatrix[idx].from[1].back_n  = FROM_B_NORTH_NORTH;
			swmatrix[idx].from[1].back_w  = 0;
			swmatrix[idx].from[1].back_nw_max = 0;
			swmatrix[idx].from[2].back_nw = 0;
			swmatrix[idx].from[2].back_n  = FROM_C_NORTH_NORTH;
			swmatrix[idx].from[2].back_w  = 0;
			swmatrix[idx].from[2].back_nw_max = 0;
			swmatrix[idx].from[3].back_nw = 0;
			swmatrix[idx].from[3].back_n  = FROM_D_NORTH_NORTH;
			swmatrix[idx].from[3].back_w  = 0;
			swmatrix[idx].from[3].back_nw_max = 0;
	}


	/*j>x*/
	struct max_t max_w[4];
	struct swcell *cell_max_w;
	for (i = 0; i < lenb; i++) {
	    /*
	     * computing row i of virtual matrix, stored in row i+1
	     */
		struct swcell *tmp_cell;
		/*
		for(k=0;k<4;k++){
			for (j = x; j < lena; j++) {
				tmp_cell=(&swmatrix[i * (lena + 1) + (j-x)]);
				if(tmp_cell->from[k].score_nw>max_w[k].score){
					max_w[k].score=tmp_cell->from[k].score_nw;
					max_w[k].pos=j-x;
				}
			}
		}*/
		for(k=0;k<4;k++){
			max_w[k].score=WORST_SCORE;//WORST_SCORE;
			max_w[k].pos=-1;
			//max_w.multi=1;
			int m;
			for(m=0;m<overlap_start-2;m++){
				cell_max_w=(&swmatrix[i * (lena + 1) + m]);
				if(max_w[k].score<=cell_max_w->from[k].score_nw){
						if(cell_max_w->from[k].score_nw == max_w[k].score){
							max_w[k].multi++;
						}else{
							max_w[k].multi=1;
						}
						max_w[k].score=(&swmatrix[(i) * (lena + 1) + m])->from[k].score_nw;
						max_w[k].pos=m;
				}
			}
		}
		//for(m=0;m<x+1;m++){

	  for (j = x; j < lena; j++) {
	      /*
	       * computing column j of virtual matrix, stored in column j+1
	       */
	      struct swcell *cell_nw, *cell_n, *cell_w, *cell_cur;

	      cell_nw  = &swmatrix[i * (lena + 1) + j];
	      cell_n   = cell_nw + 1;
	      cell_w   = cell_nw + (lena + 1);
	      cell_cur = cell_w + 1;
	      for(k=0;k<4;k++){
		  if((j-x)+overlap_start-2>0 && (j-x)+overlap_start<=x){//in overlap region
			cell_max_w=(&swmatrix[i * (lena + 1) + (j-x)+overlap_start-2]);
			if(cell_max_w->from[k].score_nw >= max_w[k].score){
				//max_w.score=(&swmatrix[(i) * (lena + 1) + (j-x)+overlap_start-2])->score_northwest;
				//max_w.pos=j-x+overlap_start-2;
				if(cell_max_w->from[k].score_nw == max_w[k].score){
					max_w[k].multi++;
				}else{
					max_w[k].multi=1;
				}
				max_w[k].score=cell_max_w->from[k].score_nw;//(&swmatrix[(i) * (lena + 1) + (j-x)+overlap_start-2])->score_northwest;
				max_w[k].pos=j-x+overlap_start-2;
			}
		  }
	      }	
	  for (k = 0; k < 4; k++) {
		/*
		 * northwest
		 */
		ms = (db[j] == qr[k][i]) ? match : mismatch;
		//why treat revcmp different?
		if (!revcmpl) {
		  tmp  = cell_nw->from[k].score_nw + ms;
		  tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);

		  if (cell_nw->from[k].score_n + ms > tmp) {
		    tmp  = cell_nw->from[k].score_n + ms;
		    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
		  }

		  if (cell_nw->from[k].score_w + ms > tmp) {
		    tmp  = cell_nw->from[k].score_w + ms;
		    tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);
		  }
		  if (cell_nw->from[k].score_nw_max + ms > tmp) {
			tmp  = cell_nw->from[k].score_nw_max + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST_MAX);
		  }
		} else {
			tmp  = cell_nw->from[k].score_nw + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);

			if (cell_nw->from[k].score_n + ms > tmp) {
			tmp  = cell_nw->from[k].score_n + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
			}

			if (cell_nw->from[k].score_w + ms > tmp) {
			tmp  = cell_nw->from[k].score_w + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);
			}
			if (cell_nw->from[k].score_nw_max + ms > tmp) {
			tmp  = cell_nw->from[k].score_nw_max + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST_MAX);
			}
		}

		/* check neighbours */
		for (l = 0; l < 4; l++) {
		  if (l == k)
		    continue;

		  if (!revcmpl) {
		    /* northwest */
		    if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
		      tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
		      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
		    }

		    /* north */
		    if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
		      tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
		      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
		    }

		    /* west */
		    if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
		      tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
		      tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
		    }
		    /* northwest_max */
		    if (cell_nw->from[l].score_nw_max + ms + xover_penalty > tmp) {
			  tmp  = cell_nw->from[l].score_nw_max + ms + xover_penalty;
			  tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST_MAX);
			}
		  } else {
			/* northwest */
			if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
			}

			/* north */
			if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
			}

			/* west */
			if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
			}
			/* northwest_max */
			if (cell_nw->from[l].score_nw_max + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_nw_max + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST_MAX);
			}
		  }
		}


		cell_cur->from[k].score_nw = tmp;
		cell_cur->from[k].back_nw  = tmp2;

		/*
		 * northwest_max
		 */

		if (!revcmpl) {

			//tmp  = max_l[i].max[k].score + ms;
			tmp = max_w[k].score+ms+split_penalty;
			tmp2 = FROM_x(k, FROM_NORTHWEST_MAX_NORTHWEST);
			tmp_pos=max_w[k].pos;

		} else {

			//tmp  = max_l[i].max[k].score + ms;
			//tmp2 = FROM_x(k, FROM_NORTHWEST_MAX_NORTHWEST);

		}

		/* check neighbours */
		for (l = 0; l < 4; l++) {
		  if (l == k)
			continue;
		  if (!revcmpl) {
			if(max_w[l].score + ms + xover_penalty > tmp){
				tmp  = max_w[l].score + ms + xover_penalty+split_penalty;
				tmp2 = FROM_x(l, FROM_NORTHWEST_MAX_NORTHWEST);
				tmp_pos=max_w[l].pos;
			}

			//one read can't jump twice, so there is no northwest_max here.

		  } else {

		  }
		  /*
		  if (!revcmpl) {
			if(max_l[i].max[k].score + ms + xover_penalty > tmp){
				tmp  = max_l[i].max[k].score + ms + xover_penalty;
				tmp2 = FROM_x(l, FROM_NORTHWEST_MAX_NORTHWEST);
			}

			//one read can't jump twice, so there is no northwest_max here.

		  } else {
			if(max_l[i].max[k].score + ms + xover_penalty > tmp){
				tmp  = max_l[i].max[k].score + ms + xover_penalty;
				tmp2 = FROM_x(l, FROM_NORTHWEST_MAX_NORTHWEST);
			}
		  }*/
		}

		//tmp+=3*(mismatch-match);//punish the big N-gap

		cell_cur->from[k].score_nw_max = tmp;
		cell_cur->from[k].back_nw_max  = tmp2;
		cell_cur->from[k].pos = tmp_pos;
		/*
		 * north
		 */
		if (!revcmpl) {
		  tmp  = cell_n->from[k].score_nw - go - ge;
		  tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST);

		  if (cell_n->from[k].score_n - ge > tmp) {
		    tmp  = cell_n->from[k].score_n - ge;
		    tmp2 = FROM_x(k, FROM_NORTH_NORTH);
		  }
		  if (cell_n->from[k].score_nw_max - go - ge > tmp) {
			tmp  = cell_n->from[k].score_nw_max - go - ge > tmp;
			tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST_MAX);
		  }
		} else {
		  tmp  = cell_n->from[k].score_nw - go - ge;
		  tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST);

		  if (cell_n->from[k].score_n - ge > tmp) {
			tmp  = cell_n->from[k].score_n - ge;
			tmp2 = FROM_x(k, FROM_NORTH_NORTH);
		  }
		  if (cell_n->from[k].score_nw_max - go - ge > tmp) {
			tmp  = cell_n->from[k].score_nw_max - go - ge > tmp;
			tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST_MAX);
		  }
		}

		/* check neighbours */
		for (l = 0; l < 4; l++) {
			if (l == k)
			continue;

			if (!revcmpl) {
				/* northwest */
				if (cell_n->from[l].score_nw - go - ge + xover_penalty > tmp) {
				  tmp  = cell_n->from[l].score_nw - go - ge + xover_penalty;
				  tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST);
				}

				/* north */
				if (cell_n->from[l].score_n - ge + xover_penalty > tmp) {
				  tmp  = cell_n->from[l].score_n - ge + xover_penalty;
				  tmp2 = FROM_x(l, FROM_NORTH_NORTH);
				}
				/* northwest_max */
				if (cell_n->from[l].score_nw_max - go - ge + xover_penalty > tmp) {
				  tmp  = cell_n->from[l].score_nw_max - go - ge + xover_penalty ;
				  tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST_MAX);
				}
			} else {
				/* northwest */
				if (cell_n->from[l].score_nw - go - ge + xover_penalty > tmp) {
				tmp  = cell_n->from[l].score_nw - go - ge + xover_penalty;
				tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST);
				}

				/* north */
				if (cell_n->from[l].score_n - ge + xover_penalty > tmp) {
				tmp  = cell_n->from[l].score_n - ge + xover_penalty;
				tmp2 = FROM_x(l, FROM_NORTH_NORTH);
				}
				/* northwest_max */
				if (cell_n->from[l].score_nw_max - go - ge + xover_penalty > tmp) {
				tmp  = cell_n->from[l].score_nw_max - go - ge + xover_penalty ;
				tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST_MAX);
				}
		  }
		}


		cell_cur->from[k].score_n = tmp;
		cell_cur->from[k].back_n  = tmp2;

		/*
		 * west
		 */
		if (!revcmpl) {
			tmp  = cell_w->from[k].score_nw - go - ge;
			tmp2 = FROM_x(k, FROM_WEST_NORTHWEST);
			if (cell_w->from[k].score_w - ge > tmp) {
			tmp  = cell_w->from[k].score_w - ge;
			tmp2 = FROM_x(k, FROM_WEST_WEST);
			}
			if (cell_w->from[k].score_nw_max - go - ge > tmp) {
			  tmp  = cell_w->from[k].score_nw_max - go - ge > tmp;
			  tmp2 = FROM_x(k, FROM_WEST_NORTHWEST_MAX);
			  //printf("FROM==k:%i\tFROM_WEST_NORTHWEST_MAX:%i\tfrom:%i\n",k, FROM_x(k, FROM_WEST_NORTHWEST_MAX), FROM_x(k, FROM_WEST_NORTHWEST_MAX));
			}
		} else {
			tmp  = cell_w->from[k].score_nw - go - ge;
			tmp2 = FROM_x(k, FROM_WEST_NORTHWEST);
			if (cell_w->from[k].score_w - ge > tmp) {
			tmp  = cell_w->from[k].score_w - ge;
			tmp2 = FROM_x(k, FROM_WEST_WEST);
			}
			if (cell_w->from[k].score_nw_max - go - ge > tmp) {
			  tmp  = cell_w->from[k].score_nw_max - go - ge > tmp;
			  tmp2 = FROM_x(k, FROM_WEST_NORTHWEST_MAX);
			  //printf("FROM==k:%i\tFROM_WEST_NORTHWEST_MAX:%i\tfrom:%i\n",k, FROM_x(k, FROM_WEST_NORTHWEST_MAX), FROM_x(k, FROM_WEST_NORTHWEST_MAX));
			}
		}

		/*
		 * NB: It doesn't make sense to cross over on a
		 *     genomic gap, so we won't.
		 */

		cell_cur->from[k].score_w = tmp;
		cell_cur->from[k].back_w  = tmp2;
		/*
		 * max score
		 */
		if(i==lenb-1){

		  if (cell_cur->from[k].score_nw > score) {
			score = cell_cur->from[k].score_nw;
			max_i = i, max_j = j, max_k = k;
		  }
		  if (cell_cur->from[k].score_n > score) {
			score = cell_cur->from[k].score_n;
			max_i = i, max_j = j, max_k = k;
		  }
		  if (cell_cur->from[k].score_w > score) {
			score = cell_cur->from[k].score_w;
			max_i = i, max_j = j, max_k = k;
		  }
		  if (cell_cur->from[k].score_nw_max > score) {
			  score = cell_cur->from[k].score_nw_max;
			  max_i = i, max_j = j, max_k = k;
		  }
		}


	#ifdef DEBUG_SW
		fprintf(stderr, "i:%d j:%d k:%d score_nw:%d [%u,%s] score_n:%d [%u,%s] score_w:%d [%u,%s] \n", i+1, j+1, k,
			cell_cur->from[k].score_nw, cell_cur->from[k].back_nw & 0x3,
			(cell_cur->from[k].back_nw >> 2 == 0 ? "!" :
			 (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTH ? "n" :
			  (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTHWEST ? "nw" : "w"))),

			cell_cur->from[k].score_n, cell_cur->from[k].back_n & 0x3,
			(cell_cur->from[k].back_n >> 2 == 0 ? "!" :
			 (cell_cur->from[k].back_n >> 2 == FROM_NORTH_NORTH ? "n" : "nw")),

			cell_cur->from[k].score_w, cell_cur->from[k].back_w & 0x3,
			(cell_cur->from[k].back_w >> 2 == 0 ? "!" :
			 (cell_cur->from[k].back_w >> 2 == FROM_WEST_NORTHWEST ? "nw" : "w")));
	#endif

	      }// k

	    }//j


	  }

#ifdef DEBUG_SW
  fprintf(stderr, "max_i:%d max_j:%d max_k:%d\n", max_i, max_j, max_k);
#endif
  printf("max:%i\t%i\t%i\t\n",max_i,max_j,max_k);
  *iret = lenb;
  *jret = max_j;
  *kret = max_k;
  /*
  for(i=0;i<(lena+1)*(lenb+1);i++){
	  for(j=0;j<4;j++){
		  printf("%i:%i,",i,swmatrix[i].from[j].score_nw);
		  printf("%i,",swmatrix[i].from[j].score_n);
		  printf("%i,",swmatrix[i].from[j].score_w);
		  printf("%i,",swmatrix[i].from[j].score_nw_max);

		  printf("\t");
	  }
	  if((i+1)%(lena+1)==0&&i>0){
		  printf("\n");
	  }
  }
  for(i=0;i<(lena+1)*(lenb+1);i++){
  	  for(j=0;j<4;j++){
  		  printf("%i:%i,",i,swmatrix[i].from[j].back_nw);
  		  printf("%i,",swmatrix[i].from[j].back_n);
  		  printf("%i,",swmatrix[i].from[j].back_w);
  		  printf("%i,",swmatrix[i].from[j].back_nw_max);

  		  printf("\t");
  	  }
  	  if((i+1)%(lena+1)==0&&i>0){
  		  printf("\n");
  	  }
    }
	*/
  return (score);
}
static int
split_sw_del_double(int lena, int lenb, int *iret, int *jret,
	int *kret, bool revcmpl,int x)
{
  printf("split_sw_del_double\n");
  int i, j, k, l, max_i, max_j, max_k,idx;
  int score, ms, go, ge, tmp, tmp_pos, resetval;
  //int sw_band, ne_band;
  int8_t tmp2;

  revcmpl=0;
  /* shut up gcc */
  max_i = max_j = max_k = j = 0;

  score = WORST_SCORE;
  go = gap_open;
  ge = gap_ext;

  /*initialize the matrix -infinity*/
  for(i=0;i<(lena+1)*(lenb+1);i++){
  	  swmatrix[i].from[0].score_n = WORST_SCORE;
  	  swmatrix[i].from[0].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[0].score_w  = WORST_SCORE;
  	  swmatrix[i].from[0].score_nw_max  = WORST_SCORE;
  	  swmatrix[i].from[1].score_n = WORST_SCORE;
  	  swmatrix[i].from[1].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[1].score_w  = WORST_SCORE;
  	  swmatrix[i].from[1].score_nw_max  = WORST_SCORE;
  	  swmatrix[i].from[2].score_n = WORST_SCORE;
  	  swmatrix[i].from[2].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[2].score_w  = WORST_SCORE;
  	  swmatrix[i].from[2].score_nw_max  = WORST_SCORE;
  	  swmatrix[i].from[3].score_n = WORST_SCORE;
  	  swmatrix[i].from[3].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[3].score_w  = WORST_SCORE;
  	  swmatrix[i].from[3].score_nw_max  = WORST_SCORE;
  }

  init_cell(0);
  for (i = 1; i < lena + 1; i++) {
	  //init_cell(j);
	  	  idx=i;

		swmatrix[idx].from[0].score_w  = 0;
		swmatrix[idx].from[1].score_w  = xover_penalty;
		swmatrix[idx].from[2].score_w  = xover_penalty;
		swmatrix[idx].from[3].score_w  = xover_penalty;

		swmatrix[idx].from[0].back_nw = 0;
		swmatrix[idx].from[0].back_n  = 0;
		swmatrix[idx].from[0].back_w  = FROM_A_WEST_WEST;
		swmatrix[idx].from[0].back_nw_max = 0;
		swmatrix[idx].from[1].back_nw = 0;
		swmatrix[idx].from[1].back_n  = 0;
		swmatrix[idx].from[1].back_w  = FROM_B_WEST_WEST;
		swmatrix[idx].from[1].back_nw_max = 0;
		swmatrix[idx].from[2].back_nw = 0;
		swmatrix[idx].from[2].back_n  = 0;
		swmatrix[idx].from[2].back_w  = FROM_C_WEST_WEST;
		swmatrix[idx].from[2].back_nw_max = 0;
		swmatrix[idx].from[3].back_nw = 0;
		swmatrix[idx].from[3].back_n  = 0;
		swmatrix[idx].from[3].back_w  = FROM_D_WEST_WEST;
		swmatrix[idx].from[3].back_nw_max = 0;
  }

  for (j = 1; j < lenb + 1; j++) {
	  //init_cell(j * (lena + 1));
	  int idx=j * (lena + 1);
	  	swmatrix[idx].from[0].score_n = -gap_open-j*gap_ext;
		swmatrix[idx].from[0].score_nw  = WORST_SCORE;
		swmatrix[idx].from[0].score_w  = WORST_SCORE;
		swmatrix[idx].from[1].score_n = -gap_open-j*gap_ext+xover_penalty;
		swmatrix[idx].from[1].score_nw  = WORST_SCORE ;
		swmatrix[idx].from[1].score_w  = WORST_SCORE ;
		swmatrix[idx].from[2].score_n = -gap_open-j*gap_ext+xover_penalty;
		swmatrix[idx].from[2].score_nw  = WORST_SCORE ;
		swmatrix[idx].from[2].score_w  = WORST_SCORE ;
		swmatrix[idx].from[3].score_n = -gap_open-j*gap_ext+xover_penalty;
		swmatrix[idx].from[3].score_nw  = WORST_SCORE;
		swmatrix[idx].from[3].score_w  = WORST_SCORE ;

		swmatrix[idx].from[0].back_nw = 0;
		swmatrix[idx].from[0].back_n  = FROM_A_NORTH_NORTH;
		swmatrix[idx].from[0].back_w  = 0;
		swmatrix[idx].from[0].back_nw_max = 0;
		swmatrix[idx].from[1].back_nw = 0;
		swmatrix[idx].from[1].back_n  = FROM_B_NORTH_NORTH;
		swmatrix[idx].from[1].back_w  = 0;
		swmatrix[idx].from[1].back_nw_max = 0;
		swmatrix[idx].from[2].back_nw = 0;
		swmatrix[idx].from[2].back_n  = FROM_C_NORTH_NORTH;
		swmatrix[idx].from[2].back_w  = 0;
		swmatrix[idx].from[2].back_nw_max = 0;
		swmatrix[idx].from[3].back_nw = 0;
		swmatrix[idx].from[3].back_n  = FROM_D_NORTH_NORTH;
		swmatrix[idx].from[3].back_w  = 0;
		swmatrix[idx].from[3].back_nw_max = 0;
  }



  /*
   * Figure out our band.
   *   We can actually skip computation of a significant number of
   *   cells, which could never be part of an alignment corresponding
   *   to our threshhold score.
   */
  //sw_band = ((lenb * match - threshscore + match - 1) / match) + 1;
  //ne_band = lena - (lenb - sw_band);



  for (i = 0; i < lenb; i++) {
    /*
     * computing row i of virtual matrix, stored in row i+1
     */


    for (j = 0; j < x; j++) {
      /*
       * computing column j of virtual matrix, stored in column j+1
       */
      struct swcell *cell_nw, *cell_n, *cell_w, *cell_cur;

      cell_nw  = &swmatrix[i * (lena + 1) + j];
      cell_n   = cell_nw + 1;
      cell_w   = cell_nw + (lena + 1);
      cell_cur = cell_w + 1;

      /* banding */
      //if (i >= sw_band + j) {
      //memset(cell_cur, 0, sizeof(*cell_cur));
      //continue;
      //}
      //if (j >= ne_band + i) {
      //memset(cell_cur, 0, sizeof(*cell_cur));
      //break;
      //}

      for (k = 0; k < 4; k++) {


	/*
	 * northwest
	 */
	ms = (db[j] == qr[k][i]) ? match : mismatch;

	if (!revcmpl) {
	  tmp  = cell_nw->from[k].score_nw + ms;
	  tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);

	  if (cell_nw->from[k].score_n + ms > tmp) {
	    tmp  = cell_nw->from[k].score_n + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
	  }

	  if (cell_nw->from[k].score_w + ms > tmp) {
	    tmp  = cell_nw->from[k].score_w + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);
	  }
	} else {
	  tmp  = cell_nw->from[k].score_w + ms;
	  tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);

	  if (cell_nw->from[k].score_n + ms > tmp) {
	    tmp  = cell_nw->from[k].score_n + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
	  }

	  if (cell_nw->from[k].score_nw + ms > tmp) {
	    tmp  = cell_nw->from[k].score_nw + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);
	  }
	}

	/* check neighbours */
	for (l = 0; l < 4; l++) {
	  if (l == k)
	    continue;

	  if (!revcmpl) {
	    /* northwest */
	    if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
	    }

	    /* north */
	    if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
	    }

	    /* west */
	    if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
	    }
	  } else {
	    /* west */
	    if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
	    }

	    /* north */
	    if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
	    }

	    /* northwest */
	    if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
	    }
	  }
	}

	if (tmp <= resetval) {
	  //tmp = resetval;
	  //tmp2 = 0;
	}

	cell_cur->from[k].score_nw = tmp;
	cell_cur->from[k].back_nw  = tmp2;
	cell_cur->from[k].pos = -1;

	/*
	 * north
	 */
	if (!revcmpl) {
	  tmp  = cell_n->from[k].score_nw - go - ge;
	  tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST);

	  if (cell_n->from[k].score_n - ge > tmp) {
	    tmp  = cell_n->from[k].score_n - ge;
	    tmp2 = FROM_x(k, FROM_NORTH_NORTH);
	  }
	} else {
	  tmp  = cell_n->from[k].score_n - ge;
	  tmp2 = FROM_x(k, FROM_NORTH_NORTH);

	  if (cell_n->from[k].score_nw - go - ge > tmp) {
	    tmp  = cell_n->from[k].score_nw - go - ge;
	    tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST);
	  }
	}

	/* check neighbours */
	for (l = 0; l < 4; l++) {
	  if (l == k)
	    continue;

	  if (!revcmpl) {
	    /* northwest */
	    if (cell_n->from[l].score_nw - go - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_nw - go - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST);
	    }

	    /* north */
	    if (cell_n->from[l].score_n - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_n - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTH);
	    }
	  } else {
	    /* north */
	    if (cell_n->from[l].score_n - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_n - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTH);
	    }

	    /* northwest */
	    if (cell_n->from[l].score_nw - go - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_nw - go - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST);
	    }
	  }
	}

	if (tmp <= resetval) {
	  //tmp = resetval;
	  //tmp2 = 0;
	}

	cell_cur->from[k].score_n = tmp;
	cell_cur->from[k].back_n  = tmp2;
	cell_cur->from[k].pos = -1;

	/*
	 * west
	 */
	if (!revcmpl) {
	  tmp  = cell_w->from[k].score_nw - go - ge;
	  tmp2 = FROM_x(k, FROM_WEST_NORTHWEST);

	  if (cell_w->from[k].score_w - ge > tmp) {
	    tmp  = cell_w->from[k].score_w - ge;
	    tmp2 = FROM_x(k, FROM_WEST_WEST);
	  }
	} else {
	  tmp  = cell_w->from[k].score_w - ge;
	  tmp2 = FROM_x(k, FROM_WEST_WEST);

	  if (cell_w->from[k].score_nw - go - ge > tmp) {
	    tmp  = cell_w->from[k].score_nw - go - ge;
	    tmp2 = FROM_x(k, FROM_WEST_NORTHWEST);
	  }
	}

	/*
	 * NB: It doesn't make sense to cross over on a
	 *     genomic gap, so we won't.
	 */

	if (tmp <= resetval) {
	  //tmp = resetval;
	  //tmp2 = 0;
	}

	cell_cur->from[k].score_w = tmp;
	cell_cur->from[k].back_w  = tmp2;
	cell_cur->from[k].pos = -1;



#ifdef DEBUG_SW
	fprintf(stderr, "i:%d j:%d k:%d score_nw:%d [%u,%s] score_n:%d [%u,%s] score_w:%d [%u,%s] \n", i+1, j+1, k,
		cell_cur->from[k].score_nw, cell_cur->from[k].back_nw & 0x3,
		(cell_cur->from[k].back_nw >> 2 == 0 ? "!" :
		 (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTH ? "n" :
		  (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTHWEST ? "nw" : "w"))),

		cell_cur->from[k].score_n, cell_cur->from[k].back_n & 0x3,
		(cell_cur->from[k].back_n >> 2 == 0 ? "!" :
		 (cell_cur->from[k].back_n >> 2 == FROM_NORTH_NORTH ? "n" : "nw")),

		cell_cur->from[k].score_w, cell_cur->from[k].back_w & 0x3,
		(cell_cur->from[k].back_w >> 2 == 0 ? "!" :
		 (cell_cur->from[k].back_w >> 2 == FROM_WEST_NORTHWEST ? "nw" : "w")));
#endif

      }// l

    }//j


  }//i
  /*
  for(i=0;i<(lena+1)*(lenb+1);i++){
	  for(j=0;j<1;j++){
		  printf("%i:%i,",i,swmatrix[i].from[j].score_nw);
		  printf("%i,",swmatrix[i].from[j].score_n);
		  printf("%i,",swmatrix[i].from[j].score_w);
		  //printf("%i,",swmatrix[i].score_northwest_max);

		  printf("\t");
	  }
 	  if((i+1)%(lena+1)==0&&i>0){
 		  printf("\n");
 	  }
  }*/

  /**
   * 	cal the max_l
   */

/*  	struct max_l *max_l;
  	int m,n;
  	struct swcell *tmp_cell;
	max_l= (struct max_l *) calloc((lenb+1), sizeof(struct max_l));
	//initial max_l matritx
	for(i=0;i<lenb+1;i++){
		for(m=0;m<4;m++){
			max_l[i].max[m].score=WORST_SCORE;//max score of left part
			max_l[i].max[m].score_from=0;//max score from
			max_l[i].max[m].pos=-1;

		}
	}
*/
	/*
	for(i=0;i<lenb+1;i++){
		for(m=0;m<4;m++){
			printf("max_l%i:%i\n",i,max_l[i].max[m].score);
		}
	}*/
/*
	for(i=0;i<lenb+1;i++){

		for(m=0;m<x+1;m++){

			tmp_cell=&swmatrix[(i) * (lena + 1) + m];
			for(n=0;n<4;n++){
				if(max_l[i].max[n].score < tmp_cell->from[n].score_nw){
					max_l[i].max[n].score=tmp_cell->from[n].score_nw;
					switch(n){
					case 0:
						max_l[i].max[n].score_from=FROM_A_NORTHWEST_MAX_NORTHWEST;
						break;
					case 1:
						max_l[i].max[n].score_from=FROM_B_NORTHWEST_MAX_NORTHWEST;
						break;
					case 2:
						max_l[i].max[n].score_from=FROM_C_NORTHWEST_MAX_NORTHWEST;
						break;
					case 3:
						max_l[i].max[n].score_from=FROM_D_NORTHWEST_MAX_NORTHWEST;
						break;
					default:
						fprintf(stderr,"max_l internal error");
						break;
					}
					max_l[i].max[n].pos=m;

				}

			}
		}
	}

*/
	init_cell(lena/2);
	for (j = 1; j < lenb + 1; j++) {
		  //init_cell(j * (lena + 1));
		  int idx=j * (lena + 1)+lena/2;
		  	swmatrix[idx].from[0].score_n = -gap_open-j*gap_ext;
			swmatrix[idx].from[0].score_nw  = WORST_SCORE;
			swmatrix[idx].from[0].score_w  = WORST_SCORE;
			swmatrix[idx].from[1].score_n = -gap_open-j*gap_ext+xover_penalty;
			swmatrix[idx].from[1].score_nw  = WORST_SCORE ;
			swmatrix[idx].from[1].score_w  = WORST_SCORE ;
			swmatrix[idx].from[2].score_n = -gap_open-j*gap_ext+xover_penalty;
			swmatrix[idx].from[2].score_nw  = WORST_SCORE ;
			swmatrix[idx].from[2].score_w  = WORST_SCORE ;
			swmatrix[idx].from[3].score_n = -gap_open-j*gap_ext+xover_penalty;
			swmatrix[idx].from[3].score_nw  = WORST_SCORE;
			swmatrix[idx].from[3].score_w  = WORST_SCORE ;

			swmatrix[idx].from[0].back_nw = 0;
			swmatrix[idx].from[0].back_n  = FROM_A_NORTH_NORTH;
			swmatrix[idx].from[0].back_w  = 0;
			swmatrix[idx].from[0].back_nw_max = 0;
			swmatrix[idx].from[1].back_nw = 0;
			swmatrix[idx].from[1].back_n  = FROM_B_NORTH_NORTH;
			swmatrix[idx].from[1].back_w  = 0;
			swmatrix[idx].from[1].back_nw_max = 0;
			swmatrix[idx].from[2].back_nw = 0;
			swmatrix[idx].from[2].back_n  = FROM_C_NORTH_NORTH;
			swmatrix[idx].from[2].back_w  = 0;
			swmatrix[idx].from[2].back_nw_max = 0;
			swmatrix[idx].from[3].back_nw = 0;
			swmatrix[idx].from[3].back_n  = FROM_D_NORTH_NORTH;
			swmatrix[idx].from[3].back_w  = 0;
			swmatrix[idx].from[3].back_nw_max = 0;
	}
	/*j>x*/

	struct max_t max_w[4];
  	struct swcell *tmp_cell;
	for (i = 0; i < lenb; i++) {
	    /*
	     * computing row i of virtual matrix, stored in row i+1
	     */
		for(k=0;k<4;k++){
			max_w[k].score=WORST_SCORE;
			max_w[k].pos=-1;
		}
		for (j = x; j < lena; j++) {
	      /*
	       * computing column j of virtual matrix, stored in column j+1
	       */
	      struct swcell *cell_nw, *cell_n, *cell_w, *cell_cur;

	      cell_nw  = &swmatrix[i * (lena + 1) + j];
	      cell_n   = cell_nw + 1;
	      cell_w   = cell_nw + (lena + 1);
	      cell_cur = cell_w + 1;

	      tmp_cell=(&swmatrix[i * (lena + 1) + (j-x)]);
	      /* banding */
	      //if (i >= sw_band + j) {
	      //memset(cell_cur, 0, sizeof(*cell_cur));
	      //continue;
	      //}
	      //if (j >= ne_band + i) {
	      //memset(cell_cur, 0, sizeof(*cell_cur));
	      //break;
	      //}
	  for (k = 0; k < 4; k++) {

			if(tmp_cell->from[k].score_nw>=max_w[k].score){
				max_w[k].score=tmp_cell->from[k].score_nw;
				max_w[k].pos=j-x;

			}
	  }
	  for (k = 0; k < 4; k++) {
		 /*
		if(tmp_cell->from[k].score_nw>max_w[k].score){
			max_w[k].score=tmp_cell->from[k].score_nw;
			max_w[k].pos=j-x;

		}*/


		/*
		 * northwest
		 */
		ms = (db[j] == qr[k][i]) ? match : mismatch;
		//why treat revcmp different?
		if (!revcmpl) {
		  tmp  = cell_nw->from[k].score_nw + ms;
		  tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);

		  if (cell_nw->from[k].score_n + ms > tmp) {
		    tmp  = cell_nw->from[k].score_n + ms;
		    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
		  }

		  if (cell_nw->from[k].score_w + ms > tmp) {
		    tmp  = cell_nw->from[k].score_w + ms;
		    tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);
		  }
		  if (cell_nw->from[k].score_nw_max + ms > tmp) {
			tmp  = cell_nw->from[k].score_nw_max + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST_MAX);
		  }
		} else {
			tmp  = cell_nw->from[k].score_nw + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);

			if (cell_nw->from[k].score_n + ms > tmp) {
			tmp  = cell_nw->from[k].score_n + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
			}

			if (cell_nw->from[k].score_w + ms > tmp) {
			tmp  = cell_nw->from[k].score_w + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);
			}
			if (cell_nw->from[k].score_nw_max + ms > tmp) {
			tmp  = cell_nw->from[k].score_nw_max + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST_MAX);
			}
		}

		/* check neighbours */
		for (l = 0; l < 4; l++) {
		  if (l == k)
		    continue;

		  if (!revcmpl) {
		    /* northwest */
		    if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
		      tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
		      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
		    }

		    /* north */
		    if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
		      tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
		      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
		    }

		    /* west */
		    if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
		      tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
		      tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
		    }
		    /* northwest_max */
		    if (cell_nw->from[l].score_nw_max + ms + xover_penalty > tmp) {
			  tmp  = cell_nw->from[l].score_nw_max + ms + xover_penalty;
			  tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST_MAX);
			}
		  } else {
			/* northwest */
			if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
			}

			/* north */
			if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
			}

			/* west */
			if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
			}
			/* northwest_max */
			if (cell_nw->from[l].score_nw_max + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_nw_max + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST_MAX);
			}
		  }
		}


		cell_cur->from[k].score_nw = tmp;
		cell_cur->from[k].back_nw  = tmp2;

		/*
		 * northwest_max
		 */

		if (!revcmpl) {

			//tmp  = max_l[i].max[k].score + ms;
			tmp = max_w[k].score+ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_MAX_NORTHWEST);
			tmp_pos=max_w[k].pos;

		} else {

			//tmp  = max_l[i].max[k].score + ms;
			//tmp2 = FROM_x(k, FROM_NORTHWEST_MAX_NORTHWEST);

		}

		/* check neighbours */
		for (l = 0; l < 4; l++) {
		  if (l == k)
			continue;
		  if (!revcmpl) {
			if(max_w[l].score + ms + xover_penalty > tmp){
				tmp  = max_w[l].score + ms + xover_penalty;
				tmp2 = FROM_x(l, FROM_NORTHWEST_MAX_NORTHWEST);
				tmp_pos=max_w[l].pos;
			}

			//one read can't jump twice, so there is no northwest_max here.

		  } else {

		  }
		  /*
		  if (!revcmpl) {
			if(max_l[i].max[k].score + ms + xover_penalty > tmp){
				tmp  = max_l[i].max[k].score + ms + xover_penalty;
				tmp2 = FROM_x(l, FROM_NORTHWEST_MAX_NORTHWEST);
			}

			//one read can't jump twice, so there is no northwest_max here.

		  } else {
			if(max_l[i].max[k].score + ms + xover_penalty > tmp){
				tmp  = max_l[i].max[k].score + ms + xover_penalty;
				tmp2 = FROM_x(l, FROM_NORTHWEST_MAX_NORTHWEST);
			}
		  }*/
		}

		tmp+=3*(mismatch-match);//punish the big N-gap

		cell_cur->from[k].score_nw_max = tmp;
		cell_cur->from[k].back_nw_max  = tmp2;
		cell_cur->from[k].pos = tmp_pos;
		/*
		 * north
		 */
		if (!revcmpl) {
		  tmp  = cell_n->from[k].score_nw - go - ge;
		  tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST);

		  if (cell_n->from[k].score_n - ge > tmp) {
		    tmp  = cell_n->from[k].score_n - ge;
		    tmp2 = FROM_x(k, FROM_NORTH_NORTH);
		  }

		} else {

		}

		/* check neighbours */
		for (l = 0; l < 4; l++) {
			if (l == k)
			continue;

			if (!revcmpl) {
				/* northwest */
				if (cell_n->from[l].score_nw - go - ge + xover_penalty > tmp) {
				  tmp  = cell_n->from[l].score_nw - go - ge + xover_penalty;
				  tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST);
				}

				/* north */
				if (cell_n->from[l].score_n - ge + xover_penalty > tmp) {
				  tmp  = cell_n->from[l].score_n - ge + xover_penalty;
				  tmp2 = FROM_x(l, FROM_NORTH_NORTH);
				}

			} else {

		  }
		}


		cell_cur->from[k].score_n = tmp;
		cell_cur->from[k].back_n  = tmp2;

		/*
		 * west
		 */
		if (!revcmpl) {
			tmp  = cell_w->from[k].score_nw - go - ge;
			tmp2 = FROM_x(k, FROM_WEST_NORTHWEST);
			if (cell_w->from[k].score_w - ge > tmp) {
			tmp  = cell_w->from[k].score_w - ge;
			tmp2 = FROM_x(k, FROM_WEST_WEST);
			}

		} else {

		}

		/*
		 * NB: It doesn't make sense to cross over on a
		 *     genomic gap, so we won't.
		 */

		cell_cur->from[k].score_w = tmp;
		cell_cur->from[k].back_w  = tmp2;
		/*
		 * max score
		 */
		if(i==lenb-1){

		  if (cell_cur->from[k].score_nw > score) {
			score = cell_cur->from[k].score_nw;
			max_i = i, max_j = j, max_k = k;
		  }
		  if (cell_cur->from[k].score_n > score) {
			score = cell_cur->from[k].score_n;
			max_i = i, max_j = j, max_k = k;
		  }
		  if (cell_cur->from[k].score_w > score) {
			score = cell_cur->from[k].score_w;
			max_i = i, max_j = j, max_k = k;
		  }
		  if (cell_cur->from[k].score_nw_max > score) {
			  score = cell_cur->from[k].score_nw_max;
			  max_i = i, max_j = j, max_k = k;
		  }
		}
		/*
		if (!revcmpl) {
			if(i==lenb-1){

			  if (cell_cur->from[k].score_nw >= score) {
				score = cell_cur->from[k].score_nw;
				max_i = i, max_j = j, max_k = k;
			  }
			  if (cell_cur->from[k].score_n >= score) {
				score = cell_cur->from[k].score_n;
				max_i = i, max_j = j, max_k = k;
			  }
			  if (cell_cur->from[k].score_w >= score) {
				score = cell_cur->from[k].score_w;
				max_i = i, max_j = j, max_k = k;
			  }
			  if (cell_cur->from[k].score_nw_max >= score) {
				  score = cell_cur->from[k].score_nw_max;
				  max_i = i, max_j = j, max_k = k;
			  }
			}
		} else {
			if(i==lenb-1){

				if (cell_cur->from[k].score_nw >= score) {
					score = cell_cur->from[k].score_nw;
					max_i = i, max_j = j, max_k = k;
				}
				if (cell_cur->from[k].score_n >= score) {
					score = cell_cur->from[k].score_n;
					max_i = i, max_j = j, max_k = k;
				}
				if (cell_cur->from[k].score_w >= score) {
					score = cell_cur->from[k].score_w;
					max_i = i, max_j = j, max_k = k;
				}
				if (cell_cur->from[k].score_nw_max >= score) {
					score = cell_cur->from[k].score_nw_max;
					max_i = i, max_j = j, max_k = k;
				}
			}
		}*/

	#ifdef DEBUG_SW
		fprintf(stderr, "i:%d j:%d k:%d score_nw:%d [%u,%s] score_n:%d [%u,%s] score_w:%d [%u,%s] \n", i+1, j+1, k,
			cell_cur->from[k].score_nw, cell_cur->from[k].back_nw & 0x3,
			(cell_cur->from[k].back_nw >> 2 == 0 ? "!" :
			 (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTH ? "n" :
			  (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTHWEST ? "nw" : "w"))),

			cell_cur->from[k].score_n, cell_cur->from[k].back_n & 0x3,
			(cell_cur->from[k].back_n >> 2 == 0 ? "!" :
			 (cell_cur->from[k].back_n >> 2 == FROM_NORTH_NORTH ? "n" : "nw")),

			cell_cur->from[k].score_w, cell_cur->from[k].back_w & 0x3,
			(cell_cur->from[k].back_w >> 2 == 0 ? "!" :
			 (cell_cur->from[k].back_w >> 2 == FROM_WEST_NORTHWEST ? "nw" : "w")));
	#endif

	      }// k

	    }//j


	  }

#ifdef DEBUG_SW
  fprintf(stderr, "max_i:%d max_j:%d max_k:%d\n", max_i, max_j, max_k);
#endif
  printf("max:%i\t%i\t%i\t\n",max_i,max_j,max_k);
  *iret = lenb;//max_i;
  *jret = max_j;
  *kret = max_k;

  k=max_k;
  /*
  for(i=0;i<2*lenb+1;i++){
	  for(j=0;j<lena+1;j++){
		  printf("%i,%i:",i,j);
		  int score;
		  score=swmatrix[i * (lena + 1) + j].from[k].score_n;
		  if(score>-1000){
			  printf("%i,",score);
		  }else{
			  printf("%s,","**");
		  }
		  score=swmatrix[i * (lena + 1) + j].from[k].score_nw;
		  if(score>-1000){
			  printf("%i,",score);
		  }else{
			  printf("%s,","**");
		  }
		  score=swmatrix[i * (lena + 1) + j].from[k].score_w;
		  if(score>-1000){
			  printf("%i,",score);
		  }else{
			  printf("%s,","**");
		  }
		  score=swmatrix[i * (lena + 1) + j].from[k].score_nw_max;
		  if(score>-1000){
			  printf("%i\t",score);
		  }else{
			  printf("%s\t","**");
		  }
	  }
	  printf("\n");
  }
	*/
  /*
  for(i=0;i<(lena+1)*(lenb+1);i++){
	  for(j=0;j<4;j++){
		  printf("%i:%i,",i,swmatrix[i].from[j].score_nw);
		  printf("%i,",swmatrix[i].from[j].score_n);
		  printf("%i,",swmatrix[i].from[j].score_w);
		  printf("%i,",swmatrix[i].from[j].score_nw_max);

		  printf("\t");
	  }
	  if((i+1)%(lena+1)==0&&i>0){
		  printf("\n");
	  }
  }

  for(i=0;i<(lena+1)*(lenb+1);i++){
  	  for(j=0;j<4;j++){
  		  printf("%i:%i,",i,swmatrix[i].from[j].back_nw);
  		  printf("%i,",swmatrix[i].from[j].back_n);
  		  printf("%i,",swmatrix[i].from[j].back_w);
  		  printf("%i,",swmatrix[i].from[j].back_nw_max);

  		  printf("\t");
  	  }
  	  if((i+1)%(lena+1)==0&&i>0){
  		  printf("\n");
  	  }
    }
	*/
  return (score);
}
static int
split_sw_ins(int lena, int lenb, int *iret, int *jret,
	int *kret, bool revcmpl,int x)
{
  int i, j, k, l, max_i, max_j, max_k,idx;
  int score, ms, go, ge, tmp, tmp_pos, resetval;
  //int sw_band, ne_band;
  int8_t tmp2;
  int jump_len,split_penalty;

  split_penalty=split_penalty_ins;
  revcmpl=0;
  /* shut up gcc */
  max_i = max_j = max_k = j = 0;

  score = WORST_SCORE;
  go = gap_open;
  ge = gap_ext;

  /*initialize the matrix -infinity*/
  for(i=0;i<(lena+1)*(2*lenb+1);i++){
  	  swmatrix[i].from[0].score_n = WORST_SCORE;
  	  swmatrix[i].from[0].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[0].score_w  = WORST_SCORE;
  	  swmatrix[i].from[0].score_nw_max  = WORST_SCORE;
  	  swmatrix[i].from[1].score_n = WORST_SCORE;
  	  swmatrix[i].from[1].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[1].score_w  = WORST_SCORE;
  	  swmatrix[i].from[1].score_nw_max  = WORST_SCORE;
  	  swmatrix[i].from[2].score_n = WORST_SCORE;
  	  swmatrix[i].from[2].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[2].score_w  = WORST_SCORE;
  	  swmatrix[i].from[2].score_nw_max  = WORST_SCORE;
  	  swmatrix[i].from[3].score_n = WORST_SCORE;
  	  swmatrix[i].from[3].score_nw  = WORST_SCORE;
  	  swmatrix[i].from[3].score_w  = WORST_SCORE;
  	  swmatrix[i].from[3].score_nw_max  = WORST_SCORE;
  }

  init_cell(0);
  for (i = 1; i < lena + 1; i++) {
	  //init_cell(j);
	  	  idx=i;

		swmatrix[idx].from[0].score_w  = 0;
		swmatrix[idx].from[1].score_w  = xover_penalty;
		swmatrix[idx].from[2].score_w  = xover_penalty;
		swmatrix[idx].from[3].score_w  = xover_penalty;

		swmatrix[idx].from[0].back_nw = 0;
		swmatrix[idx].from[0].back_n  = 0;
		swmatrix[idx].from[0].back_w  = FROM_A_WEST_WEST;
		swmatrix[idx].from[0].back_nw_max = 0;
		swmatrix[idx].from[1].back_nw = 0;
		swmatrix[idx].from[1].back_n  = 0;
		swmatrix[idx].from[1].back_w  = FROM_B_WEST_WEST;
		swmatrix[idx].from[1].back_nw_max = 0;
		swmatrix[idx].from[2].back_nw = 0;
		swmatrix[idx].from[2].back_n  = 0;
		swmatrix[idx].from[2].back_w  = FROM_C_WEST_WEST;
		swmatrix[idx].from[2].back_nw_max = 0;
		swmatrix[idx].from[3].back_nw = 0;
		swmatrix[idx].from[3].back_n  = 0;
		swmatrix[idx].from[3].back_w  = FROM_D_WEST_WEST;
		swmatrix[idx].from[3].back_nw_max = 0;
  }

  for (j = 1; j < 2*lenb + 1; j++) {
	  //init_cell(j * (lena + 1));
	  int idx=j * (lena + 1);
	  	swmatrix[idx].from[0].score_n = -gap_open-j*gap_ext;
		swmatrix[idx].from[0].score_nw  = WORST_SCORE;
		swmatrix[idx].from[0].score_w  = WORST_SCORE;
		swmatrix[idx].from[1].score_n = -gap_open-j*gap_ext+xover_penalty;
		swmatrix[idx].from[1].score_nw  = WORST_SCORE ;
		swmatrix[idx].from[1].score_w  = WORST_SCORE ;
		swmatrix[idx].from[2].score_n = -gap_open-j*gap_ext+xover_penalty;
		swmatrix[idx].from[2].score_nw  = WORST_SCORE ;
		swmatrix[idx].from[2].score_w  = WORST_SCORE ;
		swmatrix[idx].from[3].score_n = -gap_open-j*gap_ext+xover_penalty;
		swmatrix[idx].from[3].score_nw  = WORST_SCORE;
		swmatrix[idx].from[3].score_w  = WORST_SCORE ;

		swmatrix[idx].from[0].back_nw = 0;
		swmatrix[idx].from[0].back_n  = FROM_A_NORTH_NORTH;
		swmatrix[idx].from[0].back_w  = 0;
		swmatrix[idx].from[0].back_nw_max = 0;
		swmatrix[idx].from[1].back_nw = 0;
		swmatrix[idx].from[1].back_n  = FROM_B_NORTH_NORTH;
		swmatrix[idx].from[1].back_w  = 0;
		swmatrix[idx].from[1].back_nw_max = 0;
		swmatrix[idx].from[2].back_nw = 0;
		swmatrix[idx].from[2].back_n  = FROM_C_NORTH_NORTH;
		swmatrix[idx].from[2].back_w  = 0;
		swmatrix[idx].from[2].back_nw_max = 0;
		swmatrix[idx].from[3].back_nw = 0;
		swmatrix[idx].from[3].back_n  = FROM_D_NORTH_NORTH;
		swmatrix[idx].from[3].back_w  = 0;
		swmatrix[idx].from[3].back_nw_max = 0;
  }
  /*
  for(i=0;i<2*lenb+1;i++){
    		  for(j=0;j<lena+1;j++){
    			  printf("%i,%i:",i,j);
    			  int score;
    			  score=swmatrix[i * (lena + 1) + j].from[0].score_n;
    			  if(score>-1000){
    				  printf("%i,",score);
    			  }else{
    				  printf("%s,","**");
    			  }
    			  score=swmatrix[i * (lena + 1) + j].from[0].score_nw;
    			  if(score>-1000){
    				  printf("%i,",score);
    			  }else{
    				  printf("%s,","**");
    			  }
    			  score=swmatrix[i * (lena + 1) + j].from[0].score_w;
    			  if(score>-1000){
    				  printf("%i,",score);
    			  }else{
    				  printf("%s,","**");
    			  }
    			  score=swmatrix[i * (lena + 1) + j].from[0].score_nw_max;
    			  if(score>-1000){
    				  printf("%i\t",score);
    			  }else{
    				  printf("%s\t","**");
    			  }
    		  }
    		  printf("\n");
    }*/


  /*
   * Figure out our band.
   *   We can actually skip computation of a significant number of
   *   cells, which could never be part of an alignment corresponding
   *   to our threshhold score.
   */
  //sw_band = ((lenb * match - threshscore + match - 1) / match) + 1;
  //ne_band = lena - (lenb - sw_band);

  for (i = 0; i < lenb; i++) {
    /*
     * computing row i of virtual matrix, stored in row i+1
     */


    for (j = 0; j < x; j++) {
      /*
       * computing column j of virtual matrix, stored in column j+1
       */
      struct swcell *cell_nw, *cell_n, *cell_w, *cell_cur;

      cell_nw  = &swmatrix[i * (lena + 1) + j];
      cell_n   = cell_nw + 1;
      cell_w   = cell_nw + (lena + 1);
      cell_cur = cell_w + 1;

      /* banding */
      //if (i >= sw_band + j) {
      //memset(cell_cur, 0, sizeof(*cell_cur));
      //continue;
      //}
      //if (j >= ne_band + i) {
      //memset(cell_cur, 0, sizeof(*cell_cur));
      //break;
      //}

      for (k = 0; k < 4; k++) {


	/*
	 * northwest
	 */
	ms = (db[j] == qr[k][i]) ? match : mismatch;

	if (!revcmpl) {
	  tmp  = cell_nw->from[k].score_nw + ms;
	  tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);

	  if (cell_nw->from[k].score_n + ms > tmp) {
	    tmp  = cell_nw->from[k].score_n + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
	  }

	  if (cell_nw->from[k].score_w + ms > tmp) {
	    tmp  = cell_nw->from[k].score_w + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);
	  }
	} else {
	  tmp  = cell_nw->from[k].score_w + ms;
	  tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);

	  if (cell_nw->from[k].score_n + ms > tmp) {
	    tmp  = cell_nw->from[k].score_n + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
	  }

	  if (cell_nw->from[k].score_nw + ms > tmp) {
	    tmp  = cell_nw->from[k].score_nw + ms;
	    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);
	  }
	}

	/* check neighbours */
	for (l = 0; l < 4; l++) {
	  if (l == k)
	    continue;

	  if (!revcmpl) {
	    /* northwest */
	    if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
	    }

	    /* north */
	    if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
	    }

	    /* west */
	    if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
	    }
	  } else {
	    /* west */
	    if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
	    }

	    /* north */
	    if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
	    }

	    /* northwest */
	    if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
	      tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
	    }
	  }
	}

	if (tmp <= resetval) {
	  //tmp = resetval;
	  //tmp2 = 0;
	}

	cell_cur->from[k].score_nw = tmp;
	cell_cur->from[k].back_nw  = tmp2;
	cell_cur->from[k].pos = -11;

	/*
	 * north
	 */
	if (!revcmpl) {
	  tmp  = cell_n->from[k].score_nw - go - ge;
	  tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST);

	  if (cell_n->from[k].score_n - ge > tmp) {
	    tmp  = cell_n->from[k].score_n - ge;
	    tmp2 = FROM_x(k, FROM_NORTH_NORTH);
	  }
	} else {
	  tmp  = cell_n->from[k].score_n - ge;
	  tmp2 = FROM_x(k, FROM_NORTH_NORTH);

	  if (cell_n->from[k].score_nw - go - ge > tmp) {
	    tmp  = cell_n->from[k].score_nw - go - ge;
	    tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST);
	  }
	}

	/* check neighbours */
	for (l = 0; l < 4; l++) {
	  if (l == k)
	    continue;

	  if (!revcmpl) {
	    /* northwest */
	    if (cell_n->from[l].score_nw - go - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_nw - go - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST);
	    }

	    /* north */
	    if (cell_n->from[l].score_n - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_n - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTH);
	    }
	  } else {
	    /* north */
	    if (cell_n->from[l].score_n - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_n - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTH);
	    }

	    /* northwest */
	    if (cell_n->from[l].score_nw - go - ge + xover_penalty > tmp) {
	      tmp  = cell_n->from[l].score_nw - go - ge + xover_penalty;
	      tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST);
	    }
	  }
	}

	if (tmp <= resetval) {
	  //tmp = resetval;
	  //tmp2 = 0;
	}

	cell_cur->from[k].score_n = tmp;
	cell_cur->from[k].back_n  = tmp2;
	cell_cur->from[k].pos = -11;

	/*
	 * west
	 */
	if (!revcmpl) {
	  tmp  = cell_w->from[k].score_nw - go - ge;
	  tmp2 = FROM_x(k, FROM_WEST_NORTHWEST);

	  if (cell_w->from[k].score_w - ge > tmp) {
	    tmp  = cell_w->from[k].score_w - ge;
	    tmp2 = FROM_x(k, FROM_WEST_WEST);
	  }
	} else {
	  tmp  = cell_w->from[k].score_w - ge;
	  tmp2 = FROM_x(k, FROM_WEST_WEST);

	  if (cell_w->from[k].score_nw - go - ge > tmp) {
	    tmp  = cell_w->from[k].score_nw - go - ge;
	    tmp2 = FROM_x(k, FROM_WEST_NORTHWEST);
	  }
	}

	/*
	 * NB: It doesn't make sense to cross over on a
	 *     genomic gap, so we won't.
	 */

	if (tmp <= resetval) {
	  //tmp = resetval;
	  //tmp2 = 0;
	}

	cell_cur->from[k].score_w = tmp;
	cell_cur->from[k].back_w  = tmp2;
	cell_cur->from[k].pos = -11;



#ifdef DEBUG_SW
	fprintf(stderr, "i:%d j:%d k:%d score_nw:%d [%u,%s] score_n:%d [%u,%s] score_w:%d [%u,%s] \n", i+1, j+1, k,
		cell_cur->from[k].score_nw, cell_cur->from[k].back_nw & 0x3,
		(cell_cur->from[k].back_nw >> 2 == 0 ? "!" :
		 (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTH ? "n" :
		  (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTHWEST ? "nw" : "w"))),

		cell_cur->from[k].score_n, cell_cur->from[k].back_n & 0x3,
		(cell_cur->from[k].back_n >> 2 == 0 ? "!" :
		 (cell_cur->from[k].back_n >> 2 == FROM_NORTH_NORTH ? "n" : "nw")),

		cell_cur->from[k].score_w, cell_cur->from[k].back_w & 0x3,
		(cell_cur->from[k].back_w >> 2 == 0 ? "!" :
		 (cell_cur->from[k].back_w >> 2 == FROM_WEST_NORTHWEST ? "nw" : "w")));
#endif

      }// l

    }//j


  }//i

  for (i = 0; i < lena + 1; i++) {
  	  //init_cell(j);
  	  	  idx=(lenb) * (lena + 1)+i;

  		swmatrix[idx].from[0].score_w  = 0;
  		swmatrix[idx].from[0].score_nw  = WORST_SCORE;
  		swmatrix[idx].from[0].score_n  = WORST_SCORE;
  		swmatrix[idx].from[0].score_nw_max  = WORST_SCORE;
  		swmatrix[idx].from[1].score_w  = xover_penalty;
  		swmatrix[idx].from[1].score_nw  = WORST_SCORE;
  		swmatrix[idx].from[1].score_n  = WORST_SCORE;
  		swmatrix[idx].from[1].score_nw_max  = WORST_SCORE;
  		swmatrix[idx].from[2].score_w  = xover_penalty;
		swmatrix[idx].from[2].score_nw  = WORST_SCORE;
		swmatrix[idx].from[2].score_n  = WORST_SCORE;
		swmatrix[idx].from[2].score_nw_max  = WORST_SCORE;
		swmatrix[idx].from[3].score_w  = xover_penalty;
		swmatrix[idx].from[3].score_nw  = WORST_SCORE;
		swmatrix[idx].from[3].score_n  = WORST_SCORE;
		swmatrix[idx].from[3].score_nw_max  = WORST_SCORE;

  		swmatrix[idx].from[0].back_nw = 0;
  		swmatrix[idx].from[0].back_n  = 0;
  		swmatrix[idx].from[0].back_w  = FROM_A_WEST_WEST;
  		swmatrix[idx].from[0].back_nw_max = 0;
  		swmatrix[idx].from[1].back_nw = 0;
  		swmatrix[idx].from[1].back_n  = 0;
  		swmatrix[idx].from[1].back_w  = FROM_B_WEST_WEST;
  		swmatrix[idx].from[1].back_nw_max = 0;
  		swmatrix[idx].from[2].back_nw = 0;
  		swmatrix[idx].from[2].back_n  = 0;
  		swmatrix[idx].from[2].back_w  = FROM_C_WEST_WEST;
  		swmatrix[idx].from[2].back_nw_max = 0;
  		swmatrix[idx].from[3].back_nw = 0;
  		swmatrix[idx].from[3].back_n  = 0;
  		swmatrix[idx].from[3].back_w  = FROM_D_WEST_WEST;
  		swmatrix[idx].from[3].back_nw_max = 0;
    }
	/*j>x*/

	struct max_t max_n[4];
	//for (i = lenb; i < 2*lenb; i++) {
	for (j = 0; j < lena; j++) {
	    /*
	     * computing row i of virtual matrix, stored in row i+1
	     */
		for(k=0;k<4;k++){
			max_n[k].score=WORST_SCORE;
			max_n[k].pos=0;
		}
		//for (j = 0; j < lena; j++) {
		for (i = lenb; i < 2*lenb; i++) {
	      /*
	       * computing column j of virtual matrix, stored in column j+1
	       */
	      struct swcell *cell_nw, *cell_n, *cell_w, *cell_cur;
	      struct swcell *tmp_cell;
	      cell_nw  = &swmatrix[i * (lena + 1) + j];
	      cell_n   = cell_nw + 1;
	      cell_w   = cell_nw + (lena + 1);
	      cell_cur = cell_w + 1;




	      /* banding */
	      //if (i >= sw_band + j) {
	      //memset(cell_cur, 0, sizeof(*cell_cur));
	      //continue;
	      //}
	      //if (j >= ne_band + i) {
	      //memset(cell_cur, 0, sizeof(*cell_cur));
	      //break;
	      //}
	  for (k = 0; k < 4; k++) {

		if(i>lenb+1){

			tmp_cell=(&swmatrix[(i-lenb-1) * (lena + 1) + j]);
			if(tmp_cell->from[k].score_nw>max_n[k].score){
				max_n[k].score=tmp_cell->from[k].score_nw;
				max_n[k].pos=i-lenb-1;
			}

		}


		/*
		 * northwest
		 */
		ms = (db[j] == qr[k][i]) ? match : mismatch;
		//why treat revcmp different?
		if (!revcmpl) {
		  tmp  = cell_nw->from[k].score_nw + ms;
		  tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);

		  if (cell_nw->from[k].score_n + ms > tmp) {
		    tmp  = cell_nw->from[k].score_n + ms;
		    tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
		  }

		  if (cell_nw->from[k].score_w + ms > tmp) {
		    tmp  = cell_nw->from[k].score_w + ms;
		    tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);
		  }
		  if (cell_nw->from[k].score_nw_max + ms > tmp) {
			tmp  = cell_nw->from[k].score_nw_max + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST_MAX);
		  }
		} else {
			tmp  = cell_nw->from[k].score_nw + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST);

			if (cell_nw->from[k].score_n + ms > tmp) {
			tmp  = cell_nw->from[k].score_n + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTH);
			}

			if (cell_nw->from[k].score_w + ms > tmp) {
			tmp  = cell_nw->from[k].score_w + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_WEST);
			}
			if (cell_nw->from[k].score_nw_max + ms > tmp) {
			tmp  = cell_nw->from[k].score_nw_max + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_NORTHWEST_MAX);
			}
		}

		/* check neighbours */
		for (l = 0; l < 4; l++) {
		  if (l == k)
		    continue;

		  if (!revcmpl) {
		    /* northwest */
		    if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
		      tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
		      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
		    }

		    /* north */
		    if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
		      tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
		      tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
		    }

		    /* west */
		    if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
		      tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
		      tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
		    }
		    /* northwest_max */
		    if (cell_nw->from[l].score_nw_max + ms + xover_penalty > tmp) {
			  tmp  = cell_nw->from[l].score_nw_max + ms + xover_penalty;
			  tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST_MAX);
			}
		  } else {
			/* northwest */
			if (cell_nw->from[l].score_nw + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_nw + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST);
			}

			/* north */
			if (cell_nw->from[l].score_n + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_n + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_NORTH);
			}

			/* west */
			if (cell_nw->from[l].score_w + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_w + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_WEST);
			}
			/* northwest_max */
			if (cell_nw->from[l].score_nw_max + ms + xover_penalty > tmp) {
			tmp  = cell_nw->from[l].score_nw_max + ms + xover_penalty;
			tmp2 = FROM_x(l, FROM_NORTHWEST_NORTHWEST_MAX);
			}
		  }
		}


		cell_cur->from[k].score_nw = tmp;
		cell_cur->from[k].back_nw  = tmp2;

		/*
		 * northwest_max
		 */

		if (!revcmpl) {

			//tmp  = max_l[i].max[k].score + ms;
			jump_len=i - lenb - max_n[k].pos;
			tmp  = max_n[k].score + ms + jump_len * (match - 3)+split_penalty;
			//tmp  = max_n[k].score + ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_MAX_NORTHWEST);
			tmp_pos=max_n[k].pos;
			/*tmp = max_n[k].score+ms;
			tmp2 = FROM_x(k, FROM_NORTHWEST_MAX_NORTHWEST);
			tmp_pos=max_n[k].pos;*/

		} else {

			//tmp  = max_l[i].max[k].score + ms;
			//tmp2 = FROM_x(k, FROM_NORTHWEST_MAX_NORTHWEST);

		}

		/* check neighbours */
		for (l = 0; l < 4; l++) {
		  if (l == k)
			continue;
		  if (!revcmpl) {
			if(max_n[l].score + ms + xover_penalty > tmp){
				//tmp  = max_n[l].score + ms + xover_penalty;
				
				jump_len=i - lenb - max_n[k].pos;
				tmp  = max_n[k].score + ms + jump_len * (match - 3)+split_penalty;
				tmp2 = FROM_x(l, FROM_NORTHWEST_MAX_NORTHWEST);
				tmp_pos=max_n[l].pos;
			}

			//one read can't jump twice, so there is no northwest_max here.

		  } else {

		  }
		  /*
		  if (!revcmpl) {
			if(max_l[i].max[k].score + ms + xover_penalty > tmp){
				tmp  = max_l[i].max[k].score + ms + xover_penalty;
				tmp2 = FROM_x(l, FROM_NORTHWEST_MAX_NORTHWEST);
			}

			//one read can't jump twice, so there is no northwest_max here.

		  } else {
			if(max_l[i].max[k].score + ms + xover_penalty > tmp){
				tmp  = max_l[i].max[k].score + ms + xover_penalty;
				tmp2 = FROM_x(l, FROM_NORTHWEST_MAX_NORTHWEST);
			}
		  }*/
		}

		//tmp+=3*(mismatch-match);//punish the big N-gap

		cell_cur->from[k].score_nw_max = tmp;
		cell_cur->from[k].back_nw_max  = tmp2;
		cell_cur->from[k].pos = tmp_pos;
		/*
		 * north
		 */
		if (!revcmpl) {
		  tmp  = cell_n->from[k].score_nw - go - ge;
		  tmp2 = FROM_x(k, FROM_NORTH_NORTHWEST);

		  if (cell_n->from[k].score_n - ge > tmp) {
		    tmp  = cell_n->from[k].score_n - ge;
		    tmp2 = FROM_x(k, FROM_NORTH_NORTH);
		  }

		} else {

		}

		/* check neighbours */
		for (l = 0; l < 4; l++) {
			if (l == k)
			continue;

			if (!revcmpl) {
				/* northwest */
				if (cell_n->from[l].score_nw - go - ge + xover_penalty > tmp) {
				  tmp  = cell_n->from[l].score_nw - go - ge + xover_penalty;
				  tmp2 = FROM_x(l, FROM_NORTH_NORTHWEST);
				}

				/* north */
				if (cell_n->from[l].score_n - ge + xover_penalty > tmp) {
				  tmp  = cell_n->from[l].score_n - ge + xover_penalty;
				  tmp2 = FROM_x(l, FROM_NORTH_NORTH);
				}

			} else {

		  }
		}


		cell_cur->from[k].score_n = tmp;
		cell_cur->from[k].back_n  = tmp2;

		/*
		 * west
		 */
		if (!revcmpl) {
			tmp  = cell_w->from[k].score_nw - go - ge;
			tmp2 = FROM_x(k, FROM_WEST_NORTHWEST);
			if (cell_w->from[k].score_w - ge > tmp) {
			tmp  = cell_w->from[k].score_w - ge;
			tmp2 = FROM_x(k, FROM_WEST_WEST);
			}

		} else {

		}

		/*
		 * NB: It doesn't make sense to cross over on a
		 *     genomic gap, so we won't.
		 */

		cell_cur->from[k].score_w = tmp;
		cell_cur->from[k].back_w  = tmp2;
		/*
		 * max score
		 */

		if(i==2*lenb-1){

		  if (cell_cur->from[k].score_nw >= score) {
			score = cell_cur->from[k].score_nw;
			max_i = i, max_j = j, max_k = k;
		  }
		  if (cell_cur->from[k].score_n >= score) {
			score = cell_cur->from[k].score_n;
			max_i = i, max_j = j, max_k = k;
		  }
		  if (cell_cur->from[k].score_w >= score) {
			score = cell_cur->from[k].score_w;
			max_i = i, max_j = j, max_k = k;
		  }
		  if (cell_cur->from[k].score_nw_max >= score) {
			  score = cell_cur->from[k].score_nw_max;
			  max_i = i, max_j = j, max_k = k;
		  }
		}
		/*
		if (!revcmpl) {
			if(i==lenb-1){

			  if (cell_cur->from[k].score_nw >= score) {
				score = cell_cur->from[k].score_nw;
				max_i = i, max_j = j, max_k = k;
			  }
			  if (cell_cur->from[k].score_n >= score) {
				score = cell_cur->from[k].score_n;
				max_i = i, max_j = j, max_k = k;
			  }
			  if (cell_cur->from[k].score_w >= score) {
				score = cell_cur->from[k].score_w;
				max_i = i, max_j = j, max_k = k;
			  }
			  if (cell_cur->from[k].score_nw_max >= score) {
				  score = cell_cur->from[k].score_nw_max;
				  max_i = i, max_j = j, max_k = k;
			  }
			}
		} else {
			if(i==lenb-1){

				if (cell_cur->from[k].score_nw >= score) {
					score = cell_cur->from[k].score_nw;
					max_i = i, max_j = j, max_k = k;
				}
				if (cell_cur->from[k].score_n >= score) {
					score = cell_cur->from[k].score_n;
					max_i = i, max_j = j, max_k = k;
				}
				if (cell_cur->from[k].score_w >= score) {
					score = cell_cur->from[k].score_w;
					max_i = i, max_j = j, max_k = k;
				}
				if (cell_cur->from[k].score_nw_max >= score) {
					score = cell_cur->from[k].score_nw_max;
					max_i = i, max_j = j, max_k = k;
				}
			}
		}*/

	#ifdef DEBUG_SW
		fprintf(stderr, "i:%d j:%d k:%d score_nw:%d [%u,%s] score_n:%d [%u,%s] score_w:%d [%u,%s] \n", i+1, j+1, k,
			cell_cur->from[k].score_nw, cell_cur->from[k].back_nw & 0x3,
			(cell_cur->from[k].back_nw >> 2 == 0 ? "!" :
			 (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTH ? "n" :
			  (cell_cur->from[k].back_nw >> 2 == FROM_NORTHWEST_NORTHWEST ? "nw" : "w"))),

			cell_cur->from[k].score_n, cell_cur->from[k].back_n & 0x3,
			(cell_cur->from[k].back_n >> 2 == 0 ? "!" :
			 (cell_cur->from[k].back_n >> 2 == FROM_NORTH_NORTH ? "n" : "nw")),

			cell_cur->from[k].score_w, cell_cur->from[k].back_w & 0x3,
			(cell_cur->from[k].back_w >> 2 == 0 ? "!" :
			 (cell_cur->from[k].back_w >> 2 == FROM_WEST_NORTHWEST ? "nw" : "w")));
	#endif

	      }// k

	    }//j


	  }

#ifdef DEBUG_SW
  fprintf(stderr, "max_i:%d max_j:%d max_k:%d\n", max_i, max_j, max_k);
#endif
  printf("max:%i\t%i\t%i\t\n",max_i,max_j,max_k);
  *iret = 2*lenb	;//max_i;
  *jret = max_j;
  *kret = max_k;

  k=0;
  /*
  for(i=0;i<2*lenb+1;i++){
	  for(j=0;j<lena+1;j++){
		  printf("%i,%i:",i,j);
		  int score;
		  score=swmatrix[i * (lena + 1) + j].from[k].score_n;
		  if(score>-1000){
			  printf("%i,",score);
		  }else{
			  printf("%s,","**");
		  }
		  score=swmatrix[i * (lena + 1) + j].from[k].score_nw;
		  if(score>-1000){
			  printf("%i,",score);
		  }else{
			  printf("%s,","**");
		  }
		  score=swmatrix[i * (lena + 1) + j].from[k].score_w;
		  if(score>-1000){
			  printf("%i,",score);
		  }else{
			  printf("%s,","**");
		  }
		  score=swmatrix[i * (lena + 1) + j].from[k].score_nw_max;
		  if(score>-1000){
			  printf("%i\t",score);
		  }else{
			  printf("%s\t","**");
		  }
	  }
	  printf("\n");
  }*/

  /*
  for(i=0;i<(lena+1)*(lenb+1);i++){
	  for(j=0;j<4;j++){
		  printf("%i:%i,",i,swmatrix[i].from[j].score_nw);
		  printf("%i,",swmatrix[i].from[j].score_n);
		  printf("%i,",swmatrix[i].from[j].score_w);
		  printf("%i,",swmatrix[i].from[j].score_nw_max);

		  printf("\t");
	  }
	  if((i+1)%(lena+1)==0&&i>0){
		  printf("\n");
	  }
  }
  for(i=0;i<(lena+1)*(lenb+1);i++){
  	  for(j=0;j<4;j++){
  		  printf("%i:%i,",i,swmatrix[i].from[j].back_nw);
  		  printf("%i,",swmatrix[i].from[j].back_n);
  		  printf("%i,",swmatrix[i].from[j].back_w);
  		  printf("%i,",swmatrix[i].from[j].back_nw_max);

  		  printf("\t");
  	  }
  	  if((i+1)%(lena+1)==0&&i>0){
  		  printf("\n");
  	  }
    }
	*/
  return (score);
}
static int
split_sw0(int lena, int lenb, int threshscore, int *iret, int *jret,
	int *kret, bool revcmpl,int x)
{}

/*
 * Fill in the backtrace in order to do a pretty printout.
 *
 * Returns the beginning matrix cell (i, j) in 'sfr->read_start' and
 * 'sfr->genome_start'.
 *
 * The return value is the first valid offset in the backtrace buffer.
 */

static int
do_backtrace_ins(int lena, int i, int j, int k, struct sw_full_results *sfr,int xy_gap_size)
{
  struct swcell *cell;
  int off, from, fromscore, pos, gap_len, ii;
  int lenb;
  gap_size=-1;
  off = (dblen + qrlen) - 1;
  lenb=i;

  printf("i:%i\tj:%i\tk:%i\n",i,j,k);
  //cell = &swmatrix[(i + 1) * (lena + 1) + j + 1];
  cell = &swmatrix[i * (lena + 1) + j];
  from = cell->from[k].back_nw;
  fromscore = cell->from[k].score_nw;
  if (cell->from[k].score_w > fromscore) {
	from = cell->from[k].back_w;
	fromscore = cell->from[k].score_w;
  }
  if (cell->from[k].score_n > fromscore){
	from = cell->from[k].back_n;
	fromscore = cell->from[k].score_n;
  }
  if (cell->from[k].score_nw_max > fromscore){
	  from = cell->from[k].back_nw_max;
  }
  if (from == 0) {
	int l, base;
	fprintf(stderr, "Assertion failed.\nQr:");
	for (l = 1, base = qr[0][0]; l < qrlen; l++) {
	  fprintf(stderr, "%d", lstocs(base, qr[0][l], false));
	  base = qr[0][l];
	}
	fprintf(stderr, "\n");
  }
  assert(from != 0);

  /* fill out the backtrace */
  while (i >= 0 && j >= 0) {
	assert(off >= 0);
	pos=cell->from[k].pos;
	//printf("%i,%i:%i\n",i,j,pos);
	//printf("%i,%i:%i,%i\n",i,j,cell->from[k].score_nw,cell->from[k].score_nw_max);
	cell = NULL;

	/* common operations first */
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_A_NORTH_NORTHWEST:
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_B_NORTH_NORTH:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_C_NORTH_NORTH:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_D_NORTH_NORTH:
	case FROM_D_NORTH_NORTHWEST:
	case FROM_D_NORTH_NORTHWEST_MAX:
	  sfr->deletions++;
	  sfr->read_start = i--;
	  break;

	case FROM_A_WEST_WEST:
	case FROM_A_WEST_NORTHWEST:
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_B_WEST_WEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_C_WEST_WEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_D_WEST_WEST:
	case FROM_D_WEST_NORTHWEST:
	case FROM_D_WEST_NORTHWEST_MAX:
	  sfr->insertions++;
	  sfr->genome_start = j--;
	  break;

	case FROM_A_NORTHWEST_NORTH:
	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_A_NORTHWEST_WEST:
	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_WEST:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
	  if (db[j] == qr[k][i])
		  sfr->matches++;
	  else
		  sfr->mismatches++;
	  sfr->read_start = i--;
	  sfr->genome_start = j--;
	  break;
	//case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	//case FROM_A_NORTHWEST_MAX_WEST:
	//case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	//case FROM_B_NORTHWEST_MAX_WEST:
	//case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	//case FROM_C_NORTHWEST_MAX_WEST:
	//case FROM_D_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	//case FROM_D_NORTHWEST_MAX_WEST:

	  if (db[j] == qr[k][i])
		  sfr->matches++;
	  else
		  sfr->mismatches++;


	  gap_size=i-pos-1;
	  gap_size+=xy_gap_size;
	  printf("i:%i\n",i);
	  printf("backtrace gap_size:%i\n",gap_size);
	  i=pos;
	  printf("jump==pos:%i\n",pos);
	  //sfr->read_start = i--;
	  sfr->genome_start = j--;
	  //sfr->genome_start = j;
	  break;
	default:
	  fprintf(stderr, "INTERNAL ERROR: from1 = %d\n", from);
	  assert(0);
	}

	/* handle match/mismatch and north */
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_A_NORTH_NORTHWEST:
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_B_NORTH_NORTH:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_C_NORTH_NORTH:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_D_NORTH_NORTH:
	case FROM_D_NORTH_NORTHWEST:
	case FROM_D_NORTH_NORTHWEST_MAX:
	  switch(k) {
	  case 0:
		backtrace[off]= BACK_A_DELETION;
		break;
	  case 1:
		backtrace[off]= BACK_B_DELETION;
		break;
	  case 2:
		backtrace[off]= BACK_C_DELETION;
		break;
	  case 3:
		backtrace[off]= BACK_D_DELETION;
		break;
	  default:
		fprintf(stderr, "INTERNAL ERROR: k = %d\n", k);
		assert(0);
	  }
	  break;

	case FROM_A_WEST_WEST:
	case FROM_A_WEST_NORTHWEST:
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_B_WEST_WEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_C_WEST_WEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_D_WEST_WEST:
	case FROM_D_WEST_NORTHWEST:
	case FROM_D_WEST_NORTHWEST_MAX:
	  /* doesn't make sense to cross over on a genomic gap */
	  backtrace[off] = BACK_INSERTION;
	  break;

	//case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	//case FROM_A_NORTHWEST_MAX_WEST:
	//case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	//case FROM_B_NORTHWEST_MAX_WEST:
	//case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	//case FROM_C_NORTHWEST_MAX_WEST:
	//case FROM_D_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	//case FROM_D_NORTHWEST_MAX_WEST:
	  printf("MAX off:%i\n",off);
	  switch(k) {
	  case 0:
		  backtrace[off]= BACK_A_MATCH_MISMATCH;
		  off--;
		  backtrace[off] =BACK_I_N;
		  break;
	  case 1:
		  backtrace[off]= BACK_B_MATCH_MISMATCH;
		  off--;
		  backtrace[off] =BACK_I_N;

		  break;
	  case 2:
		  backtrace[off]= BACK_C_MATCH_MISMATCH;
		  off--;
		  backtrace[off] =BACK_I_N;

		  break;
	  case 3:
		  backtrace[off]= BACK_D_MATCH_MISMATCH;
		  off--;
		  backtrace[off] =BACK_I_N;
		  /*for(ii=1;ii<gap_len;ii++){
			  backtrace[off] =BACK_N;
			  off--;
		  }*/
		  break;
	  default:
		  fprintf(stderr, "INTERNAL ERROR: k = %d\n", k);
		  assert(0);
	  }

	  break;

	case FROM_A_NORTHWEST_NORTH:
	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_A_NORTHWEST_WEST:
	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_WEST:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
		switch(k) {
		case 0:
			backtrace[off] = BACK_A_MATCH_MISMATCH;
			break;
		case 1:
			backtrace[off] = BACK_B_MATCH_MISMATCH;
			break;
		case 2:
			backtrace[off] = BACK_C_MATCH_MISMATCH;
			break;
		case 3:
			backtrace[off] = BACK_D_MATCH_MISMATCH;
			break;
		default:
			fprintf(stderr, "INTERNAL ERROR: k = %d\n", k);
			assert(0);
		}
		break;

	default:
		fprintf(stderr, "INTERNAL ERROR: from2 = %d\n", from);
		assert(0);
	}
	/* set k */
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_A_NORTH_NORTHWEST:
	case FROM_A_WEST_WEST:
	case FROM_A_WEST_NORTHWEST:
	case FROM_A_NORTHWEST_NORTH:
	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_A_NORTHWEST_WEST:
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	case FROM_A_NORTHWEST_MAX_WEST:
	if (k != 0) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 0;
	}
	break;

	case FROM_B_NORTH_NORTH:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_B_WEST_WEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	case FROM_B_NORTHWEST_MAX_WEST:
	  if (k != 1) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 1;
	  }
	  break;

	case FROM_C_NORTH_NORTH:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_C_WEST_WEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	case FROM_C_NORTHWEST_MAX_WEST:
	  if (k != 2) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 2;
	  }
	  break;

	case FROM_D_NORTH_NORTH:
	case FROM_D_NORTH_NORTHWEST:
	case FROM_D_WEST_WEST:
	case FROM_D_WEST_NORTHWEST:
	case FROM_D_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_WEST:
	case FROM_D_NORTH_NORTHWEST_MAX:
	case FROM_D_WEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	case FROM_D_NORTHWEST_MAX_WEST:
	  if (k != 3) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 3;
	  }
	  break;

	default:
	  fprintf(stderr, "INTERNAL ERROR: from3 = %d\n", from);
	  assert(0);
	}
	/*if(i==0){
		printf("i==0 break\n");
		off--;
		break;
	}*/
	if(i==0 || i==lenb/2){
		off--;
		break;
	}
	/*
	 * Continue backtrace (nb: i,j and k have already been changed).
	 */
	//cell = &swmatrix[(i + 1) * (lena + 1) + j + 1];

	cell = &swmatrix[i * (lena + 1) + j];
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_B_NORTH_NORTH:
	case FROM_C_NORTH_NORTH:
	case FROM_D_NORTH_NORTH:
	  from = cell->from[k].back_n;
	  break;

	case FROM_A_NORTH_NORTHWEST:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_D_NORTH_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_WEST_WEST:
	case FROM_B_WEST_WEST:
	case FROM_C_WEST_WEST:
	case FROM_D_WEST_WEST:
	  from = cell->from[k].back_w;
	  break;

	case FROM_A_WEST_NORTHWEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_D_WEST_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTH:
	  from = cell->from[k].back_n;
	  break;

	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_NORTHWEST_WEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_D_NORTHWEST_WEST:
	  from = cell->from[k].back_w;
	  break;

	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
	  from = cell->from[k].back_nw_max;
	  break;
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_D_NORTH_NORTHWEST_MAX:
	  from = cell->from[k].back_nw_max;
	  break;
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_D_WEST_NORTHWEST_MAX:

	  from = cell->from[k].back_nw_max;
	  break;
	case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTH:
	  from = cell->from[k].back_n;
	  break;

	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_NORTHWEST_MAX_WEST:
	case FROM_B_NORTHWEST_MAX_WEST:
	case FROM_C_NORTHWEST_MAX_WEST:
	case FROM_D_NORTHWEST_MAX_WEST:
	  from = cell->from[k].back_w;
	  break;
	default:
	  fprintf(stderr, "INTERNAL ERROR: from4 = %d\n", from);
	  assert(0);
	}
	off--;

	if (from == 0){
		printf("from break\n");
		printf("\ti:%i\tj:%i\n",i,j);
	  //break;
	}
  }// while

  off++;
  if (k != 0) {
	backtrace[off] |= BT_CROSSOVER;
	sfr->crossovers++;
  }
  return (off);
}
static int
do_backtrace(int lena, int i, int j, int k, struct sw_full_results *sfr,int xy_gap_size)
{
  struct swcell *cell;
  int off, from, fromscore, pos;
  gap_size=-1;
  off = (dblen + qrlen) - 1;
  printf("i:%i\tj:%i\tk:%i\n",i,j,k);
  //cell = &swmatrix[(i + 1) * (lena + 1) + j + 1];
  cell = &swmatrix[i * (lena + 1) + j];
  from = cell->from[k].back_nw;
  fromscore = cell->from[k].score_nw;
  if (cell->from[k].score_w > fromscore) {
	from = cell->from[k].back_w;
	fromscore = cell->from[k].score_w;
  }
  if (cell->from[k].score_n > fromscore){
	from = cell->from[k].back_n;
	fromscore = cell->from[k].score_n;
  }
  if (cell->from[k].score_nw_max > fromscore){
	  from = cell->from[k].back_nw_max;
  }
  if (from == 0) {
	int l, base;
	fprintf(stderr, "Assertion failed.\nQr:");
	for (l = 1, base = qr[0][0]; l < qrlen; l++) {
	  fprintf(stderr, "%d", lstocs(base, qr[0][l], false));
	  base = qr[0][l];
	}
	fprintf(stderr, "\n");
  }
  assert(from != 0);

  /* fill out the backtrace */
  while (i >= 0 && j >= 0) {
	assert(off >= 0);
	pos=cell->from[k].pos;

	//cell = &swmatrix[i * (lena + 1) + j];
	//printf("%i,%i,%i score nw:%i\tscore n:%i\tscore w:%i\tscore nw max:%i\n",i,j,k,cell->from[k].score_nw,cell->from[k].score_n,
	//		cell->from[k].score_w,cell->from[k].score_nw_max);

	cell = NULL;

	/* common operations first */
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_A_NORTH_NORTHWEST:
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_B_NORTH_NORTH:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_C_NORTH_NORTH:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_D_NORTH_NORTH:
	case FROM_D_NORTH_NORTHWEST:
	case FROM_D_NORTH_NORTHWEST_MAX:
	  sfr->deletions++;
	  sfr->read_start = i--;
	  break;

	case FROM_A_WEST_WEST:
	case FROM_A_WEST_NORTHWEST:
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_B_WEST_WEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_C_WEST_WEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_D_WEST_WEST:
	case FROM_D_WEST_NORTHWEST:
	case FROM_D_WEST_NORTHWEST_MAX:
	  sfr->insertions++;
	  sfr->genome_start = j--;
	  break;

	case FROM_A_NORTHWEST_NORTH:
	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_A_NORTHWEST_WEST:
	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_WEST:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
	  if (db[j] == qr[k][i])
		  sfr->matches++;
	  else
		  sfr->mismatches++;
	  sfr->read_start = i--;
	  sfr->genome_start = j--;
	  break;
	//case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	//case FROM_A_NORTHWEST_MAX_WEST:
	//case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	//case FROM_B_NORTHWEST_MAX_WEST:
	//case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	//case FROM_C_NORTHWEST_MAX_WEST:
	//case FROM_D_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	//case FROM_D_NORTHWEST_MAX_WEST:

	  if (db[j] == qr[k][i])
		  sfr->matches++;
	  else
		  sfr->mismatches++;


	  gap_size=j-pos-1;
	  gap_size+=xy_gap_size;
	  printf("j:%i\tpos:%i\txy gap size:%i\n",j,pos,xy_gap_size);

	  printf("backtrace gap_size:%i\n",gap_size);
	  j=pos;
	  printf("jump==pos:%i\n",pos);
	  sfr->read_start = i--;
	  //sfr->genome_start = j--;
	  sfr->genome_start = j;
	  break;
	default:
	  fprintf(stderr, "INTERNAL ERROR: from1 = %d\n", from);
	  assert(0);
	}

	/* handle match/mismatch and north */
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_A_NORTH_NORTHWEST:
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_B_NORTH_NORTH:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_C_NORTH_NORTH:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_D_NORTH_NORTH:
	case FROM_D_NORTH_NORTHWEST:
	case FROM_D_NORTH_NORTHWEST_MAX:
	  switch(k) {
	  case 0:
		backtrace[off]= BACK_A_DELETION;
		break;
	  case 1:
		backtrace[off]= BACK_B_DELETION;
		break;
	  case 2:
		backtrace[off]= BACK_C_DELETION;
		break;
	  case 3:
		backtrace[off]= BACK_D_DELETION;
		break;
	  default:
		fprintf(stderr, "INTERNAL ERROR: k = %d\n", k);
		assert(0);
	  }
	  break;

	case FROM_A_WEST_WEST:
	case FROM_A_WEST_NORTHWEST:
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_B_WEST_WEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_C_WEST_WEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_D_WEST_WEST:
	case FROM_D_WEST_NORTHWEST:
	case FROM_D_WEST_NORTHWEST_MAX:
	  /* doesn't make sense to cross over on a genomic gap */
	  backtrace[off] = BACK_INSERTION;
	  break;

	//case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	//case FROM_A_NORTHWEST_MAX_WEST:
	//case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	//case FROM_B_NORTHWEST_MAX_WEST:
	//case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	//case FROM_C_NORTHWEST_MAX_WEST:
	//case FROM_D_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	//case FROM_D_NORTHWEST_MAX_WEST:
	  printf("MAX off:%i\n",off);
	  switch(k) {
	  case 0:
		  backtrace[off]= BACK_A_MATCH_MISMATCH;
		  off--;
		  backtrace[off] =BACK_N;
		  break;
	  case 1:
		  backtrace[off]= BACK_B_MATCH_MISMATCH;
		  off--;
		  backtrace[off] =BACK_N;

		  break;
	  case 2:
		  backtrace[off]= BACK_C_MATCH_MISMATCH;
		  off--;
		  backtrace[off] =BACK_N;

		  break;
	  case 3:
		  backtrace[off]= BACK_D_MATCH_MISMATCH;
		  off--;
		  backtrace[off] =BACK_N;
		  /*for(ii=1;ii<gap_len;ii++){
			  backtrace[off] =BACK_N;
			  off--;
		  }*/
		  break;
	  default:
		  fprintf(stderr, "INTERNAL ERROR: k = %d\n", k);
		  assert(0);
	  }

	  break;

	case FROM_A_NORTHWEST_NORTH:
	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_A_NORTHWEST_WEST:
	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_WEST:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
		switch(k) {
		case 0:
			backtrace[off] = BACK_A_MATCH_MISMATCH;
			break;
		case 1:
			backtrace[off] = BACK_B_MATCH_MISMATCH;
			break;
		case 2:
			backtrace[off] = BACK_C_MATCH_MISMATCH;
			break;
		case 3:
			backtrace[off] = BACK_D_MATCH_MISMATCH;
			break;
		default:
			fprintf(stderr, "INTERNAL ERROR: k = %d\n", k);
			assert(0);
		}
		break;

	default:
		fprintf(stderr, "INTERNAL ERROR: from2 = %d\n", from);
		assert(0);
	}
	/* set k */
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_A_NORTH_NORTHWEST:
	case FROM_A_WEST_WEST:
	case FROM_A_WEST_NORTHWEST:
	case FROM_A_NORTHWEST_NORTH:
	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_A_NORTHWEST_WEST:
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	case FROM_A_NORTHWEST_MAX_WEST:
	  if (k != 0) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 0;
	  }
	  break;

	case FROM_B_NORTH_NORTH:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_B_WEST_WEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	case FROM_B_NORTHWEST_MAX_WEST:
	  if (k != 1) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 1;
	  }
	  break;

	case FROM_C_NORTH_NORTH:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_C_WEST_WEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	case FROM_C_NORTHWEST_MAX_WEST:
	  if (k != 2) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 2;
	  }
	  break;

	case FROM_D_NORTH_NORTH:
	case FROM_D_NORTH_NORTHWEST:
	case FROM_D_WEST_WEST:
	case FROM_D_WEST_NORTHWEST:
	case FROM_D_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_WEST:
	case FROM_D_NORTH_NORTHWEST_MAX:
	case FROM_D_WEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	case FROM_D_NORTHWEST_MAX_WEST:
	  if (k != 3) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 3;
	  }
	  break;

	default:
	  fprintf(stderr, "INTERNAL ERROR: from3 = %d\n", from);
	  assert(0);
	}
	if(i==0){
		printf("i==0 break\n");
		off--;
		break;
	}
	/*
	 * Continue backtrace (nb: i,j and k have already been changed).
	 */
	//cell = &swmatrix[(i + 1) * (lena + 1) + j + 1];

	cell = &swmatrix[i * (lena + 1) + j];
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_B_NORTH_NORTH:
	case FROM_C_NORTH_NORTH:
	case FROM_D_NORTH_NORTH:
	  from = cell->from[k].back_n;
	  break;

	case FROM_A_NORTH_NORTHWEST:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_D_NORTH_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_WEST_WEST:
	case FROM_B_WEST_WEST:
	case FROM_C_WEST_WEST:
	case FROM_D_WEST_WEST:
	  from = cell->from[k].back_w;
	  break;

	case FROM_A_WEST_NORTHWEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_D_WEST_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTH:
	  from = cell->from[k].back_n;
	  break;

	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_NORTHWEST_WEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_D_NORTHWEST_WEST:
	  from = cell->from[k].back_w;
	  break;

	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
	  from = cell->from[k].back_nw_max;
	  break;
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_D_NORTH_NORTHWEST_MAX:
	  from = cell->from[k].back_nw_max;
	  break;
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_D_WEST_NORTHWEST_MAX:

	  from = cell->from[k].back_nw_max;
	  break;
	case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTH:
	  from = cell->from[k].back_n;
	  break;

	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_NORTHWEST_MAX_WEST:
	case FROM_B_NORTHWEST_MAX_WEST:
	case FROM_C_NORTHWEST_MAX_WEST:
	case FROM_D_NORTHWEST_MAX_WEST:
	  from = cell->from[k].back_w;
	  break;
	default:
	  fprintf(stderr, "INTERNAL ERROR: from4 = %d\n", from);
	  assert(0);
	}
	off--;

	if (from == 0){
		printf("from break\n");
		printf("\ti:%i\tj:%i\n",i,j);
	  //break;
	}
  }// while

  off++;
  if (k != 0) {
	backtrace[off] |= BT_CROSSOVER;
	sfr->crossovers++;
  }
/*
  i=99;k=0;j=401;
  cell = &swmatrix[i * (lena + 1) + j];
  for(k=0;k<4;k++){
	  printf("%i,%i,%i score nw:%i\tscore n:%i\tscore w:%i\tscore nw max:%i\n",i,j,k,cell->from[k].score_nw,cell->from[k].score_n,
				cell->from[k].score_w,cell->from[k].score_nw_max);
  }
  i=99;k=0;j=402;
    cell = &swmatrix[i * (lena + 1) + j];
	for(k=0;k<4;k++){
	  printf("%i,%i,%i score nw:%i\tscore n:%i\tscore w:%i\tscore nw max:%i\n",i,j,k,cell->from[k].score_nw,cell->from[k].score_n,
				cell->from[k].score_w,cell->from[k].score_nw_max);
	}
  printf("off:%i\n",off);
*/
  return (off);
}

static int
do_backtrace0(int lena, int i, int j, int k, struct sw_full_results *sfr)
{
  struct swcell *cell;
  int off, from, fromscore, pos, gap_len, ii;

  off = (dblen + qrlen) - 1;

  //cell = &swmatrix[(i + 1) * (lena + 1) + j + 1];
  cell = &swmatrix[i * (lena + 1) + j];
  from = cell->from[k].back_nw;
  fromscore = cell->from[k].score_nw;
  if (cell->from[k].score_w > fromscore) {
	from = cell->from[k].back_w;
	fromscore = cell->from[k].score_w;
  }
  if (cell->from[k].score_n > fromscore){
	from = cell->from[k].back_n;
	fromscore = cell->from[k].score_n;
  }
  if (cell->from[k].score_nw_max > fromscore){
	  from = cell->from[k].back_nw_max;
  }
  if (from == 0) {
	int l, base;
	fprintf(stderr, "Assertion failed.\nQr:");
	for (l = 1, base = qr[0][0]; l < qrlen; l++) {
	  fprintf(stderr, "%d", lstocs(base, qr[0][l], false));
	  base = qr[0][l];
	}
	fprintf(stderr, "\n");
  }
  assert(from != 0);

  /* fill out the backtrace */
  while (i >= 0 && j >= 0) {
	assert(off >= 0);
	pos=cell->from[k].pos;
	cell = NULL;

	/* common operations first */
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_A_NORTH_NORTHWEST:
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_B_NORTH_NORTH:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_C_NORTH_NORTH:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_D_NORTH_NORTH:
	case FROM_D_NORTH_NORTHWEST:
	case FROM_D_NORTH_NORTHWEST_MAX:
	  sfr->deletions++;
	  sfr->read_start = i--;
	  break;

	case FROM_A_WEST_WEST:
	case FROM_A_WEST_NORTHWEST:
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_B_WEST_WEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_C_WEST_WEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_D_WEST_WEST:
	case FROM_D_WEST_NORTHWEST:
	case FROM_D_WEST_NORTHWEST_MAX:
	  sfr->insertions++;
	  sfr->genome_start = j--;
	  break;

	case FROM_A_NORTHWEST_NORTH:
	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_A_NORTHWEST_WEST:
	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_WEST:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
	  if (db[j] == qr[k][i])
		  sfr->matches++;
	  else
		  sfr->mismatches++;
	  sfr->read_start = i--;
	  sfr->genome_start = j--;
	  break;
	//case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	//case FROM_A_NORTHWEST_MAX_WEST:
	//case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	//case FROM_B_NORTHWEST_MAX_WEST:
	//case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	//case FROM_C_NORTHWEST_MAX_WEST:
	//case FROM_D_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	//case FROM_D_NORTHWEST_MAX_WEST:

	  if (db[j] == qr[k][i])
		  sfr->matches++;
	  else
		  sfr->mismatches++;


	  gap_len=j-pos;
	  j=pos;
	  printf("jump==pos:%i\n",pos);
	  sfr->read_start = i--;
	  //sfr->genome_start = j--;
	  sfr->genome_start = j;
	  break;
	default:
	  fprintf(stderr, "INTERNAL ERROR: from1 = %d\n", from);
	  assert(0);
	}

	/* handle match/mismatch and north */
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_A_NORTH_NORTHWEST:
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_B_NORTH_NORTH:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_C_NORTH_NORTH:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_D_NORTH_NORTH:
	case FROM_D_NORTH_NORTHWEST:
	case FROM_D_NORTH_NORTHWEST_MAX:
	  switch(k) {
	  case 0:
		backtrace[off]= BACK_A_DELETION;
		break;
	  case 1:
		backtrace[off]= BACK_B_DELETION;
		break;
	  case 2:
		backtrace[off]= BACK_C_DELETION;
		break;
	  case 3:
		backtrace[off]= BACK_D_DELETION;
		break;
	  default:
		fprintf(stderr, "INTERNAL ERROR: k = %d\n", k);
		assert(0);
	  }
	  break;

	case FROM_A_WEST_WEST:
	case FROM_A_WEST_NORTHWEST:
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_B_WEST_WEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_C_WEST_WEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_D_WEST_WEST:
	case FROM_D_WEST_NORTHWEST:
	case FROM_D_WEST_NORTHWEST_MAX:
	  /* doesn't make sense to cross over on a genomic gap */
	  backtrace[off] = BACK_INSERTION;
	  break;

	case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	case FROM_A_NORTHWEST_MAX_WEST:
	case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	case FROM_B_NORTHWEST_MAX_WEST:
	case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	case FROM_C_NORTHWEST_MAX_WEST:
	case FROM_D_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	case FROM_D_NORTHWEST_MAX_WEST:

	  switch(k) {
	  case 0:
		  backtrace[off]= BACK_A_MATCH_MISMATCH;
		  off--;

		  for(ii=1;ii<gap_len;ii++){
			  backtrace[off] =BACK_N;
			  off--;
		  }
		  break;
	  case 1:
		  backtrace[off]= BACK_B_MATCH_MISMATCH;
		  off--;

		  for(ii=1;ii<gap_len;ii++){
			  backtrace[off] =BACK_N;
			  off--;
		  }
		  break;
	  case 2:
		  backtrace[off]= BACK_C_MATCH_MISMATCH;
		  off--;

		  for(ii=1;ii<gap_len;ii++){
			  backtrace[off] =BACK_N;
			  off--;
		  }
		  break;
	  case 3:
		  backtrace[off]= BACK_D_MATCH_MISMATCH;
		  off--;

		  for(ii=1;ii<gap_len;ii++){
			  backtrace[off] =BACK_N;
			  off--;
		  }
		  break;
	  default:
		  fprintf(stderr, "INTERNAL ERROR: k = %d\n", k);
		  assert(0);
	  }
	  off++;
	  break;

	case FROM_A_NORTHWEST_NORTH:
	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_A_NORTHWEST_WEST:
	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_WEST:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
		switch(k) {
		case 0:
			backtrace[off] = BACK_A_MATCH_MISMATCH;
			break;
		case 1:
			backtrace[off] = BACK_B_MATCH_MISMATCH;
			break;
		case 2:
			backtrace[off] = BACK_C_MATCH_MISMATCH;
			break;
		case 3:
			backtrace[off] = BACK_D_MATCH_MISMATCH;
			break;
		default:
			fprintf(stderr, "INTERNAL ERROR: k = %d\n", k);
			assert(0);
		}
		break;

	default:
		fprintf(stderr, "INTERNAL ERROR: from2 = %d\n", from);
		assert(0);
	}
	/* set k */
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_A_NORTH_NORTHWEST:
	case FROM_A_WEST_WEST:
	case FROM_A_WEST_NORTHWEST:
	case FROM_A_NORTHWEST_NORTH:
	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_A_NORTHWEST_WEST:
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	case FROM_A_NORTHWEST_MAX_WEST:
	  if (k != 0) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 0;
	  }
	  break;

	case FROM_B_NORTH_NORTH:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_B_WEST_WEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	case FROM_B_NORTHWEST_MAX_WEST:
	  if (k != 1) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 1;
	  }
	  break;

	case FROM_C_NORTH_NORTH:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_C_WEST_WEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	case FROM_C_NORTHWEST_MAX_WEST:
	  if (k != 2) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 2;
	  }
	  break;

	case FROM_D_NORTH_NORTH:
	case FROM_D_NORTH_NORTHWEST:
	case FROM_D_WEST_WEST:
	case FROM_D_WEST_NORTHWEST:
	case FROM_D_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_WEST:
	case FROM_D_NORTH_NORTHWEST_MAX:
	case FROM_D_WEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	case FROM_D_NORTHWEST_MAX_WEST:
	  if (k != 3) {
		backtrace[off] |= BT_CROSSOVER;
		sfr->crossovers++;
		k = 3;
	  }
	  break;

	default:
	  fprintf(stderr, "INTERNAL ERROR: from3 = %d\n", from);
	  assert(0);
	}
	if(i==0){
		printf("i==0 break\n");
		off--;
		break;
	}
	/*
	 * Continue backtrace (nb: i,j and k have already been changed).
	 */
	//cell = &swmatrix[(i + 1) * (lena + 1) + j + 1];

	cell = &swmatrix[i * (lena + 1) + j];
	switch (from) {
	case FROM_A_NORTH_NORTH:
	case FROM_B_NORTH_NORTH:
	case FROM_C_NORTH_NORTH:
	case FROM_D_NORTH_NORTH:
	  from = cell->from[k].back_n;
	  break;

	case FROM_A_NORTH_NORTHWEST:
	case FROM_B_NORTH_NORTHWEST:
	case FROM_C_NORTH_NORTHWEST:
	case FROM_D_NORTH_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_WEST_WEST:
	case FROM_B_WEST_WEST:
	case FROM_C_WEST_WEST:
	case FROM_D_WEST_WEST:
	  from = cell->from[k].back_w;
	  break;

	case FROM_A_WEST_NORTHWEST:
	case FROM_B_WEST_NORTHWEST:
	case FROM_C_WEST_NORTHWEST:
	case FROM_D_WEST_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_NORTHWEST_NORTH:
	case FROM_B_NORTHWEST_NORTH:
	case FROM_C_NORTHWEST_NORTH:
	case FROM_D_NORTHWEST_NORTH:
	  from = cell->from[k].back_n;
	  break;

	case FROM_A_NORTHWEST_NORTHWEST:
	case FROM_B_NORTHWEST_NORTHWEST:
	case FROM_C_NORTHWEST_NORTHWEST:
	case FROM_D_NORTHWEST_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_NORTHWEST_WEST:
	case FROM_B_NORTHWEST_WEST:
	case FROM_C_NORTHWEST_WEST:
	case FROM_D_NORTHWEST_WEST:
	  from = cell->from[k].back_w;
	  break;

	case FROM_A_NORTHWEST_NORTHWEST_MAX:
	case FROM_B_NORTHWEST_NORTHWEST_MAX:
	case FROM_C_NORTHWEST_NORTHWEST_MAX:
	case FROM_D_NORTHWEST_NORTHWEST_MAX:
	  from = cell->from[k].back_nw_max;
	  break;
	case FROM_A_NORTH_NORTHWEST_MAX:
	case FROM_B_NORTH_NORTHWEST_MAX:
	case FROM_C_NORTH_NORTHWEST_MAX:
	case FROM_D_NORTH_NORTHWEST_MAX:
	  from = cell->from[k].back_nw_max;
	  break;
	case FROM_A_WEST_NORTHWEST_MAX:
	case FROM_B_WEST_NORTHWEST_MAX:
	case FROM_C_WEST_NORTHWEST_MAX:
	case FROM_D_WEST_NORTHWEST_MAX:

	  from = cell->from[k].back_nw_max;
	  break;
	case FROM_A_NORTHWEST_MAX_NORTH:
	case FROM_B_NORTHWEST_MAX_NORTH:
	case FROM_C_NORTHWEST_MAX_NORTH:
	case FROM_D_NORTHWEST_MAX_NORTH:
	  from = cell->from[k].back_n;
	  break;

	case FROM_A_NORTHWEST_MAX_NORTHWEST:
	case FROM_B_NORTHWEST_MAX_NORTHWEST:
	case FROM_C_NORTHWEST_MAX_NORTHWEST:
	case FROM_D_NORTHWEST_MAX_NORTHWEST:
	  from = cell->from[k].back_nw;
	  break;

	case FROM_A_NORTHWEST_MAX_WEST:
	case FROM_B_NORTHWEST_MAX_WEST:
	case FROM_C_NORTHWEST_MAX_WEST:
	case FROM_D_NORTHWEST_MAX_WEST:
	  from = cell->from[k].back_w;
	  break;
	default:
	  fprintf(stderr, "INTERNAL ERROR: from4 = %d\n", from);
	  assert(0);
	}
	off--;

	if (from == 0){
		printf("from break\n");
		printf("\ti:%i\tj:%i\n",i,j);
	  //break;
	}
  }// while

  off++;
  if (k != 0) {
	backtrace[off] |= BT_CROSSOVER;
	sfr->crossovers++;
  }
  return (off);
}

/*
 * Pretty print our alignment of 'db' and 'qr' in 'dbalign' and 'qralign'.
 *
 * i, j represent the beginning cell in the matrix.
 * k is the first valid offset in the backtrace buffer.
 */
static void
pretty_print(int i, int j, int k,  char* cigar, int x, int xy_gap_size, bool *is_split_align,int sv_type)
{

  char *d, *q, *q_s;
  int l, done,cur_from;
  //int gap_size;
  char tmp_cigar[1024];
  done = 0;
  *is_split_align=0;
  //char cigar[100];

  cigar[0]='\0';

  int tmp_back=-1;
  int n_m,n_d,n_i,n_n;//num for match/mismatch deletion insertion
  n_m=0;
  n_d=0;
  n_i=0;
  n_n=0;

  d = dbalign;
  q = qralign;
  q_s= qr_seq;
  printf("k:%i\tdblen+qrlen:%i\n",k,dblen+qrlen);
  for (l = k; l < (dblen + qrlen); l++) {

    switch (BT_TYPE(backtrace[l])) {

    case BACK_A_DELETION:
      //backtrace[l]=BACK_D;

      *d++ = '-';
      *q_s++ =  base_translate(qr[0][i], false);
      //cur_from=0;
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[0][i++], false));
      else
    	  *q++ = base_translate(qr[0][i++], false);
      //break;
      goto DEL;
    case BACK_B_DELETION:
      //backtrace[l]=BACK_D;
      *d++ = '-';
      *q_s++ = base_translate(qr[1][i], false);
      //cur_from=1;
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[1][i++], false));
      else
    	  *q++ = base_translate(qr[1][i++], false);
      goto DEL;
      //break;

    case BACK_C_DELETION:
      //backtrace[l]=BACK_D;
      *d++ = '-';
      *q_s++ = base_translate(qr[2][i], false);
      //cur_from=2;
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[2][i++], false));
      else
	*q++ = base_translate(qr[2][i++], false);
     // break;
      goto DEL;

    case BACK_D_DELETION:
      //backtrace[l]=BACK_D;
      *d++ = '-';
      *q_s++ = base_translate(qr[3][i], false);
      //cur_from=3;
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[3][i++], false));
      else
	*q++ = base_translate(qr[3][i++], false);
     // break;
      goto DEL;
DEL:
	if(sv_type==SMALL_INS){
		*is_split_align=1;
	}
    	n_d++;
		//n_left++;
		strcpy(tmp_cigar,cigar);
		if(tmp_back==BACK_D){

		}else{
			switch(tmp_back){
			case BACK_INSERTION:
				sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');
				n_i=0;
				break;
			case BACK_MM:
				sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
				n_m=0;
				break;
			case BACK_N:
				fprintf(stderr,"multi N regions in one backtrace.\n");
				exit(0);
			default:
				break;
			}

		}
		tmp_back= BACK_D;
		break;
    case BACK_INSERTION:
	if(sv_type==SMALL_DEL){
		*is_split_align=1;
	}
    	n_i++;
		strcpy(tmp_cigar,cigar);
		if(tmp_back==BACK_I){

		}else{
			if(tmp_back==BACK_D){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');
				n_d=0;
			}
			if(tmp_back== BACK_MM){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
				n_m=0;
			}
			if(tmp_back==BACK_N){
				fprintf(stderr,"multi N regions in one backtrace.\n");
				exit(0);
			}
		}
		tmp_back= BACK_I;

      *d++ = base_translate(db[j++], false);
      *q++ = '-';
      break;
    case BACK_I_N:
		*is_split_align=1;
		strcpy(tmp_cigar,cigar);
		if(tmp_back==BACK_MM){
			sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
		}else{
			if(tmp_back== BACK_INSERTION){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');

			}else if(tmp_back==BACK_D){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');

			}else{
				//cigar[0]='*';
				//cigar[1]='\0';
			}

		}

		strcpy(tmp_cigar,cigar);
		printf("ins gap_size:%i\n",gap_size);
		sprintf(cigar,"%s%i%c",tmp_cigar,gap_size,'I');
		
		if(n_m<ins_len_thresh){
			*is_split_align=0;
			return;
		}
		n_m=0;n_i=0;n_d=0;tmp_back=-1;
		//l--;//balance the l++ in for loop
		int m;
		for(m=0;m<gap_size;m++){
			*q_s++ = base_translate(qr[cur_from][i++], false);
		}
		*d++ = '-';
		*q++ = '*';
		break;
    case BACK_N:
    	strcpy(tmp_cigar,cigar);
		if(tmp_back==BACK_MM){
			sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
		}else{
			if(tmp_back== BACK_I){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');

			}else if(tmp_back==BACK_D){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');

			}else{
				//cigar[0]='*';
				//cigar[1]='\0';
			}

		}

		*is_split_align=1;
		strcpy(tmp_cigar,cigar);
		printf("print gap_size:%i\n",gap_size);
		sprintf(cigar,"%s%i%c",tmp_cigar,gap_size,'N');
		n_m=0;n_i=0;n_d=0;tmp_back=-1;


		//l--;//balance the l++ in for loop
		*d++ = base_translate(db[j++], false);
		*q++ = '*';
		break;

    case BACK_A_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;

      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[0][i], false);
      cur_from=0;
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[0][i++], false));
      else
    	  *q++ = base_translate(qr[0][i++], false);
      //break;
      goto MM;

    case BACK_B_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;
      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[1][i], false);
      cur_from=1;
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[1][i++], false));
      else
    	  *q++ = base_translate(qr[1][i++], false);
      //break;
      goto MM;

    case BACK_C_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;
      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[2][i], false);
      cur_from=2;
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[2][i++], false));
      else
    	  *q++ = base_translate(qr[2][i++], false);
      //break;
      goto MM;

    case BACK_D_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;
      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[3][i], false);
      cur_from=3;
      if (BT_ISCROSSOVER(backtrace[l]))
		*q++ = (char)tolower((int)base_translate(qr[3][i++], false));
      else
		*q++ = base_translate(qr[3][i++], false);
      //break;
      goto MM;
//    case BACK_MM:
MM:
    	n_m++;

		strcpy(tmp_cigar,cigar);
		if(tmp_back==BACK_MM){

		}else{
			if(tmp_back== BACK_I){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');
				n_i=0;
			}
			if(tmp_back==BACK_D){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');
				n_d=0;
			}
			if(tmp_back==BACK_N){
				fprintf(stderr,"multi N regions in one backtrace.\n");
				exit(0);
			}

		}
		tmp_back= BACK_MM;
        break;
    default:
    	fprintf(stderr, "INTERNAL ERROR: backtrace[l] = 0x%x\n", backtrace[l]);
    	assert(0);
    }
  }

  *d = *q = *q_s = '\0';
  strcpy(tmp_cigar,cigar);
  if(tmp_back==BACK_MM){
	  sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
  }else{
	  if(tmp_back== BACK_INSERTION){
		  sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');

	  }
	  if(tmp_back==BACK_D){
		  sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');

	  }
	  if(tmp_back==BACK_N){
		  fprintf(stderr,"multi N regions in one backtrace.\n");
		  exit(0);

	  }

  }
  if(n_m<ins_len_thresh){
	*is_split_align=0;
	return;
  }

  printf("db:%s\n",dbalign);
  printf("qr:%s\n",qralign);

}
static void
pretty_print_dup(int i, int j, int k,  char* cigar, int x, int a, int end_pos,struct sw_full_results *sfr,int rlen)
{

	char *d, *q, *q_s;
	int l, done;

	int head_i,head_d,head_m, total_i,total_d,total_m;
	char tmp_cigar[200];
	char tmp_cigar_N[100];
	char tmp_cigar_left[100];
	char tmp_cigar_right[100];
	int head_len=0,tail_len=0;
	int n_m,n_d,n_i;//num for match/mismatch deletion insertion
	int tmp_back=-1;

	n_m=0;
	n_d=0;
	n_i=0;
	done = 0;
	sfr->is_split_align=0;
	cigar[0]='\0';
	total_i=0;
	total_d=0;
	total_m=0;
	head_i=0;
	head_d=0;
	head_m=0;
	d = dbalign;
	q = qralign;
	q_s=qr_seq;
	printf("k:%i\tdblen+qrlen:%i\n",k,dblen+qrlen);
for (l = k; l < (dblen + qrlen); l++) {
    switch (BT_TYPE(backtrace[l])) {
    case BACK_A_DELETION:

      *d++ = '-';
      *q_s++ = base_translate(qr[0][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[0][i++], false));
      else
    	  *q++ = base_translate(qr[0][i++], false);
      //break;
      goto DEL;
    case BACK_B_DELETION:
      //backtrace[l]=BACK_D;
      *d++ = '-';
      *q_s++ = base_translate(qr[1][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[1][i++], false));
      else
    	  *q++ = base_translate(qr[1][i++], false);
      goto DEL;
      //break;

    case BACK_C_DELETION:
      //backtrace[l]=BACK_D;
      *d++ = '-';
      *q_s++ = base_translate(qr[2][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[2][i++], false));
      else
	*q++ = base_translate(qr[2][i++], false);
     // break;
      goto DEL;

    case BACK_D_DELETION:
      //backtrace[l]=BACK_D;
      *d++ = '-';
      *q_s++ = base_translate(qr[3][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[3][i++], false));
      else
	*q++ = base_translate(qr[3][i++], false);
     // break;
      goto DEL;
DEL:
    	total_i++;
	n_d++;
	//n_left++;
	strcpy(tmp_cigar,cigar);
	if(tmp_back==BACK_D){

	}else{
		switch(tmp_back){
		case BACK_INSERTION:
			sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');
			n_i=0;
			break;
		case BACK_MM:
			sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
			n_m=0;
			break;
		case BACK_N:
			fprintf(stderr,"multi N regions in one backtrace.\n");
			exit(0);
		default:
			break;
		}
	}
		tmp_back= BACK_D;
		break;
    case BACK_INSERTION:
    	total_d++;
	n_i++;
		strcpy(tmp_cigar,cigar);
		if(tmp_back==BACK_I){

		}else{
			if(tmp_back==BACK_D){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');
				n_d=0;
			}
			if(tmp_back== BACK_MM){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
				n_m=0;
			}
			if(tmp_back==BACK_N){
				fprintf(stderr,"multi N regions in one backtrace.\n");
				exit(0);
			}
		}
		tmp_back= BACK_I;

      *d++ = base_translate(db[j++], false);
      *q++ = '-';
      break;
    case BACK_N:
	printf("back N cigar:%s\n",cigar);
    	strcpy(tmp_cigar,cigar);
		if(tmp_back==BACK_MM){
			sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
		}else{
			if(tmp_back== BACK_I){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');

			}else if(tmp_back==BACK_D){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');

			}else{
				//cigar[0]='*';
				//cigar[1]='\0';
			}

		}
		printf("back N cigar:%s\n",cigar);
		strcpy(tmp_cigar_left,cigar);
		head_i=total_i;
		head_d=total_d;
		head_m=total_m;
		total_m=0;
		total_i=0;
		total_d=0;
		sfr->is_split_align=1;

		cigar[0]='\0';
		n_m=0;n_i=0;n_d=0;tmp_back=-1;
		*d++ = base_translate(db[j++], false);
		/*
		*is_split_align=1;
		strcpy(tmp_cigar,cigar);
		printf("print gap_size:%i\n",gap_size);
		sprintf(cigar,"%s%i%c",tmp_cigar,gap_size,'N');
		n_m=0;n_i=0;n_d=0;tmp_back=-1;


		//l--;//balance the l++ in for loop
		*d++ = base_translate(db[j++], false);
		*q++ = '*';*/
		break;

    case BACK_A_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;

      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[0][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[0][i++], false));
      else
    	  *q++ = base_translate(qr[0][i++], false);
      //break;
      goto MM;

    case BACK_B_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;
      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[1][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[1][i++], false));
      else
    	  *q++ = base_translate(qr[1][i++], false);
      //break;
      goto MM;

    case BACK_C_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;
      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[2][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[2][i++], false));
      else
    	  *q++ = base_translate(qr[2][i++], false);
      //break;
      goto MM;

    case BACK_D_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;
      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[3][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
		*q++ = (char)tolower((int)base_translate(qr[3][i++], false));
      else
		*q++ = base_translate(qr[3][i++], false);
      //break;
      goto MM;
//    case BACK_MM:
MM:
    	total_m++;
	n_m++;
		strcpy(tmp_cigar,cigar);
		if(tmp_back==BACK_MM){

		}else{
			if(tmp_back== BACK_I){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');
				n_i=0;
			}
			if(tmp_back==BACK_D){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');
				n_d=0;
			}
			if(tmp_back==BACK_N){
				fprintf(stderr,"multi N regions in one backtrace.\n");
				exit(0);
			}

		}
		tmp_back= BACK_MM;
        break;
    default:
    	fprintf(stderr, "INTERNAL ERROR: backtrace[l] = 0x%x\n", backtrace[l]);
    	assert(0);
    }
  }

  *d = *q = *q_s ='\0';
  strcpy(tmp_cigar,cigar);
  if(tmp_back==BACK_MM){
	  sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
  }else{
	  if(tmp_back== BACK_INSERTION){
		  sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');

	  }
	  if(tmp_back==BACK_D){
		  sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');

	  }
	  if(tmp_back==BACK_N){
		  fprintf(stderr,"multi N regions in one backtrace.\n");
		  exit(0);

	  }

  }
	head_len=head_m+head_i;
	tail_len=total_m+total_i;
	gap_size=a-2;
	sprintf(tmp_cigar_N,"%i%c",gap_size,'N');
	int m;
	for(m=0;m<tail_len;m++){
		sv_seq[m]=qr_seq[m+head_len];
	}
	for(m=tail_len;m<rlen;m++){
		sv_seq[m]=qr_seq[m-tail_len];
	}
	sv_seq[m]='\0';
	

	sfr->genome_start= end_pos - x -total_m-total_d+2;
	strcpy(tmp_cigar_right,cigar);
        sprintf(cigar,"%s%s%s",tmp_cigar_right,tmp_cigar_N,tmp_cigar_left);

  printf("db:%s\n",dbalign);
  printf("qr:%s\n",qralign);

}

static void
pretty_print_inv(int i, int j, int k,  char* cigar, int x, int inver_type, int end_pos,struct sw_full_results *sfr,int rlen,int xy_gap_size)
{

	char *d, *q, *q_s;
	int l, done;

	int head_i,head_d,head_m, total_i,total_d,total_m;
	char tmp_cigar[200];
	char tmp_cigar_N[100];
	char tmp_cigar_left[100];
	char tmp_cigar_right[100];
	int head_len=0,tail_len=0;
	int n_m,n_d,n_i;//num for match/mismatch deletion insertion
	int tmp_back=-1;

	n_m=0;
	n_d=0;
	n_i=0;
	done = 0;
	sfr->is_split_align=0;
	cigar[0]='\0';
	total_i=0;
	total_d=0;
	total_m=0;
	head_i=0;
	head_d=0;
	head_m=0;
	d = dbalign;
	q = qralign;
	q_s=qr_seq;
	printf("k:%i\tdblen+qrlen:%i\n",k,dblen+qrlen);
for (l = k; l < (dblen + qrlen); l++) {
    switch (BT_TYPE(backtrace[l])) {
    case BACK_A_DELETION:

      *d++ = '-';
      *q_s++ = base_translate(qr[0][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[0][i++], false));
      else
    	  *q++ = base_translate(qr[0][i++], false);
      //break;
      goto DEL;
    case BACK_B_DELETION:
      //backtrace[l]=BACK_D;
      *d++ = '-';
      *q_s++ = base_translate(qr[1][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[1][i++], false));
      else
    	  *q++ = base_translate(qr[1][i++], false);
      goto DEL;
      //break;

    case BACK_C_DELETION:
      //backtrace[l]=BACK_D;
      *d++ = '-';
      *q_s++ = base_translate(qr[2][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[2][i++], false));
      else
	*q++ = base_translate(qr[2][i++], false);
     // break;
      goto DEL;

    case BACK_D_DELETION:
      //backtrace[l]=BACK_D;
      *d++ = '-';
      *q_s++ = base_translate(qr[3][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[3][i++], false));
      else
	*q++ = base_translate(qr[3][i++], false);
     // break;
      goto DEL;
DEL:
    	total_i++;
	n_d++;
	//n_left++;
	strcpy(tmp_cigar,cigar);
	if(tmp_back==BACK_D){

	}else{
		switch(tmp_back){
		case BACK_INSERTION:
			sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');
			n_i=0;
			break;
		case BACK_MM:
			sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
			n_m=0;
			break;
		case BACK_N:
			fprintf(stderr,"multi N regions in one backtrace.\n");
			exit(0);
		default:
			break;
		}
	}
		tmp_back= BACK_D;
		break;
    case BACK_INSERTION:
    	total_d++;
	n_i++;
		strcpy(tmp_cigar,cigar);
		if(tmp_back==BACK_I){

		}else{
			if(tmp_back==BACK_D){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');
				n_d=0;
			}
			if(tmp_back== BACK_MM){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
				n_m=0;
			}
			if(tmp_back==BACK_N){
				fprintf(stderr,"multi N regions in one backtrace.\n");
				exit(0);
			}
		}
		tmp_back= BACK_I;

      *d++ = base_translate(db[j++], false);
      *q++ = '-';
      break;
    case BACK_N:
    	strcpy(tmp_cigar,cigar);
		if(tmp_back==BACK_MM){
			sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
		}else{
			if(tmp_back== BACK_I){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');

			}else if(tmp_back==BACK_D){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');

			}else{
				//cigar[0]='*';
				//cigar[1]='\0';
			}

		}
		strcpy(tmp_cigar_left,cigar);
		head_i=total_i;
		head_d=total_d;
		head_m=total_m;
		total_m=0;
		total_i=0;
		total_d=0;
		sfr->is_split_align=1;

		cigar[0]='\0';
		n_m=0;n_i=0;n_d=0;tmp_back=-1;
		*d++ = base_translate(db[j++], false);
		/*
		*is_split_align=1;
		strcpy(tmp_cigar,cigar);
		printf("print gap_size:%i\n",gap_size);
		sprintf(cigar,"%s%i%c",tmp_cigar,gap_size,'N');
		n_m=0;n_i=0;n_d=0;tmp_back=-1;


		//l--;//balance the l++ in for loop
		*d++ = base_translate(db[j++], false);
		*q++ = '*';*/
		break;

    case BACK_A_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;

      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[0][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[0][i++], false));
      else
    	  *q++ = base_translate(qr[0][i++], false);
      //break;
      goto MM;

    case BACK_B_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;
      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[1][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[1][i++], false));
      else
    	  *q++ = base_translate(qr[1][i++], false);
      //break;
      goto MM;

    case BACK_C_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;
      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[2][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
    	  *q++ = (char)tolower((int)base_translate(qr[2][i++], false));
      else
    	  *q++ = base_translate(qr[2][i++], false);
      //break;
      goto MM;

    case BACK_D_MATCH_MISMATCH:
      //backtrace[l]=BACK_MM;
      *d++ = base_translate(db[j++], false);
      *q_s++ = base_translate(qr[3][i], false);
      if (BT_ISCROSSOVER(backtrace[l]))
		*q++ = (char)tolower((int)base_translate(qr[3][i++], false));
      else
		*q++ = base_translate(qr[3][i++], false);
      //break;
      goto MM;
//    case BACK_MM:
MM:
    	total_m++;
	n_m++;
		strcpy(tmp_cigar,cigar);
		if(tmp_back==BACK_MM){

		}else{
			if(tmp_back== BACK_I){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');
				n_i=0;
			}
			if(tmp_back==BACK_D){
				sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');
				n_d=0;
			}
			if(tmp_back==BACK_N){
				fprintf(stderr,"multi N regions in one backtrace.\n");
				exit(0);
			}

		}
		tmp_back= BACK_MM;
        break;
    default:
    	fprintf(stderr, "INTERNAL ERROR: backtrace[l] = 0x%x\n", backtrace[l]);
    	assert(0);
    }
  }

  *d = *q = *q_s ='\0';
  strcpy(tmp_cigar,cigar);
  if(tmp_back==BACK_MM){
	  sprintf(cigar,"%s%i%c",tmp_cigar,n_m,'M');
  }else{
	  if(tmp_back== BACK_INSERTION){
		  sprintf(cigar,"%s%i%c",tmp_cigar,n_i,'D');

	  }
	  if(tmp_back==BACK_D){
		  sprintf(cigar,"%s%i%c",tmp_cigar,n_d,'I');

	  }
	  if(tmp_back==BACK_N){
		  fprintf(stderr,"multi N regions in one backtrace.\n");
		  exit(0);

	  }

  }
  head_len=head_m+head_i;
  tail_len=total_m+total_i;
  int m,a;
  char rcigar[100];
  memset(rcigar,0,100);
  switch(inver_type){
        case INVER_FW_OUT:
                a=x+2*x-end_pos- sfr->genome_start+xy_gap_size;

                gap_size=a-(head_m + head_d)+1;
                for(m=0;m<head_len;m++){
                        //qralign[m]=base_translate(qr[m], false);
			sv_seq[m]=qr_seq[m];
                }
                for(m=head_len;m<rlen;m++){
                        //qralign[m]=base_translate((3-qr[rlen-m+head_len-1]), false);
			sv_seq[m]=get_complement_base(qr_seq[rlen-m+head_len-1]);
                }

                reverse_cigar(cigar,tmp_cigar_right);
                sprintf(tmp_cigar_N,"%i%c",gap_size,'N');
                sprintf(cigar,"%s%s%s",tmp_cigar_left,tmp_cigar_N,tmp_cigar_right);
  		//printf("cigar l:%s\n",tmp_cigar_left);
  		//printf("cigar n:%s\n",tmp_cigar_N);
  		//printf("cigar r:%s\n",tmp_cigar_right);
  		//printf("cigar:%s\n",cigar);
                break;
        case INVER_FW_IN:
                a=end_pos-x+sfr->genome_start+xy_gap_size;

                gap_size=a-(total_m+total_d)-1;
                for(m=0;m<tail_len;m++){
                        //qralign[m]=base_translate((3-qr[rlen-m-1]), false);
			sv_seq[m]=get_complement_base(qr_seq[rlen-m-1]);
                }
                for(m=tail_len;m<rlen;m++){
                        //qralign[m]=base_translate(qr[m-tail_len], false);
			sv_seq[m]=qr_seq[m-tail_len];
                }
                sfr->genome_start=2*x - end_pos;

                reverse_cigar(cigar,tmp_cigar_right);

                sprintf(tmp_cigar_N,"%i%c",gap_size,'N');
                sprintf(cigar,"%s%s%s",tmp_cigar_right,tmp_cigar_N,tmp_cigar_left);

                break;
	case INVER_BW_IN:
                a=2*x-end_pos+x-sfr->genome_start+xy_gap_size;

                gap_size=a-(head_m+head_d)+1;
                for(m=0;m<tail_len;m++){
                        //qralign[m]=base_translate(qr[head_len+m], false);
			sv_seq[m]=qr_seq[head_len+m];
                }
                for(m=tail_len;m<rlen;m++){
                        //qralign[m]=base_translate((3-qr[head_len-(m-tail_len)-1]), false);
			sv_seq[m]=get_complement_base(qr_seq[head_len-(m-tail_len)-1]);
                }

                sfr->genome_start=end_pos-x-(total_m+total_d)+2;

                reverse_cigar(tmp_cigar_left,rcigar);
                strcpy(tmp_cigar_right,cigar);
                sprintf(tmp_cigar_N,"%i%c",gap_size,'N');
                sprintf(cigar,"%s%s%s",tmp_cigar_right,tmp_cigar_N,rcigar);

                break;
        case INVER_BW_OUT:
                a=sfr->genome_start+xy_gap_size+end_pos-x;

                gap_size=a-(total_m+total_d)-1;
                for(m=0;m<head_len;m++){
                        //qralign[m]=base_translate((3-qr[head_len-m-1]), false);
			sv_seq[m]=get_complement_base(qr_seq[head_len-m-1]);
                }
                for(m=head_len;m<rlen;m++){
                        //qralign[m]=base_translate(qr[m], false);
			sv_seq[m]=qr_seq[m];
                }

                sfr->genome_start=x-sfr->genome_start-(head_m+head_d)+2;
                reverse_cigar(tmp_cigar_left,rcigar);
                strcpy(tmp_cigar_right,cigar);
                sprintf(tmp_cigar_N,"%i%c",gap_size,'N');
                sprintf(cigar,"%s%s%s",rcigar,tmp_cigar_N,tmp_cigar_right);
                break;
	case SMALL_INVER_FW:
                a=sfr->genome_start+xy_gap_size+end_pos-x;

                gap_size=a-(total_m+total_d)-1;
                for(m=0;m<head_len;m++){
                	//qralign[m]=base_translate((3-qr[head_len-m-1]), false);
			sv_seq[m]=get_complement_base(qr_seq[head_len-m-1]);
                }
                for(m=head_len;m<rlen;m++){
                        //qralign[m]=base_translate(qr[m], false);
			sv_seq[m]=qr_seq[m];
                }

                sfr->genome_start=x-sfr->genome_start-(head_m+head_d)+2;
                reverse_cigar(tmp_cigar_left,rcigar);
                strcpy(tmp_cigar_right,cigar);
                sprintf(tmp_cigar_N,"%i%c",gap_size,'N');
                sprintf(cigar,"%s%s%s",rcigar,tmp_cigar_N,tmp_cigar_right);
                break;

        case SMALL_INVER_BW:
                a=x+2*x-end_pos- sfr->genome_start+xy_gap_size;

                gap_size=a-(head_m + head_d)+1;
                for(m=0;m<head_len;m++){
                        //qralign[m]=base_translate(qr[m], false);
			sv_seq[m]=qr_seq[m];
                }
                for(m=head_len;m<rlen;m++){
                        //qralign[m]=base_translate((3-qr[rlen-m+head_len-1]), false);
			sv_seq[m]=get_complement_base(qr_seq[rlen-m+head_len-1]);
                }

                reverse_cigar(cigar,tmp_cigar_right);
                sprintf(tmp_cigar_N,"%i%c",gap_size,'N');
                sprintf(cigar,"%s%s%s",tmp_cigar_left,tmp_cigar_N,tmp_cigar_right);
                break;

        default:
                abort();
        }
/*
	gap_size=a-2;
	sprintf(tmp_cigar_N,"%i%c",gap_size,'N');
	int m;
	for(m=0;m<tail_len;m++){
		sv_seq[m]=qr_seq[m+head_len];
	}
	for(m=tail_len;m<rlen;m++){
		sv_seq[m]=qr_seq[m-tail_len];
	}
	sv_seq[m]='\0';
	

	sfr->genome_start= end_pos - x -total_m-total_d+2;
	strcpy(tmp_cigar_right,cigar);
        sprintf(cigar,"%s%s%s",tmp_cigar_right,tmp_cigar_N,tmp_cigar_left);
*/
  printf("db:%s\n",dbalign);
  printf("qr:%s\n",qralign);

}
static void
pretty_print0(int i, int j, int k)
{

  char *d, *q;
  int l;

  d = dbalign;
  q = qralign;
  printf("k:%i\tdblen+qrlen:%i\n",k,dblen+qrlen);
  for (l = k; l < (dblen + qrlen); l++) {

    switch (BT_TYPE(backtrace[l])) {

    case BACK_A_DELETION:
      *d++ = '-';
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[0][i++], false));
      else
	*q++ = base_translate(qr[0][i++], false);
      break;

    case BACK_B_DELETION:
      *d++ = '-';
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[1][i++], false));
      else
	*q++ = base_translate(qr[1][i++], false);
      break;

    case BACK_C_DELETION:
      *d++ = '-';
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[2][i++], false));
      else
	*q++ = base_translate(qr[2][i++], false);
      break;

    case BACK_D_DELETION:
      *d++ = '-';
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[3][i++], false));
      else
	*q++ = base_translate(qr[3][i++], false);
      break;

    case BACK_INSERTION:
      *d++ = base_translate(db[j++], false);
      *q++ = '-';
      break;

    case BACK_A_MATCH_MISMATCH:
      *d++ = base_translate(db[j++], false);
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[0][i++], false));
      else
	*q++ = base_translate(qr[0][i++], false);
      break;

    case BACK_B_MATCH_MISMATCH:
      *d++ = base_translate(db[j++], false);
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[1][i++], false));
      else
	*q++ = base_translate(qr[1][i++], false);
      break;

    case BACK_C_MATCH_MISMATCH:
      *d++ = base_translate(db[j++], false);
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[2][i++], false));
      else
	*q++ = base_translate(qr[2][i++], false);
      break;

    case BACK_D_MATCH_MISMATCH:
      *d++ = base_translate(db[j++], false);
      if (BT_ISCROSSOVER(backtrace[l]))
	*q++ = (char)tolower((int)base_translate(qr[3][i++], false));
      else
	*q++ = base_translate(qr[3][i++], false);
      break;

    default:
      fprintf(stderr, "INTERNAL ERROR: backtrace[l] = 0x%x\n", backtrace[l]);
      assert(0);
    }
  }

  *d = *q = '\0';

  printf("%s\n",dbalign);
  printf("%s\n",qralign);

}

int
sw_split_cs_setup(int _dblen, int _qrlen, int _gap_open, int _gap_ext,int _match, int _mismatch, int _xover_penalty,
			int _split_penalty_ins, int _split_penalty_del_large, int _split_penalty_del_double)
{
  int i;

  dblen = _dblen;
  db = (int8_t *)malloc(dblen * sizeof(db[0]));
  if (db == NULL)
	return (1);

  qrlen = _qrlen;
  for (i = 0; i < 4; i++) {
    qr[i] = (int8_t *)malloc(qrlen * sizeof(qr[0]));
    if (qr[i] == NULL)
      return (2);
  }

  swmatrix = (struct swcell *)malloc((dblen + 1) * (qrlen + 1) *
				     sizeof(swmatrix[0]));
  if (swmatrix == NULL)
    return (3);

  backtrace = (uint8_t *)malloc((dblen + qrlen) * sizeof(backtrace[0]));
  if (backtrace == NULL)
    return (4);

  dbalign = (char *)malloc((dblen + qrlen + 1) * sizeof(dbalign[0]));
  if (dbalign == NULL)
    return (5);

  qralign = (char *)malloc((dblen + qrlen + 1) * sizeof(dbalign[0]));
  if (qralign == NULL)
    return (6);

  qr_seq = (char *)malloc((qrlen + 1) * sizeof(dbalign[0]));
  if (qr_seq == NULL)
    return (6);
  sv_seq = (char *)malloc((qrlen + 1) * sizeof(dbalign[0]));
  if (sv_seq == NULL)
    return (6);

  gap_open = -(_gap_open);
  gap_ext = -(_gap_ext);
  match = _match;
  mismatch = _mismatch;
  xover_penalty = _xover_penalty;
  //xover_penalty=-99;
  split_penalty_del_double=_split_penalty_del_double;
  split_penalty_del_large=_split_penalty_del_large;
  split_penalty_ins=_split_penalty_ins;
  ins_len_thresh=10;
  initialised = 1;

  return (0);
}

void
sw_split_cs(int8_t *genome_ls, int glen, uint32_t *read, int rlen, int initbp, int threshscore_ins,int threshscore_del,
			struct sw_full_results *sfr, bool revcmpl, int x, char* cigar, int xy_gap_size, int sv_type, int overlap_start)
{
	printf("x:%i\n",x);
	printf("xy_gap_size:%i\n",xy_gap_size);
	printf("gap_open:%i\tgap ext:%i\n",gap_open,gap_ext);
	struct sw_full_results scratch;
	int score_del=0,score_ins=0;
	llint before;
	int i, j, k;
	int is_rna=0;
	before = rdtsc();
	revcmpl=0;
	if (!initialised){
		fprintf(stderr,"not init.\n");
		abort();
	}

	swinvocs++;

	assert(glen > 0 && glen <= dblen);
	assert(rlen > 0 && rlen <= qrlen);


	//memset(sfr, 0, sizeof(*sfr));
	memset(backtrace, 0, (dblen + qrlen) * sizeof(backtrace[0]));

	dbalign[0] = qralign[0] = '\0';
	/*
	for (i = 0; i < glen; i++){
	db[i] = (int8_t)EXTRACT(genome_ls, goff + i);

	}*/
	db=genome_ls;

	/*
	* Generate each possible letter space sequence from the colour space
	* read. qr[0] corresponds to initbp, which is given initial preference.
	*/
	assert(initbp >= 0 && initbp <= 3);
	
	for (i = 0; i < 4; i++) {
		int letter = (i + initbp) % 4;

		for (j = 0; j < rlen; j++) {
		  int base = EXTRACT(read, j);
		  //printf("%i",base);

		  if (base == BASE_N || base == BASE_X) {
			qr[i][j] = BASE_N;
			letter = (i + initbp) % 4;
		  } else {
			qr[i][j] = (int8_t)cstols(letter, base, is_rna);
			letter = qr[i][j];
		  }
		  //printf("%i",qr[i][j]);
		  //printf("%c",(char)tolower((int)base_translate(qr[i][j], false)));
		}
		//printf("\n");

	}
	sfr->is_split_align =0 ;
	sfr->multi_aln=0;
	sfr->qralign=NULL;
	sfr->score=WORST_SCORE;
	printf("x00:%i\n",sfr->multi_aln);
	printf("glen:%i\trlen:%i\n",glen,rlen);
	printf("sv type:%i\n",sv_type);
	printf("thresh ins:%i\tthresh del:%i\n",threshscore_ins,threshscore_del);
	switch(sv_type){
	 case SMALL_DEL:
		printf("==============short DELetion==================\n");
                score_del = split_sw_del_double(glen, rlen, &i, &j, &k, revcmpl, x);

                printf("score_del:%i\n",score_del);
                if ( score_del > threshscore_del) {
                        k = do_backtrace(glen, i, j+1, k, sfr,xy_gap_size);
                        pretty_print(sfr->read_start-1, sfr->genome_start-1, k, cigar, x-sfr->genome_start+1, xy_gap_size, &sfr->is_split_align,sv_type);
                        sfr->score=score_del;
                        sfr->type=sv_type;
			sfr->qralign=qr_seq;


                }
                break;
	case SMALL_INS://ins
		printf("==============short INSertion==================\n");
		glen/=2;
                for (i = 0; i < 4; i++) {
                        for (j = rlen; j < 2*rlen+1; j++){
                          qr[i][j] = qr[i][j-rlen];

                        }
                }
                //memset(backtrace, 0, (dblen + qrlen) * sizeof(backtrace[0]));
                printf("glen:%i\trlen:%i\n",glen,rlen);
                score_ins = split_sw_ins(glen, rlen, &i, &j, &k, revcmpl, x);
                printf("ins score :%i\n",score_ins);
                if(score_ins > threshscore_ins){
			sfr->score=score_ins;
			gap_size=0;
                        xy_gap_size=-1*rlen;
                        k = do_backtrace_ins(glen, i, j+1, k, sfr,xy_gap_size);
                        if(score_ins>threshscore_ins){

                                //pretty_print(sfr->read_start-1, sfr->genome_start-1, k, cigar, x-sfr->genome_start+1, xy_gap_size, &sfr->is_split_align);
                                pretty_print(sfr->read_start-1, sfr->genome_start-1, k, cigar, x-sfr->genome_start+1, xy_gap_size, &sfr->is_split_align,sv_type);
                                sfr->score=score_ins;
				sfr->type=sv_type;
				sfr->qralign=qr_seq;
                        }else{
                                sfr->is_split_align=0;
                        }

                        //pretty_print(sfr->read_start-1, sfr->genome_start-1, k);

                }

		break;
	case LARGE_DEL://del
		printf("==============cluster DELetion==================\n");
		score_del = split_sw_del(glen, rlen, &i, &j, &k, revcmpl, x, overlap_start);
		if(score_del>threshscore_del){
                        k = do_backtrace(glen, i, j+1, k, sfr,xy_gap_size);
			pretty_print(sfr->read_start-1, sfr->genome_start-1, k, cigar, x-sfr->genome_start+1, xy_gap_size, &sfr->is_split_align,sv_type);
			printf("genome start:%i\tread start:%i\n", sfr->genome_start, sfr->read_start);
			sfr->score=score_del;
			sfr->type=sv_type;
			sfr->qralign=qr_seq;
		}else{
			sfr->is_split_align=0;
		}
		break;
	/*inver*/
        case INVER_FW_OUT:
        case SMALL_INVER_BW:
        case INVER_FW_IN:
        case INVER_BW_IN:
        case INVER_BW_OUT:
        case SMALL_INVER_FW:
                int inver_type;

                inver_type=sv_type;

                switch(inver_type){
                case INVER_FW_OUT:
                case SMALL_INVER_BW:
                        revcmpl=0;
                        break;
                case INVER_FW_IN:
                        revcmpl=1;
                        break;
                case INVER_BW_IN:
                        revcmpl=0;
                        break;
                case INVER_BW_OUT:
                case SMALL_INVER_FW:
                        revcmpl=1;
                        break;
                default:
                        fprintf(stderr,"invalid inver type: %i\n",inver_type);
                        abort();
                }
                score_del = split_sw_del(glen, rlen, &i, &j, &k, revcmpl, x, overlap_start);
                if(score_del>threshscore_del){
                        sfr->score=score_del;
                        k = do_backtrace(glen, i, j+1, k, sfr,xy_gap_size);
                        pretty_print_inv(sfr->read_start-1, sfr->genome_start-1, k, cigar, x, inver_type, j, sfr, rlen, xy_gap_size);
                        sfr->qralign = qralign;
                        sfr->type=sv_type;
                        if (gap_size<=0){
                                sfr->is_split_align=0;
                        }else{

                        }
                }else{
                        //sfr->type=NOT_PRINT;
                }
                break;
	case DUP://dup
		printf("==============DUPlication==================\n");
                score_del = split_sw_del(glen, rlen, &i, &j, &k, revcmpl, x, overlap_start);
                if(score_del>threshscore_del){
                        k = do_backtrace(glen, i, j+1, k, sfr,xy_gap_size);
			int a;//
			a=2*x-j + sfr->genome_start+xy_gap_size;
                        pretty_print_dup(sfr->read_start-1, sfr->genome_start-1, k, cigar, x, a,j, sfr, rlen);
                        printf("genome start:%i\tread start:%i\n", sfr->genome_start, sfr->read_start);
                        sfr->score=score_del;
			sfr->qralign = sv_seq;
                        sfr->type=sv_type;

                }else{
                        //sfr->is_split_align=0;
                }
                break;

	default:
		printf("type %i not supported.\n",sv_type);
		break;
	}
	swticks += (rdtsc() - before);
}

